#include <stdio.h>
#include <string.h>

#define NMAX 25
#define INF 6666

long A[NMAX][NMAX];
long x[NMAX * NMAX], p;
int right[NMAX][NMAX], max[NMAX * NMAX][NMAX];

int i, j, k, M, N, X, li, ls, nl, min, maxx;

int poz(long v)
{
  int li, ls, m, po;

  po = 0;
  li = 1;
  ls = X;

  while (li <= ls)
  {
    m = (li + ls) >> 1;

    if (x[m] == v)
    {
      po = m;
      break;
    }
    else
    if (x[m] < v)
       li = m + 1;
    else
        ls = m - 1;
  }

  return po;
}

int main()
{
  freopen("INPUT.TXT", "r", stdin);

  scanf("%d %d", &M, &N);
  for (X = 0, i = 1; i <= M; i++)
    for (j = 1; j <= N; j++)
    {
      scanf("%ld", &A[i][j]);
      x[++X] = A[i][j];
    }

  /* sorteaza vectorul 'x' */
  for (i = 1; i < X; i++)
      for (j = i + 1; j <= X; j++)
          if (x[i] > x[j])
          {
            p = x[i];
            x[i] = x[j];
            x[j] = p;
          }

  X = 1;
  for (i = 2; i <= M * N; i++)
      if (x[i] > x[i - 1])
         x[++X] = x[i];

  for (i = 1; i <= M; i++)
  {
      right[i][N] = 1;

      for (j = N - 1; j >= 1; j--)
          if (A[i][j] == A[i][j+1])
             right[i][j] = 1 + right[i][j+1];
          else
              right[i][j] = 1;
  }

  memset(max, 0, sizeof(max));

  for (nl = 1; nl <= M; nl++)
      for (j = 1; j <= N; j++)
      {
        li = 1;
        while (li <= M)
        {
          i = li;
          while (i <= M && A[i][j] == A[li][j])
              i++;
          ls = --i;

          if (ls - li + 1 >= nl) /* verifica intervalul (li, ls) */
          {
            maxx = 0;
            for (i = li; i <= ls - nl + 1; i++)
            {
              min = INF;
              for (k = i; k <= i + nl - 1; k++)
                  if (right[k][j] < min)
                     min = right[k][j];

              if (min > maxx)
                 maxx = min;
            }

            i = poz(A[li][j]);
            if (maxx > max[i][nl])
               max[i][nl] = maxx;
          }

          li = ls + 1;
        }
      }

  freopen("OUTPUT.TXT", "w", stdout);

  scanf("%d", &nl);
  for (k = 1; k <= nl; k++)
  {
    scanf("%d %d %ld", &i, &j, &p);

    li = poz(p);

    if (!li)
       printf("Parcela inexistenta!\n");
    else
    {
      if (i < 0 || i > M || max[li][i] < j)
         printf("Dimensiuni eronate!\n");
      else
          printf("Corect!\n");
    }
  }

  return 0;
}