#include <fstream.h>
#include <math.h>

#define filein "conducte.in"
#define fileout "conducte.out"
#define maxk 15
#define maxn 1005
#define rkezd 10000

struct ponttype {
  int x, y;
};

void kezdoertek();
void megold();
void kiir();

int k, n;
ponttype r[maxk], b[maxn];
double minut[maxn];
int honnan[maxn];
int megvan[maxn];

int main() {
  kezdoertek();
  megold();
  kiir();
  return 0;
}

double tav(ponttype p1, ponttype p2) {
  return sqrt((double)((p1).x-(p2).x)*((p1).x-(p2).x)+
              ((double)((p1).y-(p2).y))*((p1).y-(p2).y));
}



void megold() {
  int q, w, cs;
  double akttav;

  for (q=0; q<n; q++) {
    minut[q]=tav(r[0], b[q]);
    honnan[q]=rkezd;
    for (w=1; w<k; w++) {
      akttav=tav(r[w], b[q]);
      if (akttav<minut[q]) {
        minut[q]=akttav;
        honnan[q]=rkezd+w;
      }
    }
  }

  for (q=0; q<n; q++) {
    for (cs=0; megvan[cs]; cs++);
    for (w=cs+1; w<n; w++)
      if (minut[w]<minut[cs]) cs=w;

    megvan[cs]=1;
    for (w=0; w<n; w++)
      if (!megvan[w] && tav(b[cs], b[w])<minut[w]) {
        minut[w]=tav(b[cs], b[w]);
        honnan[w]=cs;
      }
  }
}

void kiir() {
  ofstream fout(fileout);
  int q;


  for (q=0; q<n; q++) {
    fout << 'B' << (q+1) << ' ';
    if (rkezd<=honnan[q]) {
      fout << 'R' << (honnan[q]-rkezd+1) << endl;
    } else {
      fout << 'B' << (honnan[q]+1) << endl;
    }
  }

  fout.close();
}

void kezdoertek() {
  int q;
  ifstream fin(filein);

  fin >> k >> n;

  for (q=0; q<k; q++) fin >> r[q].x >> r[q].y;
  for (q=0; q<n; q++) fin >> b[q].x >> b[q].y;

  fin.close();
}