{$S-,I-,R-,Q-,N+}
{$M 30000,0,655360}
Program SAM;

const filein='SAM.IN';
      fileout='SAM.OUT';
      start='VALCEAUADESPICATA';
      finish='MUNTELEOSANDEI';
      MAXN=110;

type plist=^list;
     list=record
            index:integer;
            urm:plist;
          end;

var nume:array[1..MAXN] of string;
    muc:array[1..MAXN] of plist;
    degin,order,marc:array[1..MAXN] of integer;
    mat:array[1..MAXN,1..MAXN] of integer;
    nway:array[1..MAXN] of double;
    i,j,k,m,n,i1,i2,ist,ifi:integer;
    n1,n2:string;
    aux,aux2,cst,cfin:plist;
    ch:char;
    d1,d2:double;

procedure df(nod:integer);
var aa:plist;
    ii:integer;
begin
marc[nod]:=1;

aa:=muc[nod];
while (aa<>nil) do
  begin
    ii:=aa^.index;

    if (marc[ii]=0) then
      df(ii);
    aa:=aa^.urm;
  end;
end;

begin
assign(input,filein);
reset(input);
read(m);

n:=0;
fillchar(muc,sizeof(muc),0);
fillchar(degin,sizeof(degin),0);
fillchar(mat,sizeof(mat),0);

for k:=1 to m do
  begin
    read(ch);
    while (ch=#13) or (ch=#10) or (ch=' ') do
      read(ch);

    n1:='';
    while (ch<>#13) and (ch<>#10) and (ch<>' ') do
      begin
        n1:=n1+ch;
        read(ch);
      end;

    while (ch=#13) or (ch=#10) or (ch=' ') do
      read(ch);

    n2:='';
    while (ch<>#13) and (ch<>#10) and (ch<>' ') and (ch<>#26) do
      begin
        n2:=n2+ch;
        read(ch);
      end;

    i1:=0;
    for i:=1 to n do
      if (nume[i]=n1) then
        begin
          i1:=i; break;
        end;

    if (i1=0) then
      begin
        inc(n); i1:=n;
        nume[n]:=n1;
      end;

    i2:=0;
    for i:=1 to n do
      if (nume[i]=n2) then
        begin
          i2:=i; break;
        end;

    if (i2=0) then
      begin
        inc(n); i2:=n;
        nume[n]:=n2;
      end;

    new(aux);
    aux^.index:=i2;
    aux^.urm:=muc[i1];
    muc[i1]:=aux;
    inc(degin[i2]);
    inc(mat[i1,i2]);
  end;

for i:=1 to n do
  begin
    if (nume[i]=start) then
      ist:=i;
    if (nume[i]=finish) then
      ifi:=i;
  end;

cst:=nil;
cfin:=nil;
for i:=1 to n do
  if (degin[i]=0) then
    begin
      if (cst=nil) then
        begin
          new(cst);
          cst^.index:=i;
          cst^.urm:=nil;
          cfin:=cst;
        end
      else
        begin
          new(aux);
          aux^.index:=i;
          aux^.urm:=nil;
          cfin^.urm:=aux;
          cfin:=aux;
        end;
    end;

k:=0;
while (cst<>nil) do
  begin
    i:=cst^.index;
    inc(k); order[k]:=i;

    aux:=muc[i];
    while (aux<>nil) do
      begin
        j:=aux^.index;
        dec(degin[j]);

        if (degin[j]=0) then
          begin
            new(aux2);
            aux2^.index:=j;
            aux2^.urm:=nil;
            cfin^.urm:=aux2;
            cfin:=aux2;
          end;

        aux:=aux^.urm;
      end;

    aux:=cst;
    cst:=cst^.urm;
    dispose(aux);
  end;

fillchar(marc,sizeof(marc),0);
df(ist);

fillchar(nway,sizeof(nway),0);
nway[ist]:=1;

for i1:=2 to n do
  if (marc[order[i1]]=1) and (order[i1]<>ist) then
    begin
      i:=order[i1];
      for i2:=1 to k-1 do
        if (marc[order[i2]]=1) then
          begin
            j:=order[i2];

            d1:=mat[j,i];
            if (d1>0) then
              begin
                d2:=nway[j];
                nway[i]:=nway[i]+d1*d2;
              end;
          end;
    end;

assign(output,fileout);
rewrite(output);
writeln(nway[ifi]:0:0);
close(output);
end.