#pragma option -O2 -ff -f287

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <ctype.h>
#include "zavor.h"

#define FIN "test.in"
#define FOUT "test.out"
#define MAXC (102)
#define MSG_COR "CORECT"

typedef char TCod[2*MAXC+4];

TCod cor, sparg;
int n;
int e_cor=1;

void read() {
     FILE* in=fopen(FIN,"rt");
     fscanf(in,"%s",cor);
     n=strlen(cor);
     fclose(in);
}

void write() {
     FILE* out=fopen(FOUT,"wt");
     if (e_cor) fprintf(out,MSG_COR);
     else {
          fprintf(out,"%s",sparg);
     }
     fclose(out);
}

void cod_bun(int i, char j, int ul) {
     strcpy(sparg,cor);
     sparg[i]=j;
     for (int crt=ul; crt<n; crt++)
         sparg[++i]=cor[crt];
     sparg[++i]=0;
}

void adu_stare(int nr) {
     ResetA();
     for (int i=0; i<nr; i++) {
         Schimba(cor[i]);
     }
}

void stare_finala(int nr) {
     for (int i=nr; i<n; i++) {
         Schimba(cor[i]);
     }
}

void solve() {
     ResetA();
     for (int i=0; i<n-1; i++) {
         if (toupper(Deschide())=='D') {
            e_cor=0;
            strcpy(sparg,cor);
            sparg[i]=0;
            return;
         }
         Schimba(cor[i]);
     }
     for (i=0; i<n; i++) {
         for (char j='0'; j<='9'; j++) {
             if (j==cor[i]) continue;
             for (int ul=n; ul>0; ul--) {
                 adu_stare(i);
                 Schimba(j);
                 stare_finala(ul);
                 if (toupper(Deschide())=='D') {
                    cod_bun(i,j,ul);
                    e_cor=0;
                    return;
                 }
             }
         }
     }
}

void main() {
     read();
     solve();
     write();
}