{ 
  
  Bursele Agora, Editia 2001/2002
  Runda 1, Poblema 2: Dune
  Autor: Mihai Scortaru
  Copyright (c) 2001 - Agora Media
  
  Acest fisier este proprietate a editurii Agora Media si este 
  distribuit in regim freeware. Fisierul nu poate fi modificat 
  sau folosit in scopuri comerciale fara acordul scris al 
  editurii Agora Media.

  Programul a fost testat de catre autor si membrii redactiei 
  GInfo. Totusi, autorul, redactia GInfo sau editura Agora Media 
  nu pot fi facuti responsabili pentru eventualele daune provocate 
  de functionarea incorecta a acestui program.

}


Program Dune;

var a:array[0..51,0..51] of char;
    c:char;
    m,n,x,y:integer;
    f:text;

procedure ReadData;
var i,j:Integer;
begin
  Assign(f,'DUNE.IN');
  Reset(f);
  Readln(f,m,n);
  for i:=0 to m+1 do
  begin
    a[i][0]:='+';
    a[i][n+1]:='+';
  end;
  for i:=1 to n do
  begin
    a[0][i]:='+';
    a[m+1][i]:='+';
  end;
  for i:=1 to m do
  begin
    for j:=1 to n do
    begin
      Read(f,a[i][j]);
      if a[i][j]='*' then { determinarea pozitiei sietch-ului de plecare }
      begin
        x:=i; y:=j
      end
    end;
    Readln(f);
  end;
end;

procedure Mark(i,j,dx,dy:Integer); { Marcarea cu '#' a pozitiilor in care se poate ajunge din pozitia curenta }
begin
  j:=j+dx;
  i:=i+dy;
  while a[i][j] <> '+' do
  begin
    a[i][j]:='#';
    i:=i+dy;
    j:=j+dx;
  end;
end;

procedure NewPositions;
var dx,dy:Integer;
    i,j:Integer;
begin
  case c of  { determinarea directiei }
  'E': begin dx:=1; dy:=0 end;
  'V': begin dx:=-1; dy:=0 end;
  'S': begin dx:=0; dy:=1 end;
  'N': begin dx:=0; dy:=-1 end;
  end;
  for i:=1 to m do
    for j:=1 to n do
      if a[i][j]='*' then { determinarea pozitiilor marcate cu '*' }
        Mark(i,j,dx,dy);
  for i:=1 to m do
    for j:=1 to n do
      if a[i][j]='#' then a[i][j]:='*' { marcarea cu '*' a poziiilor marcate cu '#' }
      else if a[i][j]='*' then
        a[i][j]:='.'; { marcarea cu '.' a poziiilor marcate cu '*' }
  a[x][y]:='+'; { marcarea cu '+' a pozitiei sietch-ului de plecare }
end;

procedure FindSolution;
begin
  while not Seekeof(f) do
  begin
    Read(f,c);
    NewPositions
  end;
  Close(f);
end;

procedure WriteSolution;
var i,j,sol:Integer;
begin
  sol:=0;
  for i:=1 to m do
    for j:=1 to n do
      if a[i][j]='*' then
        Inc(sol); { Numararea pozitiilor finale }
  Assign(f,'DUNE.OUT');
  Rewrite(f);
  Writeln(f,sol);
  Close(f);
end;

begin
  ReadData;
  FindSolution;
  WriteSolution;
end.