{ 
  
  Bursele Agora, Editia 2001/2002
  Runda 1, Poblema 1: Matrice
  Autor: Mihai Stroe
  Copyright (c) 2001 - Agora Media
  
  Acest fisier este proprietate a editurii Agora Media si este 
  distribuit in regim freeware. Fisierul nu poate fi modificat 
  sau folosit in scopuri comerciale fara acordul scris al 
  editurii Agora Media.

  Programul a fost testat de catre autor si membrii redactiei 
  GInfo. Totusi, autorul, redactia GInfo sau editura Agora Media 
  nu pot fi facuti responsabili pentru eventualele daune provocate 
  de functionarea incorecta a acestui program.

}

{$A+,B-,D+,E+,F-,G-,I-,L+,N-,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
{$M 16384,0,655360}
const p:array[1..37,1..7]of integer=(
(0,0,0,0,0,0,0),
(1,1,0,0,0,0,0),
(0,1,1,0,0,0,0),
(0,0,1,1,0,0,0),
(0,0,0,1,1,0,0),
(0,0,0,0,1,1,0),
(0,0,0,0,0,1,1),
(1,1,1,0,0,0,0),
(1,1,1,1,0,0,0),
(1,1,0,1,1,0,0),
(1,1,0,0,1,1,0),
(1,1,0,0,0,1,1),
(0,1,1,1,0,0,0),
(0,1,1,1,1,0,0),
(0,1,1,0,1,1,0),
(0,1,1,0,0,1,1),
(0,0,1,1,1,0,0),
(0,0,1,1,1,1,0),
(0,0,1,1,0,1,1),
(0,0,0,1,1,1,0),
(0,0,0,1,1,1,1),
(0,0,0,0,1,1,1),
(1,1,1,1,1,0,0),
(1,1,1,0,1,1,0),
(1,1,1,0,0,1,1),
(1,1,1,1,1,1,0),
(1,1,1,1,0,1,1),
(1,1,0,1,1,1,0),
(1,1,0,1,1,1,1),
(1,1,0,0,1,1,1),
(0,1,1,1,1,1,0),
(0,1,1,1,0,1,1),
(0,1,1,1,1,1,1),
(0,1,1,0,1,1,1),
(0,0,1,1,1,1,1),
(1,1,1,0,1,1,1),
(1,1,1,1,1,1,1)
);
const nr:array[1..37]of integer=(
0,1,1,1,1,1,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,3,3,3,3,3,3,3,3,3,3,3,3,3,4,4
);

var q,sum,max:longint;
    l,k,ind1,m,n,i,j,row:integer;
    tl1:longint;
    tl2:longint absolute $0:$46c;
    fi,fo:text;
    x:array[1..100,1..7]of integer;
    aduna:array[1..37,1..37]of longint;
    aduna2:array[1..37]of longint;
    a,b:array[0..100,1..37]of longint;

procedure readdata;
begin
  assign(fi,'matrix.in');
  assign(fo,'matrix.out');
  reset(fi);
  readln(fi,n,k);
  for i:=1 to n do
      begin
        for j:=1 to 7 do
            read(fi,x[i,j]);
        readln(fi);
      end;
  close(fi);
end;

procedure solve;
begin
  for i:=0 to k do
      for j:=1 to 37 do
          a[i,j]:=-1000000;
  a[0,1]:=0;

  for row:=1 to n-1 do
      begin
        { calculez valoarea adaugata pe linia curenta de configuratia i
          daca pe linia anterioara am configuratia j }
        for i:=1 to 37 do
            for j:=1 to 37 do
                begin
                  aduna[i,j]:=0;
                  for l:=1 to 7 do
                      if (p[i,l]=1)and(p[j,l]=0) then
                         aduna[i,j]:=aduna[i,j]+x[row,l];
                end;
        { calculez valoarea adaugata pe linia urmatoare de configuratia i }
        for i:=1 to 37 do
            begin
              aduna2[i]:=0;
              for l:=1 to 7 do
                  if (p[i,l]=1) then
                     aduna2[i]:=aduna2[i]+x[row+1,l];
            end;
        for i:=0 to k do
            for j:=1 to 37 do
                b[i,j]:=-1000000;
        for i:=0 to k do
            for j:=1 to 37 do
                if i>=nr[j] then
                   begin
                     { vreau sa am cat mai putine adresari de elemente
                       ale unor vectori, pentru a creste viteza }
                     q:=aduna2[j];
                     ind1:=i-nr[j];
                     for l:=1 to 37 do
                         begin
                           sum:=a[ind1,l]+q+aduna[j,l];
                           if sum>b[i,j] then b[i,j]:=sum;
                         end;
                   end;
        a:=b;
      end;
  max:=0;
  for i:=1 to k do
      for j:=1 to 37 do
          if a[i,j]>max then
             max:=a[i,j];
  rewrite(fo);
  writeln(fo,max);
  close(fo);
end;

begin
  tl1:=tl2;
  readdata;
  solve;
  writeln((tl2-tl1)/18.2:1:3);
end.