{ Mugurel Ionut Andreica - Bucuresti, ROMANIA }

{ 
  Programul gaseste, de cele mai multe ori, solutie mai
  buna decat ar trebui, caci nu garanteaza conexitatea
  decat pentru elementele care sunt mai numeroase pe harta
  :)
}

{$I-,R-,Q-,S-}
{$M 65000,0,655360}

Program WarCraft;

const filein='WARCRAFT.IN';
      fileout='WARCRAFT.OUT';
      dl:array[1..4] of integer=(-1,0,+1,0);
      dc:array[1..4] of integer=(0,+1,0,-1);
      MAXN=50;
      MAXC=1300;
      timelimit=17;
      infinit=30000;

type plist=^list;
     list=record
            ll,cc:byte;
            ant,urm:plist;
          end;

var map:array[1..MAXN,1..MAXN] of byte;
    dmin:array[1..MAXN,1..MAXN] of longint;
    poo:array[1..MAXN,1..MAXN] of plist;
    ccon:array[1..MAXN,1..MAXN] of integer;
    ntouch,nelem:array[1..MAXC,0..1] of integer;
    conex,cused:array[1..MAXC] of boolean;
    dtocon:array[1..MAXC] of integer;
    lin,col:array[1..MAXN*MAXN] of byte;
    num,ncon:array[0..1] of integer;
    i,j,k,m,n,p,q,po,nel,l,c,ln,cn,nmin,nact,buf,got,tip,sum:integer;
    stt,sto,auxa,auxu:plist;
    ch:char;

    t2:longint absolute 0:$046c;
    t1:longint;

procedure printsol(num:integer);
begin
assign(output,fileout);
rewrite(output);
writeln(num);
close(output);
halt(0);
end;

procedure bf;
begin
po:=1; nel:=1;
lin[1]:=i; col[1]:=j;
ccon[i,j]:=ncon[p];

while (po<=nel) do
  begin
    l:=lin[po]; c:=col[po];
    inc(nelem[ncon[p],p]);

    if (l=1) or (l=m) or (c=1) or (c=n) then
      inc(ntouch[ncon[p],p]);

    for k:=1 to 4 do
      begin
        ln:=l+dl[k];
        cn:=c+dc[k];

        if (ln>0) and (ln<=m) and (cn>0) and (cn<=n) and
           (map[ln,cn]=p) and (ccon[ln,cn]=0) then
           begin
             ccon[ln,cn]:=ncon[p];
             inc(nel);
             lin[nel]:=ln;
             col[nel]:=cn;
           end;
      end;

    inc(po);
  end;
end;

procedure go(li,co:byte;var clast:plist; dd:longint);
var cst,cnew,cfin,aux:plist;
    k:byte;
begin
dmin[li,co]:=0;
new(cst);
cst^.ll:=li;
cst^.cc:=co;
cst^.ant:=nil;
cst^.urm:=nil;
cfin:=cst;

stt:=cst;

while (cst<>nil) do
  begin
    l:=cst^.ll; c:=cst^.cc;

    for k:=1 to 4 do
      begin
        ln:=l+dl[k];
        cn:=c+dc[k];

        if (ln>0) and (ln<=m) and (cn>0) and (cn<=n) and
           (map[ln,cn]=1-tip) and (dmin[ln,cn]>0) then
           begin
             dmin[ln,cn]:=0;

             new(aux);
             aux^.ll:=ln;
             aux^.cc:=cn;
             aux^.ant:=cfin;
             aux^.urm:=nil;
             cfin^.urm:=aux;
             cfin:=aux;
           end;
      end;

    cst:=cst^.urm;
  end;


cst:=stt;
while (cst<>nil) do
  begin
    l:=cst^.ll; c:=cst^.cc;

    if (l>0) and (c>0) and (l<=m) and (c<=n) and (dmin[l,c]>dd) then
      begin
        new(aux);
        aux^.ll:=101;
        aux^.cc:=101;
        aux^.ant:=nil;
        aux^.urm:=cst;

        if (clast<>nil) then
          begin
            cfin^.urm:=clast;
            clast^.ant:=cfin;
          end;

        clast:=aux;
        exit;
      end;

    for k:=1 to 4 do
      begin
        ln:=l+dl[k];
        cn:=c+dc[k];

        if (ln>0) and (ln<=m) and (cn>0) and (cn<=n) then
          begin
            if (map[ln,cn]=tip) then
              begin
                if (dmin[ln,cn]>dmin[l,c]+1) then
                  begin
                    dmin[ln,cn]:=dmin[l,c]+1;

                    new(aux);
                    aux^.ll:=ln;
                    aux^.cc:=cn;
                    aux^.ant:=cfin;
                    aux^.urm:=nil;
                    cfin^.urm:=aux;
                    cfin:=aux;

                    {
                    if (poo[ln,cn]<>nil) then
                      begin
                        auxa:=poo[ln,cn]^.ant;
                        auxu:=poo[ln,cn]^.urm;

                        if (auxa<>nil) then
                          auxa^.urm:=auxu;
                        if (auxu<>nil) then
                          auxu^.ant:=auxa;

                        if (clast=poo[ln,cn]) then
                          clast:=nil;

                        dispose(poo[ln,cn]);
                      end;
                    }
                    poo[ln,cn]:=aux;
                  end;
              end
            else
              begin
                if (not conex[ccon[ln,cn]]) then
                  begin
                    { Nice part ! }
                    nact:=nact+dmin[l,c];

                    if (dmin[l,c]>=buf) then
                      buf:=0
                    else
                      buf:=buf-dmin[l,c];
                    {
                    buf:=buf+ntouch[ccon[ln,cn],1-tip];
                    }
                    got:=got+nelem[ccon[ln,cn],1-tip];
                            {
                            -ntouch[ccon[ln,cn],1-tip];
                            }
                    sum:=nact+buf+got;

                    if (sum>=num[1-tip]) or (nact+buf>=nmin) then
                      begin
                        sum:=infinit;
                        if (nact+buf<nmin) then
                          nmin:=nact+buf;

                        if (clast<>nil) then
                          begin
                            clast^.ant:=cfin;
                            cfin^.urm:=clast;
                          end;
                        clast:=cst;
                        exit;
                      end
                    else
                      begin
                        conex[ccon[ln,cn]]:=true;

                        go(ln,cn,cst, dmin[l,c]);

                        if (sum>=num[1-tip]) then
                          begin
                            clast^.ant:=cfin;
                            cfin^.urm:=clast;
                            clast:=cst;
                            exit;
                          end;
                      end;
                    { END Nice part }
                  end;
              end;
          end;
      end;

    aux:=cst;
    poo[l,c]:=nil;

    if (cst<>nil) then
      cst:=cst^.urm;
    if (aux<>nil) then
      dispose(aux);
  end;
end;

begin
t1:=t2;

assign(input,filein);
reset(input);

fillchar(num,sizeof(num),0);
fillchar(map,sizeof(map),0);
readln(m,n);

for i:=1 to m do
  begin
    for j:=1 to n do
      begin
        read(ch);
        if (ch='.') then
          map[i,j]:=0
        else
          map[i,j]:=1;

        inc(num[map[i,j]]);
      end;
    readln;
  end;

fillchar(ccon,sizeof(ccon),0);
fillchar(ncon,sizeof(ncon),0);
fillchar(ntouch,sizeof(ntouch),0);
fillchar(nelem,sizeof(nelem),0);

for i:=1 to m do
  for j:=1 to n do
    if (ccon[i,j]=0) then
      begin
        p:=map[i,j];
        inc(ncon[p]);

        bf;
      end;

if (ncon[0]>ncon[1]) then
  begin
    i:=ncon[1]; ncon[1]:=ncon[0]; ncon[0]:=i;
    i:=num[1]; num[1]:=num[0]; num[0]:=i;

    for i:=1 to m do
      for j:=1 to n do
        map[i,j]:=1-map[i,j];

    k:=ncon[1];
    for i:=1 to k do
      begin
        j:=nelem[i,1]; nelem[i,1]:=nelem[i,0]; nelem[i,0]:=j;
        j:=ntouch[i,1]; ntouch[i,1]:=ntouch[i,0]; ntouch[i,0]:=j;
      end;
  end;

if (ncon[0]<=1) and (ncon[1]<=1) then
  printsol(0);

if (num[0]<num[1]) then
  nmin:=num[0]-1
else
  nmin:=num[1]-1;

tip:=0;
fillchar(cused,sizeof(cused),false);

for i:=1 to m do
  for j:=1 to n do
    if (map[i,j]=1) and (not cused[ccon[i,j]]) then
      begin
        cused[ccon[i,j]]:=true;

        fillchar(conex,sizeof(conex),false);
        fillchar(dtocon,sizeof(dtocon),0);
        conex[ccon[i,j]]:=true;
        buf:=0; nact:=0;
        got:=nelem[ccon[i,j],1];

        fillchar(dmin,sizeof(dmin),127);
        fillchar(poo,sizeof(poo),0);

        sum:=0;

        sto^.ant:=nil; sto^.urm:=nil;

        sto:=nil;
        go(i,j,sto,infinit);

        while (sto<>nil) do
          begin
            auxa:=sto;
            sto:=sto^.urm;
            dispose(auxa);
          end;

        if (t2-t1>=timelimit) then
          begin

            printsol(nmin);

          end;
      end;

printsol(nmin);
end.