{ Mugurel Ionut Andreica - Bucuresti, ROMANIA }

{$R-,I-,Q-,S-,N+}
{$M 15000,0,655360}

Program CUBE;

const filein='CUBE.IN';
      fileout='CUBE.OUT';
      MAXN=40;
      NVEC=26;
      dx:array[1..NVEC] of shortint=
(-1,-1,-1,-1,-1,-1,-1,-1,-1, 0, 0, 0, 0,0, 0,0,0, 1, 1, 1, 1,1,1, 1,1,1);
      dy:array[1..NVEC] of shortint=
(-1,-1,-1, 0, 0, 0, 1, 1, 1,-1,-1,-1, 0,0, 1,1,1,-1,-1,-1, 0,0,0, 1,1,1);
      dz:array[1..NVEC] of shortint=
(-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1,1,-1,0,1,-1, 0, 1,-1,0,1,-1,0,1);

type plane=array[1..MAXN,1..MAXN] of longint;
     pplane=^plane;

var fin,fout:text;
    i,k,m,n,x,y,z,xi,yi,zi:shortint;
    nwords:array[1..MAXN] of pplane;
    cub:array[1..MAXN,1..MAXN,1..MAXN] of char;
    wrd:string[27];
    total:longint;

begin
assign(fin,filein);
reset(fin);
readln(fin,wrd);
readln(fin,n);

for z:=1 to n do
  for y:=1 to n do
    begin
      for x:=1 to n do
        read(fin,cub[x,y,z]);
      readln(fin);
    end;

for x:=1 to n do
  begin
    new(nwords[x]);
    fillchar(nwords[x]^,sizeof(plane),0);
  end;

{ Compute # of words }
for x:=1 to n do
  for y:=1 to n do
    for z:=1 to n do
      if (cub[x,y,z]=wrd[1]) then
        nwords[x]^[y,z]:=1;

m:=length(wrd);
for k:=2 to m do
  for x:=1 to n do
    for y:=1 to n do
      for z:=1 to n do
        if (cub[x,y,z]=wrd[k]) then
          begin
            for i:=1 to NVEC do
              begin
                xi:=x+dx[i]; yi:=y+dy[i]; zi:=z+dz[i];
                if (xi>0) and (xi<=n) and (yi>0) and (yi<=n) and
                   (zi>0) and (zi<=n) and (cub[xi,yi,zi]=wrd[k-1]) then
                  nwords[x]^[y,z]:=nwords[x]^[y,z]+nwords[xi]^[yi,zi];
              end;
          end;
{ END Compute }

{ Print solution }
total:=0;
for x:=1 to n do
  for y:=1 to n do
    for z:=1 to n do
      if (cub[x,y,z]=wrd[m]) then
        total:=total+nwords[x]^[y,z];

assign(fout,fileout);
rewrite(fout);
writeln(fout,total);
close(fout);
end.