{ Mugurel Ionut Andreica - Bucuresti, ROMANIA }

{
  The reverse Burrows-Wheeler Transformation for a particular
  type of strings (made up of '0' and '1')

  Time Complexity: O(N)
}

{$R-,I-,Q-,N+}
{$M 15000,0,655360}
Program TEMPLE;

const filein='TEMPLE.IN';
      fileout='TEMPLE.OUT';
      MAXL=50000;
      MAXD=1023;
      MAXC=50;
      MAXBDIM=65000;

type buffer=array[1..MAXBDIM] of char;
     pbuffer=^buffer;
     linie=array[1..MAXL] of byte;
     plinie=^linie;
     p=array[0..MAXC] of word;
     pp=^p;

var fin,fout:text;
    i,j,k,m,n,r,q,nch:longint;
    line:array[0..MAXD] of pp;
    num,nact:array[0..1] of longint;
    first:plinie;
    ch:byte;
    buf:pbuffer;

begin
new(buf);
fillchar(buf^,sizeof(buffer),0);

assign(fin,filein);
settextbuf(fin,buf^,sizeof(buffer));
reset(fin);
readln(fin,n);

for i:=0 to MAXD do
  begin
    new(line[i]);
    fillchar(line[i]^,sizeof(p),0);
  end;

new(first);
fillchar(first^,sizeof(linie),0);

num[0]:=0; num[1]:=0;
for i:=1 to n do
  begin
    read(fin,ch);
    first^[i]:=ch;
    inc(num[ch]);
  end;
close(fin);

move(num,nact,sizeof(num));
for i:=n downto 1 do
  if (first^[i]=0) then
    begin
      m:=nact[0];
      r:=m and MAXD;
      q:=m shr 10;

      line[r]^[q]:=i;
      dec(nact[0]);
    end
  else
    begin
      m:=num[0]+nact[1];
      r:=m and MAXD;
      q:=m shr 10;

      line[r]^[q]:=i;
      dec(nact[1]);
    end;

fillchar(first^,sizeof(linie),0);
for i:=1 to n do
  if (i<=num[0]) then
    first^[i]:=0
  else
    first^[i]:=1;

assign(fout,fileout);
settextbuf(fout,buf^,sizeof(buffer));
rewrite(fout);

write(fout,first^[1]);
i:=1;
for nch:=2 to n do
  begin
    r:=i and MAXD;
    q:=i shr 10;

    i:=line[r]^[q];
    write(fout,' ',first^[i]);
  end;

writeln(fout);
close(fout);
end.