{ Mugurel Ionut Andreica - Bucuresti, ROMANIA }

{ Flux Maxim de Cost Minim }

{$R-,I-,S-,Q-,N+}
{$M 65000,0,655360}
Program TREES;

const filein='TREES.IN';
      fileout='TREES.OUT';
      MAXV=101;
      MAXN=41;
      INFINIT=1000000;

type pc=^c;
     c=record
         ii:byte;
         urm:pc;
       end;

var fin,fout:text;
    nnodes:array[1..MAXN,0..1] of byte;
    fiu:array[1..MAXN,0..1,1..MAXV,1..2] of byte;
    cost:array[0..2*MAXN+1,0..2*MAXN+1] of longint;
    dmin:array[0..2*MAXN+1] of longint;
    tata:array[0..2*MAXN+1] of byte;
    tip:array[0..2*MAXN+1] of integer;
    flux:array[0..2*MAXN+1,0..2*MAXN+1] of byte;
    incoada:array[0..2*MAXN+1] of boolean;
    i,j,k,m,n,p,q,last,fmax,cmin:longint;
    cst,cfin,aux:pc;

function ctrans(nod1,nod2:byte):longint;
var caux:longint;
begin
caux:=0;

if (fiu[i,0,nod1,1]>0) and (fiu[j,1,nod2,1]=0) then
  caux:=caux+1;
if (fiu[i,0,nod1,1]=0) and (fiu[j,1,nod2,1]>0) then
  caux:=INFINIT;
if (fiu[i,0,nod1,2]>0) and (fiu[j,1,nod2,2]=0) then
  caux:=caux+1;
if (fiu[i,0,nod1,2]=0) and (fiu[j,1,nod2,2]>0) then
  caux:=INFINIT;

if (fiu[i,0,nod1,1]>0) and (fiu[j,1,nod2,1]>0) then
  caux:=caux+ctrans(fiu[i,0,nod1,1],fiu[j,1,nod2,1]);
if (fiu[i,0,nod1,2]>0) and (fiu[j,1,nod2,2]>0) then
  caux:=caux+ctrans(fiu[i,0,nod1,2],fiu[j,1,nod2,2]);

ctrans:=caux;
end;

begin
assign(fin,filein);
reset(fin);
readln(fin,m,n);

for k:=1 to m do
  begin
    readln(fin,nnodes[k,0]);
    for i:=1 to nnodes[k,0] do
      begin
        readln(fin,fiu[k,0,i,1],fiu[k,0,i,2]);
      end;
  end;

for k:=1 to n do
  begin
    readln(fin,nnodes[k,1]);
    for i:=1 to nnodes[k,1] do
      begin
        readln(fin,fiu[k,1,i,1],fiu[k,1,i,2]);
      end;
  end;
close(fin);

last:=m+n+1;
for i:=0 to last do
  for j:=0 to last do
    cost[i,j]:=INFINIT;

for i:=1 to m do
  cost[0,i]:=0;
for i:=m+1 to m+n do
  cost[i,last]:=0;

for i:=1 to m do
  for j:=1 to n do
    begin
      p:=ctrans(1,1);
      if (p>INFINIT) then p:=INFINIT;

      cost[i,m+j]:=p;
    end;

fmax:=0;
cmin:=0;
fillchar(flux,sizeof(flux),0);

repeat

fillchar(tip,sizeof(tip),0);
fillchar(tata,sizeof(tata),0);
fillchar(incoada,sizeof(incoada),false);
for i:=0 to last do
  dmin[i]:=INFINIT;

new(cst);
cst^.ii:=0;
cst^.urm:=nil;
cfin:=cst;

incoada[0]:=true;
dmin[0]:=0;

while (cst<>nil) do
  begin
    i:=cst^.ii;

    if (i=0) then
      begin
        for j:=1 to m do
          if (cost[i,j]<INFINIT) and (flux[i,j]=0) then
            begin
              if (dmin[i]+cost[i,j]<dmin[j]) then
                begin
                  dmin[j]:=dmin[i]+cost[i,j];
                  tata[j]:=i;
                  tip[j]:=1;

                  if (not incoada[j]) then
                    begin
                      incoada[j]:=true;
                      new(aux);
                      aux^.ii:=j;
                      aux^.urm:=nil;
                      cfin^.urm:=aux;
                      cfin:=aux;
                    end;
                end;
            end;
      end
    else
    if (i<=m) and (i>=1) then
      begin
        for j:=m+1 to m+n do
          if (cost[i,j]<INFINIT) and (flux[i,j]=0) then
            begin
              if (dmin[i]+cost[i,j]<dmin[j]) then
                begin
                  dmin[j]:=dmin[i]+cost[i,j];
                  tata[j]:=i;
                  tip[j]:=1;

                  if (not incoada[j]) then
                    begin
                      incoada[j]:=true;
                      new(aux);
                      aux^.ii:=j;
                      aux^.urm:=nil;
                      cfin^.urm:=aux;
                      cfin:=aux;
                    end;
                end;
            end;
      end
    else
    if (i<=m+n) then
      begin
        for j:=1 to m do
          if (cost[j,i]<INFINIT) and (flux[j,i]=1) then
            begin
              if (dmin[i]-cost[j,i]<dmin[j]) then
                begin
                  dmin[j]:=dmin[i]-cost[j,i];
                  tata[j]:=i;
                  tip[j]:=-1;

                  if (not incoada[j]) then
                    begin
                      incoada[j]:=true;
                      new(aux);
                      aux^.ii:=j;
                      aux^.urm:=nil;
                      cfin^.urm:=aux;
                      cfin:=aux;
                    end;
                end;
            end;

        if (flux[i,last]=0) and (dmin[i]+cost[i,last]<dmin[last]) then
          begin
            dmin[last]:=dmin[i]+cost[i,last];
            tata[last]:=i;
            tip[last]:=1;

            {
            if (not incoada[last]) then
              begin
                incoada[last]:=true;
                new(aux);
                aux^.ii:=last;
                aux^.urm:=nil;
                cfin^.urm:=aux;
                cfin:=aux;
              end;
            }
          end;
      end
    else
    if (i=last) then
      begin
        {
        for j:=m+1 to m+n do
          begin
          end;
        }
      end;

    incoada[i]:=false;

    aux:=cst;
    cst:=cst^.urm;
    dispose(aux);
  end;

if (tata[last]>0) then
  begin
    fmax:=fmax+1;
    cmin:=cmin+dmin[last];

    p:=last;
    while (p>0) do
      begin
        case tip[p] of
         1:inc(flux[tata[p],p]);
        -1:dec(flux[p,tata[p]]);
        end;

        p:=tata[p];
      end;
  end;
until (tata[last]=0);

assign(fout,fileout);
rewrite(fout);
writeln(fout,fmax);
writeln(fout,cmin);

for i:=1 to m do
  for j:=m+1 to m+n do
    if (flux[i,j]=1) then
      writeln(fout,i,' ',j-m);

close(fout);
end.