{ Mugurel Ionut Andreica - Bucuresti, ROMANIA }

{$M 65000,0,655360}
{$S-,I-,R-,Q-,N+}

{ Greedy + DP }

Program _Stupid_Game_of_Chess_;
uses chess;

const dc:array[1..8] of integer=(-1,-1,-1,0,+1,+1,+1,0);
      dl:array[1..8] of integer=(+1,0,-1,-1,-1,0,+1,+1);

type line=array[1..8,1..8] of byte;
     pline=^line;

var min:array[1..8,1..8,1..8,1..8] of pline;
    cbk,lbk,cwk,lwk,cwq,lwq:integer;
    i,j,k,m,n,c1,l1,c2,l2,niv,minarea,area:longint;
    tip,tact,newc,newl,actc,actl,mm,di,len,mind,dd,stage:longint;
    mleft:integer;
    marc:array[1..8,1..8] of integer;
    dir:array[1..8] of boolean;
    s1,s2,s3:string;
    maxniv:longint;

function distance(x1,y1,x2,y2:longint):longint;
var dx,dy:longint;
begin
dx:=abs(x1-x2);
dy:=abs(y1-y2);
if (dx>dy) then
  distance:=dx
else
  distance:=dy;
end;

function intre(a,b,c:integer):boolean;
begin
if (a=c) then intre:=true
else
if (b=c) then intre:=true
else
if (a<c) and (c<b) then
  intre:=true
else
if (b<c) and (c<a) then
  intre:=true
else
  intre:=false;
end;

function bkattacked:boolean;
var a,b,c:longint;
begin
a:=lwq-lbk;
b:=cbk-cwq;
c:=cwq*lbk-cbk*lwq;

if (a*cwk+b*lwk+c<>0) or (not intre(lwq,lbk,lwk)) or
   (not intre(cwq,cbk,cwk)) then
  begin
    if (cwq=cbk) or (lwq=lbk) or (abs(cwq-cbk)=abs(lwq-lbk)) then
      bkattacked:=true
    else
      bkattacked:=false;
  end
else
  bkattacked:=false;
end;

procedure play; forward;
procedure makebkmove(cwk1,lwk1,cwq1,lwq1:longint);
var mm,nmov,res,minim:byte;
begin
{ Try to move the black king }

nmov:=0; minim:=0;
for mm:=1 to 8 do
  begin
    cbk:=cbk+dc[mm]; lbk:=lbk+dl[mm];

    if (cbk>0) and (cbk<9) and (lbk>0) and (lbk<9) and
       ((abs(cwk-cbk)>1) or (abs(lwk-lbk)>1)) and
       ((cbk<>cwq) or (lbk<>lwq)) and (not bkattacked)
    then
      begin
        inc(nmov);
        res:=min[cbk,lbk,cwk,lwk]^[cwq,lwq];
        if (res=0) then
          begin
            inc(niv);
            play;
            dec(niv);
            res:=min[cbk,lbk,cwk,lwk]^[cwq,lwq];
            if (res=0) then res:=255;
          end;

        if (res>minim) then minim:=res;
      end;

    cbk:=cbk-dc[mm]; lbk:=lbk-dl[mm];
  end;

if (nmov=0) and (bkattacked) then
  min[cbk,lbk,cwk1,lwk1]^[cwq1,lwq1]:=1
else
if (nmov>0) and (minim<min[cbk,lbk,cwk1,lwk1]^[cwq1,lwq1]) then
  min[cbk,lbk,cwk1,lwk1]^[cwq1,lwq1]:=1+minim;
end;

procedure play;
var len,cwk1,lwk1,cwq1,lwq1,di:longint;
    dir:array[1..8] of boolean;
    mm:byte;
begin
if (niv=maxniv) then
  exit;

min[cbk,lbk,cwk,lwk]^[cwq,lwq]:=255;

cwk1:=cwk; lwk1:=lwk;
cwq1:=cwq; lwq1:=lwq;
di:=distance(cwk1,lwk1,cbk,lbk);

{ Try to move the white king }
for mm:=1 to 8 do
  begin
    cwk:=cwk+dc[mm]; lwk:=lwk+dl[mm];

    if (cwk>0) and (cwk<9) and (lwk>0) and (lwk<9) and
       ((abs(cwk-cbk)>1) or (abs(lwk-lbk)>1)) and
       ((cwk<>cwq) or (lwk<>lwq)) and ((abs(cwq-cbk)>1) or (abs(lwq-lbk)>1))
       {
       and (distance(cwk,lwk,cbk,lbk)<=di)
       }
       then
      begin
        makebkmove(cwk1,lwk1,cwq1,lwq1);
      end;

    cwk:=cwk-dc[mm]; lwk:=lwk-dl[mm];
  end;

{ Try to move the white queen }
fillchar(dir,sizeof(dir),true);

for len:=1 to 7 do
  for mm:=1 to 8 do
    if (dir[mm]) then
      begin
        cwq:=cwq+len*dc[mm]; lwq:=lwq+len*dl[mm];

        if (cwq>0) and (cwq<9) and (lwq>0) and (lwq<9) and
            ((cwq<>cwk) or (lwq<>lwk)) and
            ((cwq<>cbk) or (lwq<>lbk)) then
          begin
            if ((abs(cwq-cbk)>1) or (abs(lwq-lbk)>1)) or
               ((abs(cwq-cwk)<=1) and (abs(lwq-lwk)<=1)) then
              begin
                makebkmove(cwk1,lwk1,cwq1,lwq1);
              end;
          end
        else
          dir[mm]:=false;

        cwq:=cwq-len*dc[mm]; lwq:=lwq-len*dl[mm];
      end;
end;

procedure trybkmove(cwk1,lwk1,cwq1,lwq1:longint);
var mm,nmov,res,minim:byte;
begin
{ Try to move the black king }

nmov:=0; minim:=0;
for mm:=1 to 8 do
  begin
    cbk:=cbk+dc[mm]; lbk:=lbk+dl[mm];

    if (cbk>0) and (cbk<9) and (lbk>0) and (lbk<9) and
       ((abs(cwk-cbk)>1) or (abs(lwk-lbk)>1)) and
       ((cbk<>cwq) or (lbk<>lwq)) and (not bkattacked)
    then
      begin
        inc(nmov);
        res:=min[cbk,lbk,cwk,lwk]^[cwq,lwq];
        if (res=0) then res:=255;

        if (res>minim) then minim:=res;
      end;

    cbk:=cbk-dc[mm]; lbk:=lbk-dl[mm];
  end;

if (nmov=0) and (bkattacked) then
  begin
    if (tip=1) then
      begin
        tact:=1; actc:=cwk; actl:=lwk;
      end
    else
      begin
        tact:=2; actc:=cwq; actl:=lwq;
      end;
  end
else
if (nmov>0) and (minim<255) and (minim+1=min[cbk,lbk,cwk1,lwk1]^[cwq1,lwq1]) then
  begin
    if (tip=1) then
      begin
        tact:=1; actc:=cwk; actl:=lwk;
      end
    else
      begin
        tact:=2; actc:=cwq; actl:=lwq;
      end;
  end;
end;

procedure findmove;
var len,cwk1,lwk1,cwq1,lwq1,di:longint;
    dir:array[1..8] of boolean;
    mm:byte;
begin
cwk1:=cwk; lwk1:=lwk;
cwq1:=cwq; lwq1:=lwq;

{ Try to move the white king }
for mm:=1 to 8 do
  begin
    cwk:=cwk+dc[mm]; lwk:=lwk+dl[mm];

    if (cwk>0) and (cwk<9) and (lwk>0) and (lwk<9) and
       ((abs(cwk-cbk)>1) or (abs(lwk-lbk)>1)) and
       ((cwk<>cwq) or (lwk<>lwq)) and ((abs(cwq-cbk)>1) or (abs(lwq-lbk)>1))
    then
      begin
        tip:=1;
        trybkmove(cwk1,lwk1,cwq1,lwq1);
      end;

    cwk:=cwk-dc[mm]; lwk:=lwk-dl[mm];
  end;

{ Try to move the white queen }
fillchar(dir,sizeof(dir),true);

for len:=1 to 7 do
  for mm:=1 to 8 do
    if (dir[mm]) then
      begin
        cwq:=cwq+len*dc[mm]; lwq:=lwq+len*dl[mm];

        if (cwq>0) and (cwq<9) and (lwq>0) and (lwq<9) and
            ((cwq<>cwk) or (lwq<>lwk)) and
            ((cwq<>cbk) or (lwq<>lbk)) then
          begin
            if ((abs(cwq-cbk)>1) or (abs(lwq-lbk)>1)) or
               ((abs(cwq-cwk)<=1) and (abs(lwq-lwk)<=1)) then
              begin
                tip:=2;
                trybkmove(cwk1,lwk1,cwq1,lwq1);
              end;
          end
        else
          dir[mm]:=false;

        cwq:=cwq-len*dc[mm]; lwq:=lwq-len*dl[mm];
      end;
end;

procedure fill(row,col:longint);
var k:longint;
begin
inc(area);

if (marc[row,col]=0) then
  marc[row,col]:=2;

for k:=1 to 8 do
  begin
    row:=row+dc[k]; col:=col+dl[k];
    if (row>0) and (row<9) and (col>0) and (col<9) and
       (marc[row,col]=0) then
      fill(row,col);
    row:=row-dc[k]; col:=col-dl[k];
  end;
end;

procedure evalmove;
var len,mm:longint;
    dir:array[1..8] of boolean;

begin
fillchar(marc,sizeof(marc),0);

for mm:=1 to 8 do
  begin
    cwk:=cwk+dc[mm]; lwk:=lwk+dl[mm];
    if (cwk>0) and (cwk<9) and (lwk>0) and (lwk<9) then
      marc[cwk,lwk]:=1;
    cwk:=cwk-dc[mm]; lwk:=lwk-dl[mm];
  end;

fillchar(dir,sizeof(dir),true);
for len:=1 to 7 do
  for mm:=1 to 8 do
    if (dir[mm]) then
      begin
        cwq:=cwq+len*dc[mm]; lwq:=lwq+len*dl[mm];

        if (cwq>0) and (cwq<9) and (lwq>0) and (lwq<9) and
            ((cwq<>cwk) or (lwq<>lwk)) then
          marc[cwq,lwq]:=1
        else
          dir[mm]:=false;

        cwq:=cwq-len*dc[mm]; lwq:=lwq-len*dl[mm];
      end;

area:=0;
fill(cbk,lbk);
if (marc[cbk,lbk]=1) then
  dec(area);

if ((area<>1) or ((area=1) and (marc[cbk,lbk]=1))) then
  begin
    if (area<minarea) or
       ((area=minarea) and (tip=1) and (dd<mind)) then
      begin
        minarea:=area;
        tact:=tip;
        actl:=newl;
        actc:=newc;

        if (tip=1) then mind:=dd;
      end;
  end;
end;

begin
Init;
s1:=GetBlackKingPosition;
cbk:=ord(s1[1])-ord('a')+1;
lbk:=ord(s1[2])-ord('0');
s2:=GetWhiteKingPosition;
s3:=GetWhiteQueenPosition;
cwk:=ord(s2[1])-ord('a')+1;
lwk:=ord(s2[2])-ord('0');
cwq:=ord(s3[1])-ord('a')+1;
lwq:=ord(s3[2])-ord('0');

for c1:=1 to 8 do
  for l1:=1 to 8 do
    for c2:=1 to 8 do
      for l2:=1 to 8 do
        begin
          new(min[c1,l1,c2,l2]);
          fillchar(min[c1,l1,c2,l2]^,sizeof(line),0);
        end;

evalmove;
if (area<>1) then
  stage:=1
else
  stage:=2;

if (stage=2) then
  begin
    maxniv:=0;

    repeat
      inc(maxniv);

      for c1:=1 to 8 do
        for l1:=1 to 8 do
          for c2:=1 to 8 do
            for l2:=1 to 8 do
              begin
                fillchar(min[c1,l1,c2,l2]^,sizeof(line),0);
              end;

      niv:=0;
      play;
    until (min[cbk,lbk,cwk,lwk]^[cwq,lwq]<>255) or (maxniv=5);

    if (min[cbk,lbk,cwk,lwk]^[cwq,lwq]=255) then
      begin
        for c1:=1 to 8 do
          for l1:=1 to 8 do
            for c2:=1 to 8 do
              for l2:=1 to 8 do
                begin
                  fillchar(min[c1,l1,c2,l2]^,sizeof(line),0);
                end;
      end
    else
      stage:=6;
  end;

while (true) do
  begin
    { Make My Move }
    if (stage=1) then
      begin
        s2:=GetWhiteKingPosition;
        s3:=GetWhiteQueenPosition;
        cwk:=ord(s2[1])-ord('a')+1;
        lwk:=ord(s2[2])-ord('0');
        cwq:=ord(s3[1])-ord('a')+1;
        lwq:=ord(s3[2])-ord('0');

        minarea:=100;

        { Try to move the white king }
        di:=distance(cwk,lwk,cbk,lbk);
        mind:=di;

        for mm:=1 to 8 do
          begin
            cwk:=cwk+dc[mm]; lwk:=lwk+dl[mm];
            dd:=distance(cwk,lwk,cbk,lbk);

            if (cwk>0) and (cwk<9) and (lwk>0) and (lwk<9) and
               ((abs(cwk-cbk)>1) or (abs(lwk-lbk)>1)) and
               ((cwk<>cwq) or (lwk<>lwq)) and
               (
               ((abs(cwq-cbk)>1) or (abs(lwq-lbk)>1)) or
               ((abs(cwq-cwk)<=1) and (abs(lwq-lwk)<=1))
               ) and (dd<=di) and (min[cbk,lbk,cwk,lwk]^[cwq,lwq]=0)
            then
              begin
                tip:=1; newc:=cwk; newl:=lwk;
                evalmove;
              end;

            cwk:=cwk-dc[mm]; lwk:=lwk-dl[mm];
          end;

        { Try to move the white queen }
        fillchar(dir,sizeof(dir),true);

        for len:=1 to 7 do
          for mm:=1 to 8 do
            if (dir[mm]) then
              begin
                cwq:=cwq+len*dc[mm]; lwq:=lwq+len*dl[mm];

                if (cwq>0) and (cwq<9) and (lwq>0) and (lwq<9) and
                    ((cwq<>cwk) or (lwq<>lwk)) and
                    ((cwq<>cbk) or (lwq<>lbk)) then
                  begin
                    if ((abs(cwq-cbk)>1) or (abs(lwq-lbk)>1)) or
                       ((abs(cwq-cwk)<=1) and (abs(lwq-lwk)<=1)) then
                      begin
                        tip:=2; newc:=cwq; newl:=lwq;
                        evalmove;
                      end;
                  end
                else
                  dir[mm]:=false;

                cwq:=cwq-len*dc[mm]; lwq:=lwq-len*dl[mm];
              end;

        if (tact=1) then
          begin
            s2:=chr(actc+ord('a')-1)+chr(actl+48);
            MoveWhiteKing(s2);
          end
        else
          begin
            s3:=chr(actc+ord('a')-1)+chr(actl+48);
            MoveWhiteQueen(s3);
          end;
      end
    else
    if (stage=2) then
      begin
        s2:=GetWhiteKingPosition;
        s3:=GetWhiteQueenPosition;
        cwk:=ord(s2[1])-ord('a')+1;
        lwk:=ord(s2[2])-ord('0');
        cwq:=ord(s3[1])-ord('a')+1;
        lwq:=ord(s3[2])-ord('0');

        { Try to move the white queen }
        fillchar(dir,sizeof(dir),true);

        minarea:=100;
        for len:=1 to 7 do
          for mm:=1 to 8 do
            if (dir[mm]) then
              begin
                cwq:=cwq+len*dc[mm]; lwq:=lwq+len*dl[mm];

                if (cwq>0) and (cwq<9) and (lwq>0) and (lwq<9) and
                    ((cwq<>cwk) or (lwq<>lwk)) and
                    ((cwq<>cbk) or (lwq<>lbk)) then
                  begin
                    if ((abs(cwq-cbk)>1) or (abs(lwq-lbk)>1)) or
                       ((abs(cwq-cwk)<=1) and (abs(lwq-lwk)<=1)) then
                      begin
                        tip:=2; newc:=cwq; newl:=lwq;
                        evalmove;
                      end;
                  end
                else
                  dir[mm]:=false;

                cwq:=cwq-len*dc[mm]; lwq:=lwq-len*dl[mm];
              end;

        s3:=chr(actc+ord('a')-1)+chr(actl+48);
        MoveWhiteQueen(s3);

        stage:=4;
      end
    else
    if (stage=6) then
      begin
        { Special case solved by Tree modelling - to avoid a draw }
        tact:=0;
        findmove;

        if (tact=1) then
          begin
            s2:=chr(actc+ord('a')-1)+chr(actl+48);
            MoveWhiteKing(s2);
          end
        else
          begin
            s3:=chr(actc+ord('a')-1)+chr(actl+48);
            MoveWhiteQueen(s3);
          end;
      end
    else
    if (stage=4) then
      begin
        s2:=GetWhiteKingPosition;
        s3:=GetWhiteQueenPosition;
        cwk:=ord(s2[1])-ord('a')+1;
        lwk:=ord(s2[2])-ord('0');
        cwq:=ord(s3[1])-ord('a')+1;
        lwq:=ord(s3[2])-ord('0');

        { Try to move the white king }
        minarea:=100;
        mind:=100;

        for mm:=1 to 8 do
          begin
            cwk:=cwk+dc[mm]; lwk:=lwk+dl[mm];
            dd:=distance(cwk,lwk,cbk,lbk);

            if (cwk>0) and (cwk<9) and (lwk>0) and (lwk<9) and
               ((abs(cwk-cbk)>1) or (abs(lwk-lbk)>1)) and
               ((cwk<>cwq) or (lwk<>lwq)) and
               (
               ((abs(cwq-cbk)>1) or (abs(lwq-lbk)>1)) or
               ((abs(cwq-cwk)<=1) and (abs(lwq-lwk)<=1))
               ) and (min[cbk,lbk,cwk,lwk]^[cwq,lwq]=0)
            then
              begin
                tip:=1; newc:=cwk; newl:=lwk;
                evalmove;
              end;

            cwk:=cwk-dc[mm]; lwk:=lwk-dl[mm];
          end;

        s2:=chr(actc+ord('a')-1)+chr(actl+48);
        MoveWhiteKing(s2);

        { Verify whether you may reach stage 5 }
        s2:=GetWhiteKingPosition;
        s3:=GetWhiteQueenPosition;
        cwk:=ord(s2[1])-ord('a')+1;
        lwk:=ord(s2[2])-ord('0');
        cwq:=ord(s3[1])-ord('a')+1;
        lwq:=ord(s3[2])-ord('0');

        { Try to move the white queen }
        fillchar(dir,sizeof(dir),true);

        minarea:=100;
        for len:=1 to 7 do
          for mm:=1 to 8 do
            if (dir[mm]) then
              begin
                cwq:=cwq+len*dc[mm]; lwq:=lwq+len*dl[mm];

                if (cwq>0) and (cwq<9) and (lwq>0) and (lwq<9) and
                    ((cwq<>cwk) or (lwq<>lwk)) and
                    ((cwq<>cbk) or (lwq<>lbk)) then
                  begin
                    if ((abs(cwq-cbk)>1) or (abs(lwq-lbk)>1)) or
                       ((abs(cwq-cwk)<=1) and (abs(lwq-lwk)<=1)) then
                      begin
                        tip:=2; newc:=cwq; newl:=lwq;
                        evalmove;
                      end;
                  end
                else
                  dir[mm]:=false;

                cwq:=cwq-len*dc[mm]; lwq:=lwq-len*dl[mm];
              end;

        if (minarea=0) then
          stage:=5;
      end
    else
    if (stage=5) then
      begin
        s2:=GetWhiteKingPosition;
        s3:=GetWhiteQueenPosition;
        cwk:=ord(s2[1])-ord('a')+1;
        lwk:=ord(s2[2])-ord('0');
        cwq:=ord(s3[1])-ord('a')+1;
        lwq:=ord(s3[2])-ord('0');

        { Try to move the white queen }
        fillchar(dir,sizeof(dir),true);

        minarea:=100;
        for len:=1 to 7 do
          for mm:=1 to 8 do
            if (dir[mm]) then
              begin
                cwq:=cwq+len*dc[mm]; lwq:=lwq+len*dl[mm];

                if (cwq>0) and (cwq<9) and (lwq>0) and (lwq<9) and
                    ((cwq<>cwk) or (lwq<>lwk)) and
                    ((cwq<>cbk) or (lwq<>lbk)) then
                  begin
                    if ((abs(cwq-cbk)>1) or (abs(lwq-lbk)>1)) or
                       ((abs(cwq-cwk)<=1) and (abs(lwq-lwk)<=1)) then
                      begin
                        tip:=2; newc:=cwq; newl:=lwq;
                        evalmove;
                      end;
                  end
                else
                  dir[mm]:=false;

                cwq:=cwq-len*dc[mm]; lwq:=lwq-len*dl[mm];
               end;

        s3:=chr(actc+ord('a')-1)+chr(actl+48);
        MoveWhiteQueen(s3);
      end;

    s2:=GetWhiteKingPosition;
    s3:=GetWhiteQueenPosition;
    cwk:=ord(s2[1])-ord('a')+1;
    lwk:=ord(s2[2])-ord('0');
    cwq:=ord(s3[1])-ord('a')+1;
    lwq:=ord(s3[2])-ord('0');

    if (stage=1) or (stage=4) then
      min[cbk,lbk,cwk,lwk]^[cwq,lwq]:=1;

    { Move Black King }
    MoveBlackKing;
    s1:=GetBlackKingPosition;
    cbk:=ord(s1[1])-ord('a')+1;
    lbk:=ord(s1[2])-ord('0');

    if (stage=1) then
      begin
        s2:=GetWhiteKingPosition;
        s3:=GetWhiteQueenPosition;
        cwk:=ord(s2[1])-ord('a')+1;
        lwk:=ord(s2[2])-ord('0');
        cwq:=ord(s3[1])-ord('a')+1;
        lwq:=ord(s3[2])-ord('0');

        evalmove;
        if (area<>1) then
          stage:=1
        else
          stage:=2;
      end;

    mleft:=MovesLeft;
    if (stage=2) or ((stage<6) and (mleft<=4)) then
      begin
        maxniv:=0;

        repeat
          inc(maxniv);

          for c1:=1 to 8 do
            for l1:=1 to 8 do
              for c2:=1 to 8 do
                for l2:=1 to 8 do
                  begin
                    fillchar(min[c1,l1,c2,l2]^,sizeof(line),0);
                  end;

          niv:=0;
          play;
        until (min[cbk,lbk,cwk,lwk]^[cwq,lwq]<>255) or
              (maxniv=5);

        if (min[cbk,lbk,cwk,lwk]^[cwq,lwq]=255) then
          begin
            if (stage=2) then
              stage:=4;

            for c1:=1 to 8 do
              for l1:=1 to 8 do
                for c2:=1 to 8 do
                  for l2:=1 to 8 do
                    begin
                      fillchar(min[c1,l1,c2,l2]^,sizeof(line),0);
                    end;
          end
        else
          stage:=6;
      end;
  end;
end.