{ Mugurel Ionut Andreica - Bucuresti, ROMANIA }

{$N+,S-,I-,R-,Q-}
{$M 30000,0,655360}
Program _3D_Primes;

const filein='3D.in';
      fileout='3D.out';
      prime:array[1..9] of byte=(2,3,5,7,11,13,17,19,23);
      closestprime:array[0..26] of byte=
(0,0,2,3,3,5,5,7,7,7,7,11,11,13,13,13,13,17,17,17,17,17,17,17,17,17,17);
      MAXN=32;

type cube=array[1..MAXN,1..MAXN,1..MAXN] of byte;
     pcube=^cube;

var am,an,ap:pcube;
    i,j,k,i1,j1,k1,m,n,p,m1,n1,p1,sm,sn,sp:longint;
    max,sm1,sn1,sp1,sm2,sn2,sp2,nvec,npr,l:longint;
    sw:boolean;

procedure greedym;
begin
new(am);
fillchar(am^,sizeof(cube),0);

for i:=1 to m do
  for j:=1 to n do
    for k:=1 to p do
      begin
        nvec:=0;
        for i1:=i-1 to i+1 do
          for j1:=j-1 to j+1 do
            for k1:=k-1 to k+1 do
              if ((i1<>i) or (j1<>j) or (k1<>k)) and
                 (i1>=1) and (i1<=m) and (j1>=1) and
                 (j1<=n) and (k1>=1) and (k1<=p) then inc(nvec);

        am^[i,j,k]:=closestprime[nvec];
      end;

l:=1;
while (l<=m) do
  begin
    repeat
      sw:=false;

      for i:=l to l+1 do
        for j:=1 to n do
          for k:=1 to p do
            if (am^[i,j,k]>0) then
              begin
                npr:=0;
                for i1:=i-1 to i+1 do
                  for j1:=j-1 to j+1 do
                    for k1:=k-1 to k+1 do
                      if ((i1<>i) or (j1<>j) or (k1<>k)) and
                         (i1>=1) and (i1<=m) and (j1>=1) and
                         (j1<=n) and (k1>=1) and (k1<=p) then
                        begin
                          if (npr=am^[i,j,k]) then
                            begin
                              if (am^[i1,j1,k1]>0) then
                                begin
                                  am^[i1,j1,k1]:=0;
                                  sw:=true;
                                end;
                            end
                          else
                          if (am^[i1,j1,k1]>0) then
                            inc(npr);
                        end;

                if (npr<am^[i,j,k]) then
                  begin
                    am^[i,j,k]:=closestprime[npr];
                    sw:=true;
                  end;
              end;

    until (not sw);

    l:=l+3;
  end;

repeat
  sw:=false;

  for i:=1 to m1 do
    for j:=1 to n1 do
      for k:=1 to p1 do
        if (am^[i,j,k]>0) then
          begin
            npr:=0;
            for i1:=i-1 to i+1 do
              for j1:=j-1 to j+1 do
                for k1:=k-1 to k+1 do
                  if ((i1<>i) or (j1<>j) or (k1<>k)) and
                     (i1>=1) and (i1<=m1) and (j1>=1) and
                     (j1<=n1) and (k1>=1) and (k1<=p1) then
                    begin
                      if (npr=am^[i,j,k]) then
                        begin
                          if (am^[i1,j1,k1]>0) then
                            begin
                              am^[i1,j1,k1]:=0;
                              sw:=true;
                            end;
                        end
                      else
                      if (am^[i1,j1,k1]>0) then
                        inc(npr);
                    end;

            if (npr<am^[i,j,k]) then
              begin
                am^[i,j,k]:=closestprime[npr];
                sw:=true;
              end;
          end;

until (not sw);

for i:=1 to m1 do
  for j:=1 to n1 do
    for k:=1 to p1 do
      if (am^[i,j,k]=0) then
        begin
          nvec:=0;
          for i1:=i-1 to i+1 do
            for j1:=j-1 to j+1 do
              for k1:=k-1 to k+1 do
                if ((i1<>i) or (j1<>j) or (k1<>k)) and
                   (i1>=1) and (i1<=m1) and (j1>=1) and
                   (j1<=n1) and (k1>=1) and (k1<=p1) and
                   (am^[i1,j1,k1]>0) and (am^[i1,j1,k1]=closestprime[am^[i1,j1,k1]])
                   then inc(nvec);

          if (closestprime[nvec]<>nvec) and (nvec<>19) and (nvec<>23) then
            am^[i,j,k]:=nvec;
        end;

sm:=0;
for i:=1 to m1 do
  for j:=1 to n1 do
    for k:=1 to p1 do
      sm:=sm+am^[i,j,k];
end;

procedure greedyn;
begin
new(an);
fillchar(an^,sizeof(cube),0);

for i:=1 to m do
  for j:=1 to n do
    for k:=1 to p do
      begin
        nvec:=0;
        for i1:=i-1 to i+1 do
          for j1:=j-1 to j+1 do
            for k1:=k-1 to k+1 do
              if ((i1<>i) or (j1<>j) or (k1<>k)) and
                 (i1>=1) and (i1<=m) and (j1>=1) and
                 (j1<=n) and (k1>=1) and (k1<=p) then inc(nvec);

        an^[i,j,k]:=closestprime[nvec];
      end;

l:=1;
while (l<=n) do
  begin
    repeat
      sw:=false;

      for j:=l to l+1 do
        for i:=1 to m do
          for k:=1 to p do
            if (an^[i,j,k]>0) then
              begin
                npr:=0;
                for j1:=j-1 to j+1 do
                  for i1:=i-1 to i+1 do
                    for k1:=k-1 to k+1 do
                      if ((i1<>i) or (j1<>j) or (k1<>k)) and
                         (i1>=1) and (i1<=m) and (j1>=1) and
                         (j1<=n) and (k1>=1) and (k1<=p) then
                        begin
                          if (npr=an^[i,j,k]) then
                            begin
                              if (an^[i1,j1,k1]>0) then
                                begin
                                  an^[i1,j1,k1]:=0;
                                  sw:=true;
                                end;
                            end
                          else
                          if (an^[i1,j1,k1]>0) then
                            inc(npr);
                        end;

                if (npr<an^[i,j,k]) then
                  begin
                    an^[i,j,k]:=closestprime[npr];
                    sw:=true;
                  end;
              end;

    until (not sw);

    l:=l+3;
  end;

repeat
  sw:=false;

  for j:=1 to n1 do
    for i:=1 to m1 do
      for k:=1 to p1 do
        if (an^[i,j,k]>0) then
          begin
            npr:=0;
            for j1:=j-1 to j+1 do
              for i1:=i-1 to i+1 do
                for k1:=k-1 to k+1 do
                  if ((i1<>i) or (j1<>j) or (k1<>k)) and
                     (i1>=1) and (i1<=m1) and (j1>=1) and
                     (j1<=n1) and (k1>=1) and (k1<=p1) then
                    begin
                      if (npr=an^[i,j,k]) then
                        begin
                          if (an^[i1,j1,k1]>0) then
                            begin
                              an^[i1,j1,k1]:=0;
                              sw:=true;
                            end;
                        end
                      else
                      if (an^[i1,j1,k1]>0) then
                        inc(npr);
                    end;

            if (npr<an^[i,j,k]) then
              begin
                an^[i,j,k]:=closestprime[npr];
                sw:=true;
              end;
          end;

until (not sw);

for i:=1 to m1 do
  for j:=1 to n1 do
    for k:=1 to p1 do
      if (an^[i,j,k]=0) then
        begin
          nvec:=0;
          for i1:=i-1 to i+1 do
            for j1:=j-1 to j+1 do
              for k1:=k-1 to k+1 do
                if ((i1<>i) or (j1<>j) or (k1<>k)) and
                   (i1>=1) and (i1<=m1) and (j1>=1) and
                   (j1<=n1) and (k1>=1) and (k1<=p1) and
                   (an^[i1,j1,k1]>0) and (an^[i1,j1,k1]=closestprime[an^[i1,j1,k1]])
                   then inc(nvec);

          if (closestprime[nvec]<>nvec) and (nvec<>19) and (nvec<>23) then
            an^[i,j,k]:=nvec;
        end;

sn:=0;
for i:=1 to m1 do
  for j:=1 to n1 do
    for k:=1 to p1 do
      sn:=sn+an^[i,j,k];
end;

procedure greedyp;
begin
new(ap);
fillchar(ap^,sizeof(cube),0);

for i:=1 to m do
  for j:=1 to n do
    for k:=1 to p do
      begin
        nvec:=0;
        for i1:=i-1 to i+1 do
          for j1:=j-1 to j+1 do
            for k1:=k-1 to k+1 do
              if ((i1<>i) or (j1<>j) or (k1<>k)) and
                 (i1>=1) and (i1<=m) and (j1>=1) and
                 (j1<=n) and (k1>=1) and (k1<=p) then inc(nvec);

        ap^[i,j,k]:=closestprime[nvec];
      end;

l:=1;
while (l<=p) do
  begin
    repeat
      sw:=false;

      for k:=l to l+1 do
        for i:=1 to m do
          for j:=1 to n do
            if (ap^[i,j,k]>0) then
              begin
                npr:=0;
                for k1:=k-1 to k+1 do
                  for j1:=j-1 to j+1 do
                    for i1:=i-1 to i+1 do
                      if ((i1<>i) or (j1<>j) or (k1<>k)) and
                         (i1>=1) and (i1<=m) and (j1>=1) and
                         (j1<=n) and (k1>=1) and (k1<=p) then
                        begin
                          if (npr=ap^[i,j,k]) then
                            begin
                              if (ap^[i1,j1,k1]>0) then
                                begin
                                  ap^[i1,j1,k1]:=0;
                                  sw:=true;
                                end;
                            end
                          else
                          if (ap^[i1,j1,k1]>0) then
                            inc(npr);
                        end;

                if (npr<ap^[i,j,k]) then
                  begin
                    ap^[i,j,k]:=closestprime[npr];
                    sw:=true;
                  end;
              end;

    until (not sw);

    l:=l+3;
  end;

repeat
  sw:=false;

  for k:=1 to p1 do
    for i:=1 to m1 do
      for j:=1 to n1 do
        if (ap^[i,j,k]>0) then
          begin
            npr:=0;
            for k1:=k-1 to k+1 do
              for j1:=j-1 to j+1 do
                for i1:=i-1 to i+1 do
                  if ((i1<>i) or (j1<>j) or (k1<>k)) and
                     (i1>=1) and (i1<=m1) and (j1>=1) and
                     (j1<=n1) and (k1>=1) and (k1<=p1) then
                    begin
                      if (npr=ap^[i,j,k]) then
                        begin
                          if (ap^[i1,j1,k1]>0) then
                            begin
                              ap^[i1,j1,k1]:=0;
                              sw:=true;
                            end;
                        end
                      else
                      if (ap^[i1,j1,k1]>0) then
                        inc(npr);
                    end;

            if (npr<ap^[i,j,k]) then
              begin
                ap^[i,j,k]:=closestprime[npr];
                sw:=true;
              end;
          end;

until (not sw);

for i:=1 to m1 do
  for j:=1 to n1 do
    for k:=1 to p1 do
      if (ap^[i,j,k]=0) then
        begin
          nvec:=0;
          for i1:=i-1 to i+1 do
            for j1:=j-1 to j+1 do
              for k1:=k-1 to k+1 do
                if ((i1<>i) or (j1<>j) or (k1<>k)) and
                   (i1>=1) and (i1<=m1) and (j1>=1) and
                   (j1<=n1) and (k1>=1) and (k1<=p1) and
                   (ap^[i1,j1,k1]>0) and (ap^[i1,j1,k1]=closestprime[ap^[i1,j1,k1]])
                   then inc(nvec);

          if (closestprime[nvec]<>nvec) and (nvec<>19) and (nvec<>23) then
            ap^[i,j,k]:=nvec;
        end;

sp:=0;
for i:=1 to m1 do
  for j:=1 to n1 do
    for k:=1 to p1 do
      sp:=sp+ap^[i,j,k];
end;

begin
assign(input,filein);
reset(input);
read(m,n,p);
m1:=m; n1:=n; p1:=p;
close(input);

sm:=0; sn:=0; sp:=0;

if (m=1) or (n=1) or (p=1) then
  begin
    greedym;
    greedyn;
    greedyp;
    sm1:=sm; sn1:=sn; sp1:=sp;

    max:=sm1;
    if (sn1>max) then max:=sn1;
    if (sp1>max) then max:=sp1;


    assign(output,fileout);
    rewrite(output);

    if (sm>=sn) and (sm>=sp) then
      begin
        for i:=1 to m do
          for j:=1 to n do
            for k:=1 to p do
              writeln(am^[i,j,k]);
      end
    else
    if (sn>=sm) and (sn>=sp) then
      begin
        for i:=1 to m do
          for j:=1 to n do
            for k:=1 to p do
              writeln(an^[i,j,k]);
      end
    else
      begin
        for i:=1 to m do
          for j:=1 to n do
            for k:=1 to p do
              writeln(ap^[i,j,k]);
      end;
    close(output);

    dispose(am);
    dispose(an);
    dispose(ap);

    if (n>1) then
      begin
        dec(n);
        greedym;
        sm2:=sm;
        inc(n);
      end
    else
      begin
        dec(p);
        greedym;
        sm2:=sm;
        inc(p);
      end;

    if (m>1) then
      begin
        dec(m);
        greedyn;
        sn2:=sn;
        inc(m);
      end
    else
      begin
        dec(p);
        greedyn;
        sn2:=sn;
        inc(p);
      end;

    if (n>1) then
      begin
        dec(n);
        greedyp;
        sp2:=sp;
        inc(n);
      end
    else
      begin
        dec(m);
        greedyp;
        sp2:=sp;
        inc(m);
      end;

    if (sm2>=sn2) and (sm2>=sp2) and (sm2>max) then
      begin
        assign(output,fileout);
        rewrite(output);

        for i:=1 to m do
          for j:=1 to n do
            for k:=1 to p do
              writeln(am^[i,j,k]);

        close(output);
      end
    else
    if (sn2>=sm2) and (sn2>=sp2) and (sn2>max) then
      begin
        assign(output,fileout);
        rewrite(output);

        for i:=1 to m do
          for j:=1 to n do
            for k:=1 to p do
              writeln(an^[i,j,k]);

        close(output);
      end
    else
    if (sp2>=sm2) and (sp2>=sn2) and (sp2>max) then
      begin
        assign(output,fileout);
        rewrite(output);

        for i:=1 to m do
          for j:=1 to n do
            for k:=1 to p do
              writeln(ap^[i,j,k]);

        close(output);
      end;
  end
else
  begin
    greedym;
    if (n<>m) then
      greedyn;

    if (p<>m) and (p<>n) then
      greedyp;

    assign(output,fileout);
    rewrite(output);

    if (sm>=sn) and (sm>=sp) then
      begin
        for i:=1 to m do
          for j:=1 to n do
            for k:=1 to p do
              writeln(am^[i,j,k]);
      end
    else
    if (sn>=sm) and (sn>=sp) then
      begin
        for i:=1 to m do
          for j:=1 to n do
            for k:=1 to p do
              writeln(an^[i,j,k]);
      end
    else
      begin
        for i:=1 to m do
          for j:=1 to n do
            for k:=1 to p do
              writeln(ap^[i,j,k]);
      end;

    close(output);
  end;
end.