{ Mugurel Ionut Andreica - Bucuresti, ROMANIA }

{$S-,I-,R-,Q-,N+}
{$M 65000,0,655360}
Program _stargate_;

const MAXN=500;
      filein='stargate.in';
      fileout='stargate.out';
      BUFSIZE=50000;
      infinit=1000000000;
      maxrand=100;
      prime=29989;
      maxtry=1000;
      maxprod=8000000;
      maxiter=2000;
      timelimit=17;

type row=array[1..MAXN] of byte;
     prow=^row;
     plist=^list;
     list=record
            num:longint;
            urm:plist;
          end;

var a:array[1..MAXN] of prow;
    cycle,cmin,cycint,tata,next:array[1..MAXN] of longint;
    used:array[1..MAXN] of boolean;
    edge:array[1..MAXN] of plist;
    i,j,i1,j1,k,m,p,p1,poz1,n,cact,cbest,cint,cnew,ntry,niter:longint;
    co,co1,shortest:byte;
    found,notimproved:boolean;
    aux:plist;

    t2:longint absolute 0:$046c;
    t1:longint;


procedure readinput;
var fin:text;
    buffer:array[1..BUFSIZE] of char;
begin
assign(fin,filein);
reset(fin);
read(fin,n);

for i:=1 to n do
  begin
    new(a[i]);
    fillchar(a[i]^,sizeof(row),0);
  end;

while (not seekeof(fin)) do
  begin
    read(fin,i,j,co);
    a[i]^[j]:=co;
    a[j]^[i]:=co;
  end;

close(fin);
end;

procedure writeoutput;
var fout:text;
begin
assign(fout,fileout);
rewrite(fout);
writeln(fout,cbest);
for i:=1 to n do
  write(fout,cmin[i],' ');
writeln(fout,1);
close(fout);
{
writeln(t2-t1);
}
halt(0);
end;

procedure bkt(niv:byte);
var s:byte;
begin
if (niv=n+1) then
  begin
    co:=a[cycle[n]]^[1];
    cact:=cact+co;

    if (co>0) and (cact<cbest) then
      begin
        cbest:=cact;
        for i:=1 to n do
          cmin[i]:=cycle[i];
      end;

    if (t2-t1>=timelimit) then
      writeoutput;

    cact:=cact-co;
  end
else
  begin
    for s:=1 to n do
      if (not used[s]) and (a[cycle[niv-1]]^[s]>0) then
        begin
          cycle[niv]:=s;
          used[s]:=true;
          cact:=cact+a[cycle[niv-1]]^[s];

          if (cact<cbest) then
            bkt(niv+1);

          cact:=cact-a[cycle[niv-1]]^[s];
          used[s]:=false;
        end;
  end;
end;

procedure randomcycles;
begin
randseed:=(((n+13) shl 8) xor 32457) mod prime;
for k:=1 to maxrand do
  begin
    fillchar(used,sizeof(used),false);
    cycle[1]:=1; used[1]:=true;

    cact:=0;
    for i:=2 to n do
      begin
        ntry:=0;
        repeat
          j:=random(n)+1;
          co:=a[cycle[i-1]]^[j];
        until ((not used[j]) and (co>0)) or
              (ntry=maxtry);

        if (ntry=maxtry) then
          break;

        used[j]:=true;
        cycle[i]:=j;
        cact:=cact+co;
      end;

    if (ntry=maxtry) then
      continue;

    co:=a[cycle[n]]^[1];
    if (co>0) then
      begin
        cact:=cact+co;
        if (cact<cbest) then
          begin
            cbest:=cact;
            for i:=1 to n do
              cmin[i]:=cycle[i];
          end;
      end;
  end;
end;

procedure swapedges;
begin
niter:=0;
repeat
  notimproved:=true;
  cint:=cact;

  for i:=1 to n-2 do
    for j:=i+2 to n do
      begin
        if (i=1) and (j=n) then
          continue;

        co:=a[cycle[i]]^[cycle[j]];
        co1:=a[cycle[next[i]]]^[cycle[next[j]]];

        if (co>0) and (co1>0) then
          begin
            cnew:=cact-a[cycle[i]]^[cycle[next[i]]]-
                       a[cycle[j]]^[cycle[next[j]]]+
                       co+co1;

            if (cnew<cint) then
              begin
                cint:=cnew;
                notimproved:=false;
                i1:=i; j1:=j;
              end;
          end;
      end;

  if (notimproved=false) then
    begin
      cact:=cint;
      for i:=1 to i1 do
        cycint[i]:=cycle[i];

      m:=i1;
      for i:=j1 downto i1+1 do
        begin
          inc(m);
          cycint[m]:=cycle[i];
        end;

      for i:=j1+1 to n do
        begin
          inc(m);
          cycint[m]:=cycle[i];
        end;

      for i:=1 to n do
        cycle[i]:=cycint[i];
    end;

  inc(niter);
until (niter=maxiter) or (notimproved) or (t2-t1>=timelimit);

if (cint<cbest) then
  begin
    cbest:=cint;
    for i:=1 to n do
      cmin[i]:=cycle[i];
  end;
end;


procedure shortestedgefirst;
begin
for i:=1 to n-1 do
  next[i]:=i+1;
next[n]:=1;

for k:=1 to n do
  begin
    fillchar(used,sizeof(used),false);
    cycle[1]:=k; used[k]:=true;

    p1:=1;

    cact:=0;
    for j:=2 to n do
      begin
        found:=false;
        shortest:=255;
        for i:=1 to n do
          if (not used[i]) then
            begin
              co:=a[cycle[j-1]]^[i];
              if (co<=shortest) and (co>0) then
                begin
                  shortest:=co;
                  found:=true;
                  cycle[j]:=i;
                end;
            end;

        if (not found) then
          break;

        used[cycle[j]]:=true;
        cact:=cact+shortest;

        if (cycle[j]=1) then
          p1:=j;
      end;

    if (not found) then
      continue;

    co:=a[cycle[n]]^[cycle[1]];
    if (co>0) then
      begin
        cact:=cact+co;

        for i:=p1 to n do
          cycint[i-p1+1]:=cycle[i];

        for i:=1 to p1-1 do
          cycint[n-p1+1+i]:=cycle[i];

        for i:=1 to n do
          cycle[i]:=cycint[i];

        swapedges;
      end;

    if (t2-t1>=timelimit) then
      writeoutput;
  end;
end;

procedure df(nod:longint);
var aa:plist;
    i:longint;
begin
used[nod]:=true;
inc(m);
cycle[m]:=nod;

if (nod=1) then
  p1:=m;

aa:=edge[nod];
while (aa<>nil) do
  begin
    i:=aa^.num;
    if (not used[i]) then
      df(i);

    aa:=aa^.urm;
  end;
end;

procedure apm; { the greedy algorithm which is very useful if the
                 costs of the edges form a metric }
begin
{ In this procedure, the array "cycle" is first used as
  an array to store distances }

fillchar(used,sizeof(used),false);
for i:=1 to n do
  begin
    edge[i]:=nil;
    cycle[i]:=infinit;
  end;

m:=1; p:=1;
used[1]:=true;
cycle[1]:=0;
found:=true;
cact:=0;

while (found) do
  begin
    for i:=2 to n do
      if (not used[i]) then
        begin
          co:=a[p]^[i];
          if (co<cycle[i]) and (co>0) then
            begin
              cycle[i]:=co;
              tata[i]:=p;
            end;
        end;

    found:=false;
    cint:=infinit;

    for i:=2 to n do
      if (not used[i]) and (cycle[i]<cint) then
        begin
          cint:=cycle[i];
          found:=true;
          p:=i;
        end;

    if (found) then
      begin
        cact:=cact+cint;
        used[p]:=true;
        inc(m);

        new(aux);
        aux^.num:=tata[p];
        aux^.urm:=edge[p];
        edge[p]:=aux;

        new(aux);
        aux^.num:=p;
        aux^.urm:=edge[tata[p]];
        edge[tata[p]]:=aux;
      end;
  end;

if (m=n) then
  begin
    cint:=infinit;
    for k:=1 to n do
      begin
        fillchar(used,sizeof(used),false);
        cact:=0;
        m:=0;

        df(k);

        found:=true;
        for i:=2 to n do
          begin
            co:=a[cycle[i-1]]^[cycle[i]];
            if (co=0) then
              begin
                found:=false;
                break;
              end;

            cact:=cact+co;
          end;

        co:=a[cycle[n]]^[cycle[1]];
        if (co>0) and (found) then
          begin
            cact:=cact+co;
            if (cact<cint) then
              begin
                cint:=cact;
                for i:=1 to n do
                  cycint[i]:=cycle[i];
                poz1:=p1;
              end;
          end;
      end;

    if (cint<cbest) then
      begin
        cbest:=cint;

        for i:=poz1 to n do
          cmin[i-poz1+1]:=cycint[i];

        for i:=1 to poz1-1 do
          cmin[n-poz1+1+i]:=cycint[i];
      end;
  end;
end;

begin
t1:=t2;

readinput;

if (n<=11) then
  begin
    { If N is at most 11, then I use exhaustive search }

    cbest:=infinit;
    cact:=0;

    fillchar(used,sizeof(used),false);

    cycle[1]:=1;
    used[1]:=true;

    bkt(2);

    writeoutput;
  end
else
  begin
    { If N is greater than 11, then I use several greedy methods }
    cbest:=infinit;

    randomcycles;
    apm;
    shortestedgefirst;
    writeoutput;
  end;
end.