{ Mugurel Ionut Andreica - Bucuresti, ROMANIA }

{ Number of comparisons made: N-1 + [logN]-1 + [loglogN]-1 + O(logN) }

Program _maxime_;
uses max;

const MAXN=255;
      maxlevel=10;

type tree=array[1..MAXN,1..maxlevel,0..2] of integer;

var list,list2:array[1..MAXN] of integer;
    t1,t2:tree;
    i,k,p,n,m1,m2,m3,l1,l2,nel,ncomp:integer;

function maimare(i,j:integer):boolean;
var nco:integer;
begin
inc(ncomp);

nco:=GetNoComp;
if (nco>0) then
  maimare:=IsGreater(i,j)
else
  maimare:=false;
end;

procedure buildtree(n:integer;findmax2:boolean;var m1:integer;
                    var m2:integer;var t:tree;var nlevel:integer);
var i,j,p,nel,newnel:integer;
begin
for p:=1 to n do
  t[p,1,0]:=list[p];

k:=1; nel:=n;
while (nel>1) do
  begin
    newnel:=0;
    for p:=1 to (nel shr 1) do
      begin
        i:=t[2*p-1,k,0];
        j:=t[2*p,k,0];

        inc(newnel);
        if (maimare(i,j)) then
          begin
            t[newnel,k+1,0]:=i;
            t[newnel,k+1,1]:=2*p-1;
            t[newnel,k+1,2]:=j;
          end
        else
          begin
            t[newnel,k+1,0]:=j;
            t[newnel,k+1,1]:=2*p;
            t[newnel,k+1,2]:=i;
          end;
      end;

    if (nel and 1=1) then
      begin
        inc(newnel);
        t[newnel,k+1,0]:=t[nel,k,0];
        t[newnel,k+1,1]:=nel;
        t[newnel,k+1,2]:=0;
      end;

    inc(k);
    nel:=newnel;
  end;
nlevel:=k;

{ This is the maximum element }
m1:=t[1,k,0];

{ Find logN-1 potential second maximum elements }
p:=1; nel:=0;
while (k>1) do
  begin
    if (t[p,k,2]>0) then
      begin
        inc(nel);
        list2[nel]:=t[p,k,2];
      end;

    p:=t[p,k,1];
    dec(k);
  end;

if (findmax2) then
  begin
    { Cauta al doilea maxim }
    if (nel>=1) then
      begin
        m2:=list2[1];
        for k:=2 to nel do
          if (maimare(list2[k],m2)) then
            m2:=list2[k];
      end;
  end
else
  k:=nel;
end;

begin
Init;
n:=GetN;

fillchar(t1,sizeof(t1),0);
fillchar(t2,sizeof(t2),0);
m1:=0; m2:=0; m3:=0;
ncomp:=0;

for i:=1 to n do
  list[i]:=i;
buildtree(n,false,m1,m2,t1,l1);

for i:=1 to k do
  list[i]:=list2[i];
buildtree(k,true,m2,m3,t2,l2);

{ Locate M2 in T1 }
p:=1;
while (l1>1) do
  begin
    if (t1[p,l1,2]=m2) then
      begin
        for i:=1 to n do
          if (t1[i,l1-1,0]=m2) then
            begin
              p:=i; dec(l1); break;
            end;
         break;
      end;

    p:=t1[p,l1,1];
    dec(l1);
  end;

{ Search for M3 in M2's subtree in T1 }
nel:=0;
while (l1>1) do
  begin
    if (t1[p,l1,2]>0) then
      begin
        inc(nel);
        list2[nel]:=t1[p,l1,2];
      end;

    p:=t1[p,l1,1];
    dec(l1);
  end;

if (m3=0) then
  begin
    m3:=list2[1];
    p:=2;
  end
else
  p:=1;

if (nel>=1) then
  begin
    for i:=p to nel do
      if (maimare(list2[i],m3)) then
        m3:=list2[i];
  end;

Max1(m1);
Max2(m2);
Max3(m3);
EndProgram;
end.