{$A+,B-,D+,E+,F-,G-,I+,L+,N-,O-,P-,Q-,R-,S+,T-,V+,X+,Y+}
{$M 16384,0,655360}
{
This is a demo for the MAX.PAS Pascal unit.
It will not be used during the evaluation process.
Please do not use in your program the variables defined in this file!
  The variables in the unit used during the evaluation process have
  different identifiers, so your source might not be compiled correctly!
The time needed for the execution of the functions and procedures in the unit
  used for evaluation will be no longer than the time needed for the
  execution of the functions and procedures in this unit!
The unit uses the file MAX.TXT for initializing. You may edit your own MAX.TXT
  file in order to test your program! Your program must not try to open the
  MAX.TXT file for reading because this file will not exist during the evaluation.
  The unit used for evaluation will use a different method for getting the initial data!
This file is freeware. It cannot be modified, but can be distributed freely.
This file is distributed as-done.
The GInfo Editorial Staff is not responsible
  for any damage caused by the use of this file!
Author: Mihai Scortaru
Please report any bugs found in this file not later than
  Tuesday, April 8th, 2003!
}
unit max;

interface

procedure Init;
function GetN:Integer;
function GetNoComp:Integer;
function IsGreater(i,j:Integer):Boolean;
procedure Max1(x:Integer);
procedure Max2(x:Integer);
procedure Max3(x:Integer);
procedure EndProgram;

implementation

type IntegerArray=array[1..255] of Integer;
var  a:IntegerArray;
     N,callsLeft,noResults:Integer;
     initialized:boolean;
     ok1,ok2,ok3:boolean;
     m1,m2,m3:integer;

procedure error(s:string);
begin
  writeln(s);
  halt;
end;

function GetN:Integer;
begin
  if not initialized then
    error('Library not initialized!');
  GetN := N;
end;

function GetNoComp:Integer;
begin
  if not initialized then
    error('Library not initialized!');
  GetNoComp := callsLeft;
end;

function IsGreater(i,j:Integer):Boolean;
begin
  if not initialized then
    error('Library not initialized!');
  if (i<1) or (i>N) or  (j<1) or (j>N) then
    error('Invalid element!');
  if callsleft = 0 then
    error('Too many calls!');
  Dec(callsLeft);
  IsGreater := a[i] > a[j];
end;

procedure Init;
var i:Integer;
    f:text;
begin
 if initialized then
    error('Library already initialized!');
  initialized := true;
  noResults := 0;
  assign(f,'MAX.TXT');
  reset(f);
  readln(f,N);
  readln(f,callsLeft);
  for i:=1 to N do
    read(f,a[i]);
  readln(f,m1,m2,m3);
  close(f);
end;

procedure Max1(x:Integer);
begin
  if not initialized then
    error('Library already initialized!');
  if (x<1) or (x>N) then
    error('Invalid element!');
  if x<>m1 then
    error('Wrong answer!');
  if ok1 then
    error('Result submitted twice!');
  ok1:=true;
end;

procedure Max2(x:Integer);
begin
  if not initialized then
    error('Library already initialized!');
  if (x<1) or (x>N) then
    error('Invalid element!');
  if x<>m2 then
    error('Wrong answer!');
  if ok2 then
    error('Result submitted twice!');
  ok2:=true;
end;

procedure Max3(x:Integer);
begin
  if not initialized then
    error('Library already initialized!');
  if (x<1) or (x>N) then
    error('Invalid element!');
  if x<>m3 then
    error('Wrong answer!');
  if ok3 then
    error('Result submitted twice!');
  ok3:=true;
end;

procedure EndProgram;
begin
  if ok1 and ok2 and ok3 then
    error('Ok!')
  else
    error('Not all results were submitted!');
end;

end.