{$A+,B-,D+,E+,F-,G-,I-,L+,N+,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
{$M 16384,0,655360}

{ Time Complexity: O(N*N*M) }

Program _FOLD_;

const filein = 'FOLD.IN';
      fileout = 'FOLD.OUT';
      MAXN = 250;
      bit : array [0..7] of byte = (1,2,4,8,16,32,64,128);

type buffer = array [1..64000] of char;
     pbuffer = ^buffer;
     intlinie = array [0..MAXN] of integer;
     pintlinie = ^intlinie;
     bytelinie = array [0..MAXN] of byte;
     pbytelinie = ^bytelinie;

var buf : pbuffer;
    a : array [1..MAXN] of pbytelinie;
    count : array[1..MAXN] of pintlinie;
    col : array[1..MAXN] of boolean;
    i, j, k, m, n, p : integer;
    kk : longint;
    total : extended;
    fin, fout : text;

begin
assign(fin, filein);
new(buf);
settextbuf(fin, buf^, sizeof(buffer));
reset(fin);

read(fin, n, m);
for i := 1 to n do
  begin
    new(a[i]);
    fillchar(a[i]^, sizeof(bytelinie), 0);
    new(count[i]);
    fillchar(count[i]^, sizeof(intlinie), 0);
  end;

{ read the matrix }
for i := 1 to n do
  for j := 0 to m-1 do
    begin
      read(fin, k);
      if (k = 1) then
        a[i]^[j shr 3] := a[i]^[j shr 3] or bit[j and 7];
    end;
close(fin);

for j := 0 to m-1 do
  begin
    for i := 1 to n do
      if (a[i]^[j shr 3] and bit[j and 7] > 0) then
        col[i] := true
      else
        col[i] := false;

    for i := 1 to n-1 do
      if (col[i]) then
        for k := i+1 to n do
          if (col[k]) then
            inc(count[i]^[k]);
  end;

total := 0;
for i := 1 to n-1 do
  for j := i+1 to n do
    begin
      kk := count[i]^[j];
      kk := (kk*(kk-1)) shr 1;
      total := total + kk;
    end;

assign(fout, fileout);
rewrite(fout);
writeln(fout, total:0:0);
close(fout);
end.