{$R-,I-,S-,Q-}
{$M 65000, 0, 655360}

Program _HOLES_;

const filein = 'HOLES.IN';
      fileout = 'HOLES.OUT';
      MAXN = 101;
      dl : array [1..4] of integer = (-1, 0, +1, 0);
      dc : array [1..4] of integer = (0, +1, 0, -1);

var map : array[1..MAXN, 1..MAXN] of integer;
    nh, h : array [1..MAXN*MAXN] of integer;
    i, j, k, m, n, npos, ncomp, lnext, cnext, lin, col: longint;
    vmin, num : longint;
    bad : boolean;
    ch : char;

procedure fill;
var k : byte;
begin
if (map[lin][col] <> 0) then
  exit;

map[lin][col] := ncomp;
inc(npos);

if (lin = 1) or (col = 1) or (lin = m) or (col = n) then
  bad := true;

for k := 1 to 4 do
  begin
    lnext := lin+dl[k];
    cnext := col+dc[k];

    if (lnext >= 1) and (lnext <= m) and
       (cnext >= 1) and (cnext <= n) then
      begin
        lin := lin + dl[k];
        col := col + dc[k];

        fill;

        lin := lin - dl[k];
        col := col - dc[k];
      end;
  end;
end;

begin
{ read input data }
assign(input, filein);
reset(input);
read(m, n);
for i:= 1 to m do
  begin
    for j := 1 to n do
      begin
        ch := #0;
        repeat
          read(ch);
        until (ch = '0') or (ch = '1');

        if (ch = '0') then
          map[i][j] := 0
        else
          map[i][j] := -1;
      end;
  end;

{ do the fill }
fillchar(nh, sizeof(nh), 0);

ncomp := 0;
for i := 1 to m do
  for j := 1 to n do
    if (map[i][j] = 0) then
      begin
        ncomp := ncomp + 1;
        bad := false;
        npos := 0;

        lin := i;
        col := j;
        fill;

        if (not bad) then
          inc(nh[npos]);


        writeln(ncomp, ' -> ', npos);

      end;


{ trebuie determinat cmmmc al numerelor de elemente din fiecare gaura }


{ write output data }
assign(output, fileout);
rewrite(output);

{ afisaza cmmmc determinat }

close(output);
end.