{$A+,B-,D+,E+,F-,G-,I-,L+,N-,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
{$M 65000,0,655360}

Program _COLLECT_;

const filein = 'COLLECT.IN';
      fileout = 'COLLECT.OUT';
      MAXN = 50;
      maxobj = 130;
      infinit = 64000;
      dl : array [1..4] of integer = (-1, 0, +1, 0);
      dc : array [1..4] of integer = (0, +1, 0, -1);
      timelimit = 17;

type bytelinie = array [1..maxobj] of byte;
     pbytelinie = ^bytelinie;
     pq = ^q;
     q = record
           l, c : integer;
           urm : pq;
         end;

var a : array [1..MAXN, 1..MAXN] of char;
    out, di, objname : array [1..MAXN, 1..MAXN] of word;
    d : array [1..maxobj, 1..maxobj] of word;
    dord : array [1..maxobj] of pbytelinie;
    lO, cO : array [1..MAXN*MAXN] of byte;
    marcat : array [1..MAXN, 1..MAXN] of boolean;
    stk : array [1..MAXN*MAXN] of integer;
    i, j, k, m, n, p, lM, cM, nO, curr, next, nsel : integer;
    cst, cfin, aux : pq;
    tact, tmin : word;
    ch : char;

    t2 : longint absolute 0:$046c;
    t1 : longint;

    stop : boolean;

procedure printsol;
begin
assign(output, fileout);
rewrite(output);
writeln(tmin);
close(output);
halt(0);
end;

procedure bkt1(niv : integer);
var i, j : integer;
begin
if (t2 - t1 >= timelimit) then
  printsol;

if (niv = nO + 1) then
  begin
    tact := tact + out[lO[stk[nO]], cO[stk[nO]]];

    if (tact < tmin) then
      tmin := tact;

    tact := tact - out[lO[stk[nO]], cO[stk[nO]]];
  end
else
  begin
    for i := 2 to nO do
      begin
        j := dord[stk[niv-1]]^[i];

        if (not marcat[lO[j], cO[j]]) then
          begin
            marcat[lO[j], cO[j]] := true;
            tact := tact + d[stk[niv-1], j];

            if (tact < tmin) then
              begin
                stk[niv] := j;
                bkt1(niv+1);
              end
            else
              begin
                marcat[lO[j], cO[j]] := false;
                tact := tact - d[stk[niv-1], j];

                break;
              end;

            marcat[lO[j], cO[j]] := false;
            tact := tact - d[stk[niv-1], j];
          end;
      end;
  end;
end;

procedure addtoq(i, j : integer);
begin
if (cst = nil) then
  begin
    new(cst);
    cst^.l := i;
    cst^.c := j;
    cst^.urm := nil;
    cfin := cst;
  end
else
  begin
    new(aux);
    aux^.l := i;
    aux^.c := j;
    aux^.urm := nil;
    cfin^.urm := aux;
    cfin := aux;
  end;

out[i,j] := 1;
end;

procedure computeout;
var l, c, i, j, k, lnext, cnext : integer;
begin
for i := 1 to m do
  for j := 1 to n do
    out[i,j] := infinit;

cst := nil;
for i := 1 to m do
  begin
    if (a[i,1] = 'E') or (a[i,1] = 'O') then
      addtoq(i, 1);

    if (a[i,n] = 'E') or (a[i,n] ='O') then
      addtoq(i, n);
  end;

for j := 2 to n-1 do
  begin
    if (a[1,j] = 'E') or (a[1,j] = 'O') then
      addtoq(1, j);

    if (a[m,j] = 'E') or (a[m,j] = 'O') then
      addtoq(m, j);
  end;

while (cst <> nil) do
  begin
    l := cst^.l;
    c := cst^.c;

    for k := 1 to 4 do
      begin
        lnext := l + dl[k];
        cnext := c + dc[k];

        if (lnext >=1 ) and (lnext <= m) and (cnext >= 1) and (cnext <= n) and
          (out[lnext, cnext] = infinit) and
          ((a[lnext, cnext] = 'E') or (a[lnext, cnext] = 'O')) then
          begin
            out[lnext,cnext] := out[l,c] + 1;

            new(aux);
            aux^.l := lnext;
            aux^.c := cnext;
            aux^.urm := nil;

            cfin^.urm := aux;
            cfin := aux;
          end;
      end;

    aux := cst;
    cst := cst^.urm;
    dispose(aux);
  end;
end;

procedure computedist(o : integer);
var l, c, i, j, k, lnext, cnext : integer;
begin
for i := 1 to m do
  for j := 1 to n do
    di[i,j] := infinit;

new(cst);
cst^.l := lO[o];
cst^.c := cO[o];
cst^.urm := nil;
cfin := cst;

di[lO[o], cO[o]] := 0;

while (cst <> nil) do
  begin
    l := cst^.l;
    c := cst^.c;

    for k := 1 to 4 do
      begin
        lnext := l + dl[k];
        cnext := c + dc[k];

        if (lnext >=1 ) and (lnext <= m) and (cnext >= 1) and (cnext <= n) and
          (di[lnext, cnext] = infinit) and
          ((a[lnext, cnext] = 'E') or (a[lnext, cnext] = 'O')) then
          begin
            di[lnext,cnext] := di[l,c] + 1;

            new(aux);
            aux^.l := lnext;
            aux^.c := cnext;
            aux^.urm := nil;

            cfin^.urm := aux;
            cfin := aux;
          end;
      end;

    aux := cst;
    cst := cst^.urm;
    dispose(aux);
  end;

for i := 1 to nO do
  d[o, i] := di[lO[i], cO[i]];
end;

function computedist2(o : integer) : integer;
var l, c, i, j, k, lnext, cnext : integer;
    stop : boolean;

begin
for i := 1 to m do
  for j := 1 to n do
    di[i,j] := infinit;

new(cst);
cst^.l := lO[o];
cst^.c := cO[o];
cst^.urm := nil;
cfin := cst;

di[lO[o], cO[o]] := 0;

stop := false;
while (cst <> nil) do
  begin
    l := cst^.l;
    c := cst^.c;

    for k := 1 to 4 do
      begin
        lnext := l + dl[k];
        cnext := c + dc[k];

        if (lnext >=1 ) and (lnext <= m) and (cnext >= 1) and (cnext <= n) and
          (di[lnext, cnext] = infinit) and
          ((a[lnext, cnext] = 'E') or (a[lnext, cnext] = 'O')) then
          begin
            di[lnext,cnext] := di[l,c] + 1;

            if (a[lnext, cnext] = 'O') and (not marcat[lnext, cnext]) then
              begin
                stop := true;
                break;
              end;

            new(aux);
            aux^.l := lnext;
            aux^.c := cnext;
            aux^.urm := nil;

            cfin^.urm := aux;
            cfin := aux;
          end;

        if (stop) then
          break;
      end;

    if (stop) then
      break;

    aux := cst;
    cst := cst^.urm;
    dispose(aux);
  end;

while (cst <> nil) do
  begin
    aux := cst;
    cst := cst^.urm;
    dispose(aux);
  end;

tmin := tmin + di[lnext, cnext];
computedist2 := objname[lnext, cnext];
end;


begin
t1 := t2;

assign(input, filein);
reset(input);
read(m, n);

fillchar(objname, sizeof(objname), 0);

nO := 0;
for i := 1 to m do
  for j := 1 to n do
    begin
      repeat
        read(ch);
      until (ch = 'M') or (ch = 'O') or (ch = 'W') or (ch = 'E');

      if (ch = 'M') then
        begin
          lM := i; cM := j;
          a[i,j] := 'E';
        end
      else
      if (ch = 'O') then
        begin
          a[i,j] := ch;

          inc(nO);
          lO[nO] := i;
          cO[nO] := j;

          objname[i, j] := nO;
        end
      else
        a[i,j] := ch;
    end;

close(input);

inc(nO);
lO[nO] := lM;
cO[nO] := cM;

computeout;

tmin := infinit;
if (nO <= maxobj) then
  begin
    for i := 1 to nO do
      computedist(i);

    for i := 1 to nO do
      begin
        new(dord[i]);
        for j := 1 to nO do
          dord[i]^[j] := j;

        for j := 1 to nO-1 do
          for k := j+1 to nO do
            if (d[i,dord[i]^[j]] > d[i, dord[i]^[k]]) then
              begin
                p := dord[i]^[j];
                dord[i]^[j] := dord[i]^[k];
                dord[i]^[k] := p;
              end;

      end;

    fillchar(marcat, sizeof(marcat), false);
    stk[1] := nO;
    marcat[lO[nO], cO[nO]] := true;
    tact := 0;

    bkt1(2);
  end
else
  begin
    { greedy }

    tmin := 0;
    fillchar(marcat, sizeof(marcat), false);
    curr := nO;
    marcat[lO[curr], cO[curr]] := true;

    nsel := 1;

    while (nsel < nO) do
      begin
        curr := computedist2(curr);

        marcat[lO[curr], cO[curr]] := true;

        inc(nsel);
      end;

    tmin := tmin + out[lO[curr], cO[curr]];
  end;

printsol;
end.