{$A+,B-,D+,E+,F-,G-,I-,L+,N+,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
{$M 16384,0,655360}

Program _NETWORK_;

const MAXN = 111;
      filein = 'NETWORK.IN';
      fileout = 'NETWORK.OUT';
      timelimit = 17;

var cap, flux : array [1..MAXN, 1..MAXN] of byte;
    q, tata, tip : array [1 .. 2*MAXN] of integer;
    sel : array [1..MAXN] of boolean;
    i, j, k, m, n, vmin : integer;

    t2 : longint absolute 0 : $046c;
    t1 : longint;

function minim(a, b : integer) : integer;
begin
if (a < b) then
  minim := a
else
  minim := b;
end;

procedure printsol;
begin
{
writeln(t2 - t1 , ' : ', i, ' -> ', vmin);
}
assign(output, fileout);
rewrite(output);
writeln(vmin);
close(output);
halt(0);
end;

function maxflow(d : integer) : integer;
var i, j, k, p, fmax, po, nel : integer;
begin
for i := 1 to n do
  for j := 1 to n do
    flux[i, j] := 0;

fmax := 0;

repeat
  if (t2 - t1 >= timelimit) then
    printsol;

  for i := 1 to n do
    begin
      sel[i] := false;
      tata[i] := 0;
      tip[i] := 0;
    end;

  po := 1;
  nel := 1;
  q[1] := 1;
  sel[1] := true;

  while (po <= nel) do
    begin
      i := q[po];

      for j := 2 to n do
        if (not sel[j]) then
          begin
            if (cap[i, j] = 1) and (flux[i, j] = 0) then
              begin
                tata[j] := i;
                tip[j] := 1;
                sel[j] := true;

                inc(nel);
                q[nel] := j;
              end;

            if (cap[j, i] = 1) and (flux[j, i] = 1) then
              begin
                tata[j] := i;
                tip[j] := 2;
                sel[j] := true;

                inc(nel);
                q[nel] := j;
              end;
          end;

      inc(po);
    end;

  if (sel[d]) then
    begin
      inc(fmax);

      p := d;
      while (p > 1) do
        begin
          if (tip[p] = 1) then
            inc(flux[tata[p], p])
          else
            dec(flux[p, tata[p]]);

          p := tata[p];
        end;

      if (fmax >= vmin) then
        break;
    end;

until (not sel[d]);

maxflow := fmax;
end;

begin
t1 := t2;

{ read input data }
assign(input, filein);
reset(input);

read(n, m);

for i := 1 to n do
  for j := 1 to n do
    cap[i, j] := 0;

for k := 1 to m do
  begin
    read(i, j);
    cap[i, j] := 1;
    cap[j, i] := 1;
  end;

{ compute stuff }
vmin := n-1;

for i := 2 to n do
  vmin := minim(vmin, maxflow(i));

{ write output data }
printsol;
end.