Program _NUMBERS_; { de pe vremea cand am rezolvat-o la TIMUS }

const filein = 'NUMBERS.IN';
      fileout = 'NUMBERS.OUT';
      digits:set of char=['0'..'9'];
      avans=10;

type BigNum=array[0..500] of longint;
     pBigNum=^BigNum;

var s,num,v1,v2,v3,minim,total,zece:BigNum;
    i,j,k,m,n,p,q,li,ls,dmnt, t, nt:longint;
    clast,cact:array[1..9] of BigNum;
    ok,found:boolean;
    ch:char;

procedure movebignum(n1:pBigNum;rez:pBigNum);
var i:integer;
begin
fillchar(rez^,sizeof(rez^),0);

for i:=0 to n1^[0] do
  rez^[i]:=n1^[i];
end;

procedure add(x:longint;n1:pBigNum;rez:pBigNum);
var i,ndig:integer;
begin
movebignum(n1,rez);

rez^[1]:=rez^[1]+x;
ndig:=rez^[0];

for i:=1 to ndig+avans do
  if (rez^[i]>=10) then
    begin
      rez^[i+1]:=rez^[i+1]+(rez^[i] div 10);
      rez^[i]:=rez^[i] mod 10;
    end;

for i:=ndig+avans downto 1 do
  if (rez^[i]>0) then
    begin
      rez^[0]:=i; break;
    end;
end;

procedure sub(x:longint;n1:pBigNum;rez:pBigNum);
var i,ndig:integer;
begin
movebignum(n1,rez);

rez^[1]:=rez^[1]-x;
ndig:=rez^[0];

for i:=1 to ndig do
  while (rez^[i]<0) do
    begin
      rez^[i+1]:=rez^[i+1]-1;
      rez^[i]:=rez^[i]+10;
    end;

for i:=ndig downto 1 do
  if (rez^[i]>0) then
    begin
      rez^[0]:=i; break;
    end;
end;

procedure mult(x:longint;n1:pBigNum;rez:pBigNum);
var i,ndig:integer;
begin
fillchar(rez^,sizeof(BigNum),0);

ndig:=n1^[0];
for i:=1 to ndig do
  rez^[i]:=n1^[i]*x;

for i:=1 to ndig+avans do
  if (rez^[i]>=10) then
    begin
      rez^[i+1]:=rez^[i+1]+(rez^[i] div 10);
      rez^[i]:=rez^[i] mod 10;
    end;

for i:=ndig+avans downto 1 do
  if (rez^[i]>0) then
    begin
      rez^[0]:=i; break;
    end;
end;

procedure addbignum(n1:pBigNum;n2:pBigNum;rez:pBigNum);
var i,ndig:integer;
begin
fillchar(rez^,sizeof(BigNum),0);

if (n1^[0]>n2^[0]) then
  ndig:=n1^[0]
else
  ndig:=n2^[0];

for i:=1 to ndig do
  rez^[i]:=n1^[i]+n2^[i];

for i:=1 to ndig+avans do
  if (rez^[i]>=10) then
    begin
      rez^[i+1]:=rez^[i+1]+(rez^[i] div 10);
      rez^[i]:=rez^[i] mod 10;
    end;

for i:=ndig+avans downto 1 do
  if (rez^[i]>0) then
    begin
      rez^[0]:=i; break;
    end;
end;


function compare(n1:pBigNum;n2:pBigNum):integer;
var i,ndig,res:integer;
begin
if (n1^[0]>n2^[0]) then
  compare:=1
else
if (n2^[0]>n1^[0]) then
  compare:=-1
else
  begin
    ndig:=n1^[0];
    res:=0;

    for i:=ndig downto 1 do
      if (n1^[i]>n2^[i]) then
        begin
          res:=1; break;
        end
      else
      if (n2^[i]>n1^[i]) then
        begin
          res:=-1; break;
        end;

    compare:=res;
  end;
end;

begin
assign(input, filein);
reset(input);
assign(output, fileout);
rewrite(output);

readln(nt);
for t := 1 to nt do
  begin
    n:=0;
    while (not seekeoln(input)) do
      begin
        read(ch);
        if (ch in digits) then
          begin
            inc(n);
            s[n]:=ord(ch)-48;
          end;
      end;
    readln;

    minim[0]:=n+1;
    for i:=1 to n do
      minim[n-i+1]:=s[i];
    minim[n+1]:=1;
    dmnt:=1;

    { Step 1 - Search full starting numbers }
    for i:=1 to n do
      if (s[1]>0) then
        begin
          fillchar(num,sizeof(num),0);
          num[0]:=i;

          for j:=1 to i do
            num[i-j+1]:=s[j];

          add(1,@num,@v1);
          k:=i+1;  ok:=true;
          while (k<=n) and (ok) do
            begin
              li:=k;
              ls:=li+v1[0]-1;

              for j:=ls downto li do
                if (j<=n) and (s[j]<>v1[v1[0]-(j-li)]) then
                  begin
                    ok:=false; break;
                  end;

              add(1,@v1,@v2);
              movebignum(@v2,@v1);

              k:=ls+1;
            end;

          if (ok) then
            begin
              movebignum(@num,@minim);
              dmnt:=0;
              break;
            end;
        end;

    { Step 2 - Search partial starting numbers }
    for i:=1 to n-1 do
      if (s[i+1]>0) then
        begin
          { Search complete endings }
          for j:=i+i+1 to n do
            begin
              fillchar(num,sizeof(num),0);
              num[0]:=i;

              for p:=1 to i do
                num[i-p+1]:=s[p];

              add(1,@num,@v1);

              found:=true;
              for k:=j downto j-i+1 do
                if (s[k]<>v1[1+(j-k)]) then
                  begin
                    found:=false;
                    break;
                  end;

              if (found) then
                begin
                  v1[0]:=i;
                  v1[i+1]:=0;

                  movebignum(@v1,@v3);

                  for k:=j-i downto i+1 do
                    begin
                      inc(v1[0]);
                      v1[v1[0]]:=s[k];
                    end;

                   k:=i+1;  ok:=true;
                   while (k<=n) and (ok) do
                     begin
                       li:=k;
                       ls:=li+v1[0]-1;

                       for p:=ls downto li do
                         if (p<=n) and (s[p]<>v1[v1[0]-(p-li)]) then
                           begin
                             ok:=false; break;
                           end;

                       add(1,@v1,@v2);
                       movebignum(@v2,@v1);

                       k:=ls+1;
                     end;

                   if (ok) then
                     begin
                       for k:=j-i downto i+1 do
                          begin
                            inc(v3[0]);
                            v3[v3[0]]:=s[k];
                          end;

                       sub(1,@v3,@num);

                       p:=compare(@num,@minim);
                      if (num[0]>i) and
                         ((p=-1) or ((p=0) and (n-q-i<dmnt)))
                       then
                         begin
                           movebignum(@num,@minim);
                           dmnt:=num[0]-i;
                         end;
                     end;
                end;
            end;

          { Search incomplete endings }
          for q:=0 to i-1 do
            begin
              if (n-q+1<=i) then break;

              fillchar(num,sizeof(num),0);
              num[0]:=i;

              for p:=1 to i do
                num[i-p+1]:=s[p];

              add(1,@num,@v1);

              v1[0]:=i;
              v1[i+1]:=0;

              found:=true;
              k:=v1[0]+1;
              for j:=n-q+1 to n do
                begin
                  dec(k);
                  if (s[j]<>v1[k]) then
                    begin
                      found:=false; break;
                    end;
                end;

              if (found) then
                begin
                  for j:=n-q downto i+1 do
                    begin
                      inc(v1[0]);
                      v1[v1[0]]:=s[j];
                    end;

                  sub(1,@v1,@num);

                  p:=compare(@num,@minim);
                  if (num[0]>i) and
                     ((p=-1) or ((p=0) and (n-q-i<dmnt)))
                  then
                    begin
                      movebignum(@num,@minim);
                      dmnt:=n-q-i;
                    end;
                end;
            end;
        end;

    fillchar(total,sizeof(total),0);
    total[0]:=1;

    fillchar(clast,sizeof(clast),0);
    fillchar(zece,sizeof(BigNum),0);

    for i:=1 to minim[0] do
      begin
        fillchar(cact,sizeof(cact),0);

        if (i=1) then
          begin
            zece[0]:=1;
            zece[1]:=1;
            cact[1][0]:=1;
            cact[1][1]:=1;
          end
        else
          begin
            mult(i-1,@zece,@v2);
            addbignum(@v2,@clast[9],@v1);
            add(1,@v1,@v2);
            movebignum(@v2,@cact[1]);

            mult(10,@zece,@v1);
            movebignum(@v1,@zece);
          end;

        for j:=2 to 9 do
          begin
            mult(i*(j-1),@zece,@v1);
            addbignum(@v1,@cact[1],@v2);
            movebignum(@v2,@cact[j]);
          end;

        for j:=1 to 9 do
          movebignum(@cact[j],@clast[j]);
      end;

    movebignum(@cact[minim[minim[0]]],@total);

    movebignum(@minim,@num);
    num[num[0]]:=0;

    while (num[num[0]]=0) and (num[0]>0) do
      dec(num[0]);

    mult(minim[0],@num,@v1);
    addbignum(@v1,@total,@v2);
    movebignum(@v2,@total);

    sub(minim[0]-1,@total,@num);
    add(dmnt,@num,@total);


    write(total[total[0]]);
    for i:=total[0]-1 downto 1 do
      write(total[i]);
    writeln;
  end;

close(input);
close(output);
end.