#include <stdio.h>
#include <string.h>
#include <math.h>
#include <dos.h>
#define filein "CIRCLES.IN"
#define fileout "CIRCLES.OUT"
#define maxn 10
#define infinit 1e6
#define step 8e-6
#define timelimit 17
#define maxim(a,b) ((a) > (b) ? (a) : (b))
#define minim(a,b) ((a) < (b) ? (a) : (b))

double d[maxn], u[maxn], r[maxn], L, lcurr, unghi, PIp2;
double x, y, xmin, ymin, xmax, ymax;
int i, j, k;

long int *t2, t1;

int main()
{
t2 = MK_FP(0, 0x46c);
t1 = *t2;

freopen(filein, "r", stdin);
for (i = 0; i < maxn; i++)
  {
    scanf("%lf %lf %lf", &x, &y, &r[i]);
    d[i] = sqrt(x*x + y*y);
    u[i] = atan2(y, x);
  }

PIp2 = acos(0);
unghi = 0;
L = infinit;

while (unghi < PIp2)
  {
    if (*t2 - t1 >= timelimit)
      break;

    xmin = ymin = infinit;
    xmax = ymax = -infinit;

    for (i = 0; i < maxn; i++)
      {
        x = d[i] * cos(u[i]), y = d[i] * sin(u[i]);

        if (x - r[i] < xmin)
          xmin = x - r[i];
        if (x + r[i] > xmax)
          xmax = x + r[i];
        if (y - r[i] < ymin)
          ymin = y - r[i];
        if (y + r[i] > ymax)
          ymax = y + r[i];
      }

    lcurr = maxim(xmax-xmin, ymax-ymin);
    L = minim(L, lcurr);

    unghi += step;
    for (i = 0; i < maxn; i++)
      u[i] += step;
  }


printf("%ld %.8lf\n", *t2-t1, unghi);

freopen(fileout, "w", stdout);
printf("%.8lf\n", L);

return 0;
}