#include <stdio.h>
#include <string.h>

#define NMAX 111
#define NCOL 15

long cN[NMAX][NCOL], cM[NMAX][NCOL];
int F[NMAX][NMAX];
int nf[NMAX], ncN[NMAX], ncM[NMAX];
int N, M, cnt;

int cb[NMAX], cf[NMAX];
int vb[NMAX], vf[NMAX];
int gata;

void dff(int, int);

void dfb(int n)
{
	int i;

	vb[n] = 1;

	for (i = 0; i < nf[n]; i++)
		if (!vf[F[n][i]])
		{
			dff(F[n][i], n);
			if (gata)
				break;
		}
}

void dff(int n, int t)
{
	vf[n] = 1;

	if (!cf[n])
	{
		gata = 1;
		cf[n] = t;
		cb[t] = n;
    cnt++;
	} else
	{
		dfb(cf[n]);
		if (gata)
		{
			cf[n] = t;
			cb[t] = n;
		}
	}
}

int main()
{
	int i, j, k, l, aux, poz, ok;

	freopen("INPUT.TXT", "r", stdin);

	scanf("%d", &N);
	for (i = 1; i <= N; i++)
	{
    scanf("%d", &ncN[i]);
    for (j = 1; j <= ncN[i]; j++)
      scanf("%ld", &cN[i][j]);
	}

	scanf("%d", &M);
	for (i = 1; i <= M; i++)
	{
    scanf("%d", &ncM[i]);
    for (j = 1; j <= ncM[i]; j++)
      scanf("%ld", &cM[i][j]);
	}

	for (i = 1; i <= N; i++)
    nf[i] = 0;

  for (i = 1; i <= N; i++)
    for (j = 1; j <= M; j++)
    {
      ok = 0;

      for (k = 1; k <= ncN[i] && !ok; k++)
        for (l = 1; l <= ncM[j] && !ok; l++)
          if (cN[i][k] == cM[j][l])
          {
            F[i][nf[i]++] = j;
            ok = 1;
          }
    }

  memset(cb, 0, sizeof(cb));
  memset(cf, 0, sizeof(cf));

  cnt = 0;

	for (i = 1; i <= N; i++)
	{
		poz = 0;
		for (j = 0; j < nf[i]; j++)
			if (!cf[F[i][j]])
			{
				poz = F[i][j];
				break;
			}

		if (poz)
		{
			cb[i] = poz;
			cf[poz] = i;
      cnt++;
		} else
			break;
	}

	for (; i<=N; i++)
	{
		memset(vb, 0, sizeof(vb));
		memset(vf, 0, sizeof(vf));
		gata = 0;

		dfb(i);
	}

  freopen("OUTPUT.txt", "w", stdout);

  printf("%d\n", cnt);
	for (i = 1; i <= N; i++)
    if (cb[i])
		  printf("%d %d\n", i, cb[i]);

	return 0;
}
