#include <stdio.h>
#include <string.h>

#define NMAX 111

int dl[4] = { -1, 0, +1, 0 };
int dc[4] = { 0, +1, 0, -1 };

char A[NMAX][NMAX], viz[NMAX][NMAX], ql[NMAX * NMAX], qc[NMAX * NMAX];
int i, j, M, N, max;

void viziteaza(int ls, int cs)
{
  int le, ri, ok, i, j, k, ine, jne;

  ql[le = ri = 1] = ls;
  qc[1] = cs;

  viz[ls][cs] = 1;

  ok = 1;
  while (le <= ri)
  {
    i = ql[le]; j = qc[le];

    if (i == 1 || i == M || j == 1 || j == N)
       ok = 0;

    for (k = 0; k < 4; k++)
    {
      ine = i + dl[k]; jne = j + dc[k];

      if (ine >= 1 && ine <= M && jne >= 1 && jne <= N &&
          !viz[ine][jne] && A[ine][jne] == '0')
      {
        ri++;
        ql[ri] = ine;
        qc[ri] = jne;
        viz[ine][jne] = 1;
      }
    }

    le++;
  }

  if (ok && ri > max)
     max = ri;
}

int main()
{
  freopen("INPUT.TXT", "r", stdin);

  scanf("%d %d", &M, &N);
  for (i = 1; i <= M; i++)
      for (j = 1; j <= N; j++)
          scanf(" %c", &A[i][j]);

  max = 0;

  memset(viz, 0, sizeof(viz));
  for (i = 1; i <= M; i++)
      for (j = 1; j <= N; j++)
          if (A[i][j] == '0' && !viz[i][j])
             viziteaza(i, j);

  freopen("OUTPUT.TXT", "w", stdout);
  printf("%d\n", max);

  return 0;
}