#include <stdio.h>
#include <string.h>

#define LMAX 20
#define CMAX 60
#define KMAX 201

unsigned char ok[LMAX][CMAX][(KMAX >> 2) + 2];
char A[LMAX][CMAX], s[KMAX];
int i, j, k, M, N, K;
int l1, c1, l2, c2, Sl, Sc, ll1, cc1, ll2, cc2, x, dl, dc;

void print(int i, int j, int k)
{
int x;

  if (k)
  {
    x = ok[i][j][k >> 2] & (1 << (2 * (k & 3)));
    x += ok[i][j][k >> 2] & (1 << (2 * (k & 3) + 1));

    x >>= (2 * (k & 3));

    if (x == 2)
    {
      print(i, j, k - 1);
      printf("2\n");
    }
    else
    {
      if (s[k - 1] == 'N')
         i++;
      else
      if (s[k - 1] == 'E')
         j--;
      else
      if (s[k - 1] == 'S')
         i--;
      else
      if (s[k - 1] == 'V')
         j++;

      print(i, j, k - 1);
      printf("1\n");
    }
  }
}

int main()
{
  freopen("INPUT.TXT", "r", stdin);

  scanf("%d %d", &M, &N);
  for (i = 0; i < M; i++)
      for (j = 0; j < N; j++)
          scanf("%d", &A[i][j]);

  scanf("%d %d %d %d %d", &l1, &c1, &l2, &c2, &K);
  l1--, c1--, l2--, c2--;

  Sl = M - 1;
  Sc = N - 1;

  memset(ok, 0, sizeof(ok));
  ok[0][0][0] = 1;

  scanf("%s", s);

  for (k = 0; k < K; k++)
  {
    if (s[k] == 'N')
       dl = -1, dc = 0;
    else
    if (s[k] == 'E')
       dl = 0, dc = 1;
    else
    if (s[k] == 'S')
       dl = +1, dc = 0;
    else
    if (s[k] == 'V')
       dl = 0, dc = -1;

    for (i = 0; i < M; i++)
        for (j = 0; j < N; j++)
        {
          x = ok[i][j][k >> 2] & (1 << (2 * (k & 3)));
          x += ok[i][j][k >> 2] & (1 << (2 * (k & 3) + 1));

          if (x) // ok la (i, j, pozitia anterioara)
          {
            ll1 = i;
            cc1 = j;
            ll2 = Sl - ll1;
            cc2 = Sc - cc1;

            /* muta 1 */
            ll1 += dl; cc1 += dc;
            if (ll1 >= 0 && ll1 < M && cc1 >= 0 && cc1 < N && !A[ll1][cc1])
               ok[ll1][cc1][(k + 1) >> 2] |= (1 << (2 * ((k + 1) & 3)));

            ll1 -= dl; cc1 -= dc;

            /* muta 2 */
            ll2 += dl; cc2 += dc;

            if (ll2 >= 0 && ll2 < M && cc2 >= 0 && cc2 < N && !A[ll2][cc2])
               ok[ll1][cc1][(k + 1) >> 2] |= (1 << (2 * ((k + 1) & 3) + 1));
            }
        }

    Sl += dl;
    Sc += dc;
  }

  /*
  if (Sl - l1 != l2 || Sc  - c1 != c2)
     printf(":(\n");
  */

  freopen("OUTPUT.TXT", "w", stdout);

  print(l1, c1, K);

  return 0;
}