{ Mugurel Ionut Andreica - Bucuresti, ROMANIA }

{
  The reverse Burrows-Wheeler Transformation for a particular
  type of strings (made up of 'S' and 'L')

  Time Complexity: O(N)
}

{$R-,I-,Q-,N+}
{$M 15000,0,655360}
Program TEMPLE;

const filein='INPUT.TXT';
      fileout='OUTPUT.TXT';
      MAXL=50100;
      MAXD=1023;
      MAXC=50;
      MAXBDIM=65000;
      symb : array [0..1] of char = ('S', 'L');

type buffer=array[1..MAXBDIM] of char;
     pbuffer=^buffer;
     linie=array[1..MAXL] of byte;
     plinie=^linie;
     p=array[0..MAXC] of word;
     pp=^p;

var fin,fout:text;
    i,j,k,m,n,r,q,nch:longint;
    line:array[0..MAXD] of pp;
    num,nact:array[0..1] of longint;
    first:plinie;
    ch:char;
    buf:pbuffer;

begin
new(buf);
fillchar(buf^,sizeof(buffer),0);

assign(fin,filein);
settextbuf(fin,buf^,sizeof(buffer));
reset(fin);

for i:=0 to MAXD do
  begin
    new(line[i]);
    fillchar(line[i]^,sizeof(p),0);
  end;

new(first);
fillchar(first^,sizeof(linie),0);

num[0]:=0; num[1]:=0;
n := 0;

while (not seekeoln(fin)) do
  begin
    repeat
      read(fin,ch);
    until (ch = 'S') or (ch = 'L');

    inc(n);
    if (ch = 'S') then
      first^[n] := 0
    else
      first^[n] := 1;

    inc(num[first^[n]]);
  end;
close(fin);

move(num,nact,sizeof(num));
for i:=n downto 1 do
  if (first^[i]=0) then
    begin
      m:=nact[0];
      r:=m and MAXD;
      q:=m shr 10;

      line[r]^[q]:=i;
      dec(nact[0]);
    end
  else
    begin
      m:=num[0]+nact[1];
      r:=m and MAXD;
      q:=m shr 10;

      line[r]^[q]:=i;
      dec(nact[1]);
    end;

fillchar(first^,sizeof(linie),0);
for i:=1 to n do
  if (i<=num[0]) then
    first^[i]:=0
  else
    first^[i]:=1;

assign(fout,fileout);
settextbuf(fout,buf^,sizeof(buffer));
rewrite(fout);

write(fout,symb[first^[1]]);
i:=1;
for nch:=2 to n do
  begin
    r:=i and MAXD;
    q:=i shr 10;

    i:=line[r]^[q];
    write(fout, symb[first^[i]]);
  end;

writeln(fout);
close(fout);
end.