#include <stdio.h>
#include <string.h>

#define NMAX 10000

long i, j, k, N, r, po, nel;
int digit[10], pred[NMAX], q[NMAX];
unsigned char dig[NMAX], rem[NMAX];

void print(long r)
{
if (pred[r] > 0)
   print(pred[r]);

printf("%d", dig[r]);
}

void solveprob(void)
{
long x;

for (x = 0; x < N; x++)
	rem[x] = pred[x] = 0;

nel = 0;
for (i = 1; i <= 9; i++)
  if (digit[i] && !rem[i % N])
    {
	 	q[++nel] = i % N;
		rem[i % N] = 1;
		dig[i % N] = i;
	}

po = 1;

while (po <= nel)
  {
    if (rem[0])
		break;
	  
	  k = q[po];

    for (i = 0; i <= 9; i++)
      if (digit[i])
        {
          /* do stuff */
          r = (k*10+i) % N;
          if (!rem[r])
            {
              rem[r] = 1;
              pred[r] = k;
              dig[r] = i;

              nel++;
              q[nel] = r;
            }
        }

    po++;
  }

if (rem[0])
	print(0);
else
  printf("-1");

printf("\n");
}

int main()
{
	freopen("INPUT.TXT", "r", stdin);

	scanf("%ld", &N);

  memset(digit, 0, sizeof(digit));
  scanf("%ld", &r);
  for (i = 0; i < r; i++)
  {
    scanf("%ld", &k);
    digit[k] = 1;
  }

  freopen("OUTPUT.TXT", "w", stdout);

  solveprob();

	return 0;
}