Program APM1_2;

const filein='INPUT.TXT';
      fileout='OUTPUT.TXT';
      MAXW=111;
      MARE=100000;

type plist=^list;
     list=record
            o,c:integer;
            urm:plist;
          end;

var cost:array[1..MAXW,1..MAXW] of integer;
    edge:array[1..MAXW] of plist;
    tata, niv:array[1..MAXW] of integer;
    cact:array[1..MAXW] of longint;
    sel:array[1..MAXW] of boolean;
    i,j,k,m,n,p,w,minv,total,mindif:longint;
    fin,fout:text;
    aux:plist;

    e1 : array[1..MAXW, 1..MAXW] of byte;
    p1, p2 : integer;

begin
assign(fin,filein);
reset(fin);
read(fin,w,p);

fillchar(edge,sizeof(edge),0);
fillchar(e1, sizeof(e1), 0);

for k:=1 to p do
  begin
    read(fin,i,j,m);

    if (m mod 1000 = 0) then
       m := m div 1000
    else
        m := 1 + (m div 1000);

    e1[i, j] := 1;
    e1[j, i] := 1;

    cost[i, j] := m;
    cost[j, i] := m;

    new(aux);
    aux^.o:=j;
    aux^.c:=m;
    aux^.urm:=edge[i];
    edge[i]:=aux;

    new(aux);
    aux^.o:=i;
    aux^.c:=m;
    aux^.urm:=edge[j];
    edge[j]:=aux;
  end;
close(fin);

cact[1]:=0;
for i:=2 to w do
  begin
    cact[i]:=MARE;
    tata[i]:=0;
  end;

fillchar(sel,sizeof(sel),false);

sel[1]:=true;
niv[1] := 1;

m:=1; p:=1; total:=0;
while (m<w) do
  begin
    aux:=edge[p];
    while (aux<>nil) do
      begin
        i:=aux^.o;
        j:=aux^.c;

        if ((cact[i]>j) and (not sel[i])) then
          begin
            cact[i]:=j;
            tata[i]:=p;
            niv[i] := niv[p] + 1;
          end;

        aux:=aux^.urm;
      end;

    p1 := p;

    minv:=MARE;
    for i:=1 to w do
      if (not sel[i]) and (cact[i]<minv) then
        begin
          minv:=cact[i];
          p:=i;
        end;

    sel[p]:=true;
    total:=total+minv;
    m:=m+1;

    e1[p, tata[p]] := 2;
    e1[tata[p], p] := 2;
  end;


assign(fout,fileout);
rewrite(fout);

writeln(fout, total);
for i := 1 to w - 1 do
  for j := i + 1 to w do
    if (e1[i, j] = 1) then
       writeln(fout, i, ' ', j, ' D')
    else
    if (e1[i, j] = 2) then
       writeln(fout, i, ' ', j, ' P');

close(fout);
end.
