#include <fstream.h>
#include <mem.h>

#define filein "dune.in"
#define fileout "dune.out"
#define maxn 105
#define maxh 37

#define akts(ert, kert) (aktsorp[(ert)+(kert)*maxh])
#define elozos(ert, kert) (elozosorp[(ert)+(kert)*maxh])

void kezdoertek();
void megold();
void kiir();

int n, k;
long tabla[maxn][7];
long elozosor[maxh][maxn], aktsor[maxh][maxn];
int lehetelozo[maxh][maxn], lehetmost[maxh][maxn];
long maxert;
int hsor[maxh]={0, 3, 6, 7, 12, 14, 15, 24, 27, 28,
30, 31, 48, 51, 54, 55, 56, 59, 60, 62, 63, 96, 99,
102, 103, 108, 110, 111, 112, 115, 118, 119, 120,
123, 124, 126, 127};
long legj;
int ertek[maxh]={0, 1, 1, 2, 1, 2, 3, 1, 2, 2, 3, 4,
1, 2, 2, 3, 2, 3, 3, 4, 5, 1, 2, 2, 3, 2, 3, 4, 2, 3,
3, 4, 3, 4, 4, 5, 6,};


int main() {
  kezdoertek();
  megold();
  kiir();
  return 0;
}

void megold() {
  int q, w, e, r, aktbit;
  long aktplussz;

  lehetelozo[0][0]=1;
  for (q=1; q<n; q++) {
    for (w=0; w<maxh; w++)
      for (e=0; e<maxh; e++) {
        aktplussz=0;
        for (aktbit=1, r=0; aktbit<128; aktbit<<=1, r++)
          if (hsor[w]&aktbit) {
            aktplussz+=tabla[q][r];
            if (!(hsor[e]&aktbit)) aktplussz+=tabla[q-1][r];
          }

        for (r=1; r<=k; r++) {
          if (lehetelozo[e][r-ertek[w]]) {
            if (!lehetmost[w][r]) {
              lehetmost[w][r]=1;
              aktsor[w][r]=elozosor[e][r-ertek[w]]+aktplussz;
              if (legj<aktsor[w][r]) legj=aktsor[w][r];
            } else if (aktsor[w][r]<elozosor[e][r-ertek[w]]+aktplussz){
              aktsor[w][r]=elozosor[e][r-ertek[w]]+aktplussz;
              if (legj<aktsor[w][r]) legj=aktsor[w][r];
            }
          }
        }
      }
    memcpy(lehetelozo, lehetmost, sizeof(lehetelozo));
    setmem(lehetmost, sizeof(lehetmost), 0);
    memcpy(elozosor, aktsor, sizeof(aktsor));
  }
}

void kiir() {
  ofstream fout(fileout);

  fout << legj;

  fout.close();
}

void kezdoertek() {
  int q, w;
  ifstream fin(filein);

  fin >> n >> k;

  for (q=0; q<n; q++) for (w=0; w<7; w++) fin >> tabla[q][w];

  fin.close();
}