{ Mugurel Ionut Andreica - Bucuresti, ROMANIA }

{$A+,B-,D+,E+,F-,G-,I-,L+,N+,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
{$M 16384,0,655360}

Program Retea;

type bytemat=array[0..101,0..101] of byte;
     byteboolvect=array[0..101,0..101,1..2] of byte;
     trvect=array[0..20000] of byte;
     bufvect=array[1..65000] of char;

var fin,fout:text;
    tip,ddir,i,j,k,m,n,p,laux,caux,lnext,cnext,poi,nel:integer;
    flux:array[0..100,0..100,1..4] of byte;
    fnod:array[0..100,0..100] of byte;
    pl,pc:array[1..500] of byte;
    delas,spred:^bytemat;
    incoada,dir,tatal,tatac:^byteboolvect;
    fmax,ll,cc:integer;
    solutie:boolean;
    tl,tc,col,coc,cot:^trvect;
    buffer:^bufvect;
    {
    t2:longint absolute 0:$046c;
    t1:longint;
    }
procedure nosol;
begin
assign(fout,'NET.OUT');
rewrite(fout);
writeln(fout,0);
close(fout);
halt(0);
end;

begin
{
t1:=t2;
}
assign(fin,'NET.IN');
reset(fin);
readln(fin,n,m);

if (m>4*n-4) then nosol;
for i:=1 to m do
  readln(fin,pl[i],pc[i]);

close(fin);

new(tatal); new(tatac); new(incoada);
new(dir); new(delas); new(spred);
new(col); new(coc); new(cot);

fillchar(fnod,sizeof(fnod),0);
fillchar(flux,sizeof(flux),0);
fillchar(delas^,sizeof(delas^),0);
fillchar(spred^,sizeof(spred^),0);

repeat

solutie:=false;
fillchar(incoada^,sizeof(incoada^),0);
nel:=0; poi:=1;

for k:=1 to m do
  begin
    i:=pl[k]; j:=pc[k];

    if (delas^[i,j]=0) then
      begin
        incoada^[i,j,1]:=1;
        tatal^[i,j,1]:=0;
        tatac^[i,j,1]:=0;

        nel:=1;
        col^[1]:=i; coc^[1]:=j; cot^[1]:=1;
        break;
      end;
  end;

while (poi<=nel) and (not solutie) do
  begin
    ll:=col^[poi]; cc:=coc^[poi];
    tip:=cot^[poi];

    if ((ll=n) or (ll=1) or (cc=n) or (cc=1)) and
       (spred^[ll,cc]=0) and (tip=2) then
      begin
        solutie:=true;
        break;
      end;

    case tip of
    2:begin
        { Muchii directe }
        lnext:=ll-1;
        if (lnext>0) and (flux[ll,cc,1]=0) and (flux[lnext,cc,3]=0) then
          begin
            if (incoada^[lnext,cc,1]=0) then
              begin
                incoada^[lnext,cc,1]:=1;
                tatal^[lnext,cc,1]:=ll;
                tatac^[lnext,cc,1]:=cc;
                dir^[lnext,cc,1]:=1;

                inc(nel);
                col^[nel]:=lnext;
                coc^[nel]:=cc;
                cot^[nel]:=1;
              end;
          end;
        cnext:=cc+1;
        if (cnext<=n) and (flux[ll,cc,2]=0) and (flux[ll,cnext,4]=0) then
          begin
            if (incoada^[ll,cnext,1]=0) then
              begin
                incoada^[ll,cnext,1]:=1;
                tatal^[ll,cnext,1]:=ll;
                tatac^[ll,cnext,1]:=cc;
                dir^[ll,cnext,1]:=2;

                inc(nel);
                col^[nel]:=ll;
                coc^[nel]:=cnext;
                cot^[nel]:=1;
              end;
          end;
        lnext:=ll+1;
        if (lnext<=n) and (flux[ll,cc,3]=0) and (flux[lnext,cc,1]=0) then
          begin
            if (incoada^[lnext,cc,1]=0) then
              begin
                incoada^[lnext,cc,1]:=1;
                tatal^[lnext,cc,1]:=ll;
                tatac^[lnext,cc,1]:=cc;
                dir^[lnext,cc,1]:=3;

                inc(nel);
                col^[nel]:=lnext;
                coc^[nel]:=cc;
                cot^[nel]:=1;
              end;
          end;
        cnext:=cc-1;
        if (cnext>0) and (flux[ll,cc,4]=0) and (flux[ll,cnext,2]=0) then
          begin
            if (incoada^[ll,cnext,1]=0) then
              begin
                incoada^[ll,cnext,1]:=1;
                tatal^[ll,cnext,1]:=ll;
                tatac^[ll,cnext,1]:=cc;
                dir^[ll,cnext,1]:=4;

                inc(nel);
                col^[nel]:=ll;
                coc^[nel]:=cnext;
                cot^[nel]:=1;
              end;
          end;
        { END Muchii directe }

        { Muchii inverse }
        if (fnod[ll,cc]=1) and (incoada^[ll,cc,1]=0) then
          begin
            incoada^[ll,cc,1]:=1;
            tatal^[ll,cc,1]:=ll;
            tatac^[ll,cc,1]:=cc;
            dir^[ll,cc,1]:=5;

            inc(nel);
            col^[nel]:=ll;
            coc^[nel]:=cc;
            cot^[nel]:=1;
          end;
        { END Muchii inverse }
      end;
    1:begin
        { Muchii inverse }
        lnext:=ll-1;
        if (lnext>0) and (flux[lnext,cc,3]=1) then
          begin
            if (incoada^[lnext,cc,2]=0) then
              begin
                incoada^[lnext,cc,2]:=1;
                tatal^[lnext,cc,2]:=ll;
                tatac^[lnext,cc,2]:=cc;
                dir^[lnext,cc,2]:=3;

                inc(nel);
                col^[nel]:=lnext;
                coc^[nel]:=cc;
                cot^[nel]:=2;
              end;
          end;
        cnext:=cc+1;
        if (cnext<=n) and (flux[ll,cnext,4]=1) then
          begin
            if (incoada^[ll,cnext,2]=0) then
              begin
                incoada^[ll,cnext,2]:=1;
                tatal^[ll,cnext,2]:=ll;
                tatac^[ll,cnext,2]:=cc;
                dir^[ll,cnext,2]:=4;

                inc(nel);
                col^[nel]:=ll;
                coc^[nel]:=cnext;
                cot^[nel]:=2;
              end;
          end;
        lnext:=ll+1;
        if (lnext<=n) and (flux[lnext,cc,1]=1) then
          begin
            if (incoada^[lnext,cc,2]=0) then
              begin
                incoada^[lnext,cc,2]:=1;
                tatal^[lnext,cc,2]:=ll;
                tatac^[lnext,cc,2]:=cc;
                dir^[lnext,cc,2]:=1;

                inc(nel);
                col^[nel]:=lnext;
                coc^[nel]:=cc;
                cot^[nel]:=2;
              end;
          end;
        cnext:=cc-1;
        if (cnext>0) and (flux[ll,cnext,2]=1) then
          begin
            if (incoada^[ll,cnext,2]=0) then
              begin
                incoada^[ll,cnext,2]:=1;
                tatal^[ll,cnext,2]:=ll;
                tatac^[ll,cnext,2]:=cc;
                dir^[ll,cnext,2]:=2;

                inc(nel);
                col^[nel]:=ll;
                coc^[nel]:=cnext;
                cot^[nel]:=2;
              end;
          end;
        { END Muchii inverse }

        { Muchii directe }
        if (fnod[ll,cc]=0) and (incoada^[ll,cc,2]=0) then
          begin
            incoada^[ll,cc,2]:=1;
            tatal^[ll,cc,2]:=ll;
            tatac^[ll,cc,2]:=cc;
            dir^[ll,cc,2]:=5;

    if ((ll=n) or (ll=1) or (cc=n) or (cc=1)) and
       (spred^[ll,cc]=0) then
      begin
        solutie:=true;
        break;
      end;

            inc(nel);
            col^[nel]:=ll;
            coc^[nel]:=cc;
            cot^[nel]:=2;
          end;
        { END Muchii directe }
      end;
    end;

    inc(poi);
  end;

if (solutie) then
  begin
    fmax:=fmax+1;
    spred^[ll,cc]:=1;

    tip:=2;
    laux:=tatal^[ll,cc,tip]; caux:=tatac^[ll,cc,tip];

    while (laux>0) and (caux>0) do
      begin

        if (laux=ll) and (caux=cc) then
          begin
            if (tip=2) then
              inc(fnod[ll,cc])
            else
              dec(fnod[ll,cc]);
          end
        else
          begin
            if (tip=1) then
              inc(flux[laux,caux,dir^[ll,cc,tip]])
            else
              dec(flux[ll,cc,dir^[ll,cc,tip]]);
          end;

        laux:=ll; caux:=cc;
        ll:=tatal^[laux,caux,tip];
        cc:=tatac^[laux,caux,tip];

        tip:=3-tip;
        laux:=tatal^[ll,cc,tip]; caux:=tatac^[ll,cc,tip];
      end;

    delas^[ll,cc]:=1;
  end;

if (fmax=m) then
  solutie:=false;

until (not solutie);

dispose(incoada);
dispose(col);
dispose(coc);
dispose(cot);
dispose(tatal);
dispose(tatac);
dispose(dir);
dispose(delas);
dispose(spred);

new(buffer);
fillchar(buffer^,sizeof(bufvect),0);
settextbuf(fout,buffer^,sizeof(bufvect));
assign(fout,'NET.OUT');
rewrite(fout);

if (fmax<m) then
  writeln(fout,0)
else
  begin

    new(tl); new(tc);
    for k:=1 to fmax do
      begin
        {
        fillchar(tl^,sizeof(tl^),0);
        fillchar(tc^,sizeof(tc^),0);
        }
        p:=0;
        ll:=pl[k]; cc:=pc[k];

        while (ll>0) and (cc>0) do
          begin
            inc(p); tl^[p]:=ll; tc^[p]:=cc;
            laux:=0; caux:=0;

            if (flux[ll,cc,1]=1) then
              begin
                laux:=ll-1; caux:=cc;
              end
            else
              if (flux[ll,cc,2]=1) then
                begin
                  laux:=ll; caux:=cc+1;
                end
              else
                if (flux[ll,cc,3]=1) then
                  begin
                    laux:=ll+1; caux:=cc;
                  end
                else
                  if (flux[ll,cc,4]=1) then
                    begin
                      laux:=ll; caux:=cc-1;
                    end;

            ll:=laux; cc:=caux;
          end;

        writeln(fout,p);
        for i:=1 to p-1 do
          write(fout,'(',tl^[i],' ',tc^[i],') ');
        writeln(fout,'(',tl^[p],' ',tc^[p],')');

      end;

  end;
close(fout);
{
writeln(t2-t1);
}
end.