{ Mugurel Ionut Andreica - Bucuresti, ROMANIA }

{$R-,I-,Q-,S-}
{$M 65000,0,655360}

Program Matrix;

const filein='MATRIX.IN';
      fileout='MATRIX.OUT';
      MAXN=100;
      MAXB=128;
      NOK=37;
      bit:array[0..6] of byte=(1,2,4,8,16,32,64);

type pmax=array[1..NOK,0..MAXN] of longint;

var mat:array[1..MAXN,0..6] of longint;
    actmax,lastmax:pmax;
    maxsq,list:array[0..MAXB] of byte;
    llast:array[0..MAXB,0..6] of byte;
    act,newlast,last:array[0..6] of byte;
    oklast,okact:array[1..NOK,0..MAXN] of boolean;
    okk:array[0..MAXB] of boolean;
    minsq:array[0..MAXB] of byte;
    i,j,k,m,n,p,q,qq,msq,ind,iqq:integer;
    smax,sact,sst:longint;
{
    t2:longint absolute 0:$046c;
    t1:longint;
}
procedure back(col,np:byte);
begin
if (col=6) or (np=k) then
  begin
    qq:=0;
    for j:=0 to 6 do
      if (act[j]>0) then
        qq:=qq or bit[j];

    if (np<minsq[qq]) then
      minsq[qq]:=np;
  end
else
  begin
    inc(act[col]);
    inc(act[col+1]);
    inc(newlast[col]);
    inc(newlast[col+1]);
    inc(np);

    back(col+1,np);

    dec(act[col]);
    dec(act[col+1]);
    dec(newlast[col]);
    dec(newlast[col+1]);
    dec(np);

    back(col+1,np);
  end;
end;

begin
{
t1:=t2;
}
assign(input,filein);
reset(input);
assign(output,fileout);
rewrite(output);

readln(n,k);
for i:=1 to n do
  begin
    for j:=0 to 6 do
      read(mat[i,j]);
    readln;
  end;

{ Compute MAX Squares for no. of lines }
maxsq[1]:=0;
for i:=2 to n do
  begin
    maxsq[i]:=maxsq[i-1]+4;
    if (maxsq[i]>k) then
      maxsq[i]:=k;
  end;
{ END MAX Squares }

{ Compute "OK" Binary Configurations }
fillchar(okk,sizeof(okk),true);
for q:=0 to 127 do
  begin
    fillchar(last,sizeof(last),0);
    for j:=0 to 6 do
      if (q and bit[j]>0) then
        last[j]:=1;

    if (last[0]=1) and (last[1]=0) then
      okk[q]:=false;
    if (last[6]=1) and (last[5]=0) then
      okk[q]:=false;

    for j:=1 to 5 do
      if (last[j]=1) then
        begin
          if not ((last[j-1]=1) or (last[j+1]=1)) then
            okk[q]:=false;
        end;
  end;

p:=0;
for q:=0 to 127 do
  if (okk[q]) then
    begin
      inc(p);
      list[p]:=q;

      for j:=0 to 6 do
        if (q and bit[j]>0) then
          llast[q,j]:=1
        else
          llast[q,j]:=0;
    end;
{ END "OK" Binary Configurations }

{ Compute MIN Squares for every "OK" Binary Config. }
fillchar(minsq,sizeof(minsq),120);
back(0,0);
{ END MIN Squares }

fillchar(lastmax,sizeof(lastmax),0);
fillchar(oklast,sizeof(oklast),false);
oklast[1,0]:=true;

smax:=0;
for i:=2 to n do
  begin
    fillchar(actmax,sizeof(actmax),128);
    fillchar(okact,sizeof(okact),false);
    okact[1,0]:=true;

    for iqq:=1 to NOK do
      begin
        qq:=list[iqq];

        msq:=maxsq[i-1];
        if (k-minsq[qq]<msq) then
          msq:=k-minsq[qq];

        for ind:=1 to NOK do
          begin
            q:=list[ind];

            sst:=0;
            for j:=0 to 6 do
              begin
                if (llast[q,j]=0) and (llast[qq,j]>0) then
                  sst:=sst+mat[i-1,j];
                if (llast[qq,j]>0) then
                  sst:=sst+mat[i,j];
              end;

            for p:=0 to msq do
              if (oklast[ind,p]) then
                begin
                  sact:=sst+lastmax[ind,p];

                  if (sact>actmax[iqq,p+minsq[qq]]) then
                    begin
                      actmax[iqq,p+minsq[qq]]:=sact;
                      okact[iqq,p+minsq[qq]]:=true;

                      if (sact>smax) then
                        smax:=sact;
                    end;
                end
          end;
      end;

    move(actmax,lastmax,sizeof(pmax));
    move(okact,oklast,sizeof(okact));
  end;

writeln(smax);
{
writeln(t2-t1);
}
close(output);
end.