// Liviu Andreicut - Bucuresti, ROMANIA

#include <stdio.h>
#include <math.h>
#include <string.h>

#define fin "fibo.in"
#define fout "fibo.out"

int n;

#define maxc 5000

class big
{
   public:
          int nc,nr[maxc];
          big();
          friend big operator*(big, int);
          big operator=(big);
          big operator=(int);
   };
   
big::big()
{
   nc=0;
   }

big operator*(big a, int b)
{
   int i,t=0;
   for (i=0;i<a.nc;i++)
       {
          a.nr[i]=a.nr[i]*b+t;
          t=a.nr[i]/10;
          a.nr[i]%=10;
          }
   while (t)
         {
            a.nr[a.nc++]=t%10;
            t/=10;
            }
   return a;
   }

big big::operator=(big a)
{
   int i;
   for (i=0;i<=a.nc;i++) nr[i]=a.nr[i];
   nc=a.nc;
   return *this;
   }

big big::operator=(int a)
{
   nc=0;
   while (a)
         {
            nr[nc++]=a%10;
            a/=10;
            }
   return *this;
   }

void ReadData()
{
   FILE *f=fopen(fin,"rt");
   fscanf(f,"%d",&n);
   fclose(f);
   }

void Solve()
{
   FILE *f=fopen(fout,"wt");
   if (n<3) fprintf(f,"-1");
   else
       {
          big a;
          a=3;
          int unit=4;
          int max=(n-2)/(unit/2);
          int r=(n-2)%(unit/2);
          register int i;
          for (i=0;i<max;i++) a=a*unit;
          for (i=0;i<r;i++) a=a*2;
          for (i=a.nc-1;i>=0;i--) fprintf(f,"%d",a.nr[i]);
          }
   fclose(f);
   }

main()
{
   ReadData();
   Solve();
   return 0;
   }
