// This is a Demo Header
// It will not be used for Evaluation
// Please report any bugs found
// Copyright (c) 2002 - Agora Media SRL

#include <stdlib.h>
#include <stdio.h>
#include <dos.h>

long _win,_lose,_equal,_moves;
long far *_t;
long _tmax;
int _theboard[9];
int _initialized,_computer,_error,_time=0;

void InitGame(void){
  int i;
  if (!_time){
    _t=(long far*)0x46C;
    _tmax=*_t+18;
    _time=1;
  }
  _error=_moves=0;
  for (i=0;i<9;i++)
    _theboard[i]=0;
  if (_initialized)
    _error=1;
  _computer=_initialized=1;
}

void _Finish(void){
  printf("Wins: %7ld\n",_win);
  printf("Draws:%7ld\n",_equal);
  printf("Loses:%7ld\n",_lose);
  puts("-------------");
  printf("Points:%6ld\n\n",(_win*2+_equal)/1000);
  exit(1);
}

int _Victory(int x){
  if (_theboard[0]==x && _theboard[1]==x && _theboard[2]==x)
    return 1;
  if (_theboard[3]==x && _theboard[4]==x && _theboard[5]==x)
    return 1;
  if (_theboard[6]==x && _theboard[7]==x && _theboard[8]==x)
    return 1;
  if (_theboard[0]==x && _theboard[3]==x && _theboard[6]==x)
    return 1;
  if (_theboard[1]==x && _theboard[4]==x && _theboard[7]==x)
    return 1;
  if (_theboard[2]==x && _theboard[5]==x && _theboard[8]==x)
    return 1;
  if (_theboard[2]==x && _theboard[4]==x && _theboard[6]==x)
    return 1;
  if (_theboard[0]==x && _theboard[4]==x && _theboard[8]==x)
    return 1;
  return 0;
}

int YourMove(void){
  int x;
  if (*_t>_tmax) _Finish();
  if (!_computer || !_initialized)
    _error=1;
  if (_error){
    _initialized=0;
    _lose++;
    return -1;
  }
  if (_Victory(1)){
    _initialized=0;
    _win++;
    return -1;
  }
  do{
    x=random(9);
  } while (_theboard[x]);
  _theboard[x]=2;
  _moves++;
  if (_Victory(2)){
    _initialized=0;
    _lose++;
    return -1;
  }
  if (_moves==9){
    _initialized=0;
    _equal++;
    return -1;
  }
  _computer=0;
  return x;
}

void MyMove(int x){
  if (_computer || !_initialized)
    _error=1;
  else if (_theboard[x]) _error=1;
       else _theboard[x]=1;
  _computer=1;
  _moves++;
}