{
  This is a Demo Header
  It will not be used for Evaluation
  Please report any bugs found
  Copyright (c) 2002 - Agora Media SRL
}

unit tictac;

interface

var _win,_lose,_equal,_moves:Longint;
    _t:Longint absolute $0:$46c;
    _tmax:Longint;
    _theboard:array[0..8] of Integer;
    _initialized,_computer,_error:Boolean;

procedure InitGame;
function YourMove:Integer;
procedure MyMove(x:Integer);

implementation

procedure InitGame;
var i:Integer;
begin
  _error:=false;
  _moves:=0;
  for i:=0 to 8 do
    _theboard[i]:=0;
  if _initialized then
    _error:=true;
  _computer:=true;
  _initialized:=true;
end;

procedure _Finish;
begin
  Writeln('Wins: ',_win:7);
  Writeln('Draws:',_equal:7);
  Writeln('Loses:',_lose:7);
  Writeln('-------------');
  Writeln('Points:', (_win*2+_equal) div 1000:6);
  Writeln;
  Halt;
end;

function _Victory(x:Integer):Boolean;
begin
  if (_theboard[0]=x) and (_theboard[1]=x) and (_theboard[2]=x)
  then begin _Victory:=true;exit; end;
  if (_theboard[3]=x) and (_theboard[4]=x) and (_theboard[5]=x)
  then begin _Victory:=true;exit; end;
  if (_theboard[6]=x) and (_theboard[7]=x) and (_theboard[8]=x)
  then begin _Victory:=true;exit; end;
  if (_theboard[0]=x) and (_theboard[3]=x) and (_theboard[6]=x)
  then begin _Victory:=true;exit; end;
  if (_theboard[1]=x) and (_theboard[4]=x) and (_theboard[7]=x)
  then begin _Victory:=true;exit; end;
  if (_theboard[2]=x) and (_theboard[5]=x) and (_theboard[8]=x)
  then begin _Victory:=true;exit; end;
  if (_theboard[2]=x) and (_theboard[4]=x) and (_theboard[6]=x)
  then begin _Victory:=true;exit; end;
  if (_theboard[0]=x) and (_theboard[4]=x) and (_theboard[8]=x)
  then begin _Victory:=true;exit; end;
  _Victory:=false;
end;

function YourMove:Integer;
var x:Integer;
begin
  if _t>_tmax then _Finish;
  if not _computer or not _initialized then
    _error:=true;
  if _error then
  begin
    YourMove:=-1;
    _initialized:=false;
    inc(_lose);
    exit;
  end;
  if _Victory(1) then
  begin
    YourMove:=-1;
    _initialized:=false;
    inc(_win);
    exit;
  end;
  repeat
    x:=random(9);
  until _theboard[x]=0;
  _theboard[x]:=2;
  inc(_moves);
  if _Victory(2) then
  begin
    YourMove:=-1;
    _initialized:=false;
    inc(_lose);
    exit;
  end;
  if _moves=9 then
  begin
    YourMove:=-1;
    _initialized:=false;
    inc(_equal);
    exit;
  end;
  YourMove:=x;
  _computer:=false;
end;

procedure MyMove(x:Integer);
begin
  if _computer or not _initialized then _error:=true
  else
    if (_theboard[x]<>0) then _error:=true
    else _theboard[x]:=1;
  _computer:=true;
  inc(_moves);
end;

begin
  _tmax:=_t+18;
  _initialized:=false;
end.
