{ Mugurel Ionut Andreica - Bucuresti, ROMANIA }

Program _wormhole_;

const filein='wormhole.in';
      fileout='wormhole.out';
      maxdigits=1000;
      baza=10000;
      avans=5;

type BigNum=array[0..maxdigits] of longint;
     pBigNum=^BigNum;

var fin,fout:text;
    vact,vaux,vaux2,res:BigNum;
    i,j,k,n,r:longint;

procedure movebignum(n1:pBigNum;rez:pBigNum);
var i:integer;
begin
fillchar(rez^,sizeof(rez^),0);

for i:=0 to n1^[0] do
  rez^[i]:=n1^[i];
end;

procedure mult(x:longint;n1:pBigNum;rez:pBigNum);
var i,ndig:integer;
begin
fillchar(rez^,sizeof(BigNum),0);

ndig:=n1^[0];
for i:=1 to ndig do
  rez^[i]:=n1^[i]*x;

for i:=1 to ndig+avans do
  if (rez^[i]>=baza) then
    begin
      rez^[i+1]:=rez^[i+1]+(rez^[i] div baza);
      rez^[i]:=rez^[i] mod baza;
    end;

for i:=ndig+avans downto 1 do
  if (rez^[i]>0) then
    begin
      rez^[0]:=i; break;
    end;
end;

procedure addbignum(n1:pBigNum;n2:pBigNum;rez:pBigNum);
var i,ndig:integer;
begin
fillchar(rez^,sizeof(BigNum),0);

if (n1^[0]>n2^[0]) then
  ndig:=n1^[0]
else
  ndig:=n2^[0];

for i:=1 to ndig do
  rez^[i]:=n1^[i]+n2^[i];

for i:=1 to ndig+avans do
  if (rez^[i]>=baza) then
    begin
      rez^[i+1]:=rez^[i+1]+(rez^[i] div baza);
      rez^[i]:=rez^[i] mod baza;
    end;

for i:=ndig+avans downto 1 do
  if (rez^[i]>0) then
    begin
      rez^[0]:=i; break;
    end;
end;

begin
assign(fin,filein);
reset(fin);
read(fin,n);
close(fin);

fillchar(res,sizeof(res),0);
res[0]:=1;
fillchar(vact,sizeof(vact),0);
vact[0]:=1; vact[1]:=1;

i:=n;
while (i>=2) do
  begin
    if (i=n) and (n and 1=0) then
      begin
        res[1]:=1;
        mult(n,@vact,@vaux);
        movebignum(@vaux,@vact);
        dec(i);
      end
    else
      begin
        mult(i-1,@vact,@vaux);
        addbignum(@vaux,@res,@vaux2);
        movebignum(@vaux2,@res);

        mult(i,@vact,@vaux);
        mult(i-1,@vaux,@vact);

        dec(i,2);
      end;
  end;

assign(fout,fileout);
rewrite(fout);
write(fout,res[res[0]]);
for i:=res[0]-1 downto 1 do
  begin
    k:=baza div 10;
    while (k>0) do
      begin
        write(fout,(res[i] div k) mod 10);
        k:=k div 10;
      end;
  end;
close(fout);
end.