/*
This is a C++ example of the GRAPH.H header utilization.
It produces the correct result only for the GRAPH.TXT initialization file
  provided as example.
This file is open-source. It can be modified and distributed freely.
This file is distributed as-done.
The GInfo Editorial Stuff is not responsible
   for any damage caused by the use of this file!
Author: Mihai Scortaru
Please report any bugs found in this file not later than
   Tuesday, December 3rd, 2002!
*/

#include <stdio.h>
#include "graph.h"

void main(void){
  Init();
  puts("");
  puts("");
  int n = GetNumberOfNodes();
  printf("The graph has %d nodes.\n",n);
  int m = GetNumberOfCallsLeft();
  printf("There are %d calls available.\n",m);
  puts("The weight of the nodes are:");
  for (int i=1;i<=n;i++)
    printf("    The weight of node %d is %ld.\n",i,GetNodeWeight(i));
  puts("The edges in the graph are:");
  for (i=1;i<=n;i++)
    for (int j=i+1;j<=n;j++)
      if (IsEdgeBetween(i,j))
	printf("    Thre is an edge between the nodes %d and %d.\n",i,j);
  if (CheckEdgeWeight(1,2,7))
    puts("The weight of the edge between the nodes 1 and 2 is 7.");
  if (CheckEdgeWeight(1,2,2))
    puts("The weight of the edge between the nodes 1 and 2 is 2.");
  Result(1,2,2);
  Result(2,3,3);
  Result(3,4,5);
  Result(4,1,7);
}