{
This is a Pascal example of the GRAPH.PAS unit utilization.
It produces the correct result only for the GRAPH.TXT initialization file
  provided as example.
This file is open-source. It can be modified and distributed freely.
This file is distributed as-done.
The GInfo Editorial Stuff is not responsible
   for any damage caused by the use of this file!
Author: Mihai Scortaru
Please report any bugs found in this file not later than
   Tuesday, December 3rd, 2002!
}

uses graph;
var i,j,m,n:Integer;
    m1:Integer;
begin
  writeln;
  writeln;
  init;
  n:=GetNumberOfNodes;
  writeln('The graph has ', n, ' nodes.');
  m:=GetNumberOfCallsLeft;
  writeln('There are ', m, ' calls available.');
  writeln('The weights of the nodes are:');
  for i:=1 to n do
  writeln('    The weight of node ',i,' is ',GetNodeWeight(i),'.');
  writeln('The edges in the graph are:');
  for i:=1 to n do
    for j:=i+1 to n do
      if IsEdgeBetween(i,j) then
        writeln('    There is an edge between the nodes ', i,' and ',j,'.');
  if CheckEdgeWeight(1,2,7) then
    writeln('The weight of the edge between the nodes 1 and 2 is 7.');
  if CheckEdgeWeight(1,2,2) then
    writeln('The weight of the edge between the nodes 1 and 2 is 2.');
  Result(1,2,2);
  Result(2,3,3);
  Result(3,4,5);
  Result(4,1,7);
end.