{$A+,B-,D+,E+,F-,G-,I+,L+,N-,O-,P-,Q-,R-,S+,T-,V+,X+,Y+}
{$M 16384,0,655360}
{
This is a demo for the SORT.PAS Pascal unit.
It will not be used during the evaluation process.
Please do not use in your program the variables defined in this file!
  The variables in the unit used during the evaluation process have
  different identifiers, so your source might not be compiled correctly!
The time needed for the execution of the functions and procedures in the unit
  used for evaluation will be no longer than the time needed for the
  execution of the functions and procedures in this unit!
The unit uses the file SORT.TXT for initializing. You may edit your own SORT.TXT
  file in order to test your program! Your program must not try to open the
  SORT.TXT file for reading because this file will not exist during the evaluation.
  The unit used for evaluation will use a different method for getting the initial data!
This file is freeware. It cannot be modified, but can be distributed freely.
This file is distributed as-done.
The GInfo Editorial Staff is not responsible
  for any damage caused by the use of this file!
Author: Mihai Scortaru
Please report any bugs found in this file not later than
  Tuesday, January 22nd, 2003!
}
unit sort;

interface

procedure Init;
function GetN:Integer;
function GetNoComp:Integer;
function IsGreater(i,j:Integer):Boolean;
procedure Result(i,pi:Integer);

implementation

type IntegerArray=array[1..255] of Integer;
     BooleanArray=array[1..255] of Boolean;
var  a,p:IntegerArray;
     r:BooleanArray;
     N,callsLeft,noResults:Integer;
     initialized:boolean;

procedure error(s:string);
begin
  writeln(s);
  halt;
end;

function GetN:Integer;
begin
  if not initialized then
    error('Library not initialized!');
  GetN := N;
end;

function GetNoComp:Integer;
begin
  if not initialized then
    error('Library not initialized!');
  GetNoComp := callsLeft;
end;

function IsGreater(i,j:Integer):Boolean;
begin
  if not initialized then
    error('Library not initialized!');
  if (i<1) or (i>N) or  (j<1) or (j>N) then
    error('Invalid element!');
  if callsleft = 0 then
    error('Too many calls!');
  Dec(callsLeft);
  IsGreater := a[i] > a[j];
end;

procedure Init;
var i:Integer;
    f:text;
begin
 if initialized then
    error('Library already initialized!');
  initialized := true;
  noResults := 0;
  assign(f,'SORT.TXT');
  reset(f);
  readln(f,N);
  readln(f,callsLeft);
  for i:=1 to N do
    read(f,a[i]);
  for i:=1 to N do
    read(f,p[i]);
  close(f);
end;

procedure Result(i, pi:Integer);
begin
  if not initialized then
    error('Library already initialized!');
  if (i<1) or (i>N) or  (pi<1) or (pi>N) then
    error('Invalid element!');
  if p[i]<>pi then
    error('Wrong answer!');
  if r[i] then
    error('Result submitted twice!');
  r[i]:=true;
  inc(noResults);
  if noResults = N then
    error('Ok!');
end;

end.