{$A+,B-,D+,E+,F-,G-,I+,L+,N-,O-,P-,Q-,R-,S+,T-,V+,X+,Y+}
{$M 16384,0,655360}
{
This is a demo for the ARROWS.PAS Pascal unit.
It will not be used during the evaluation process.
Please do not use in your program the variables defined in this file!
  The variables in the unit used during the evaluation process have
  different identifiers, so your source might not be compiled correctly!
The time needed for the execution of the functions and procedures in the unit
  used for evaluation will be no longer than the time needed for the
  execution of the functions and procedures in this unit!
The unit uses the file ARROWS.TXT for initializing. You may edit your own ARROWS.TXT
  file in order to test your program! Your program must not try to open the
  ARROWS.TXT file for reading because this file will not exist during the evaluation.
  The unit used for evaluation will use a different method for getting the initial data!
This file is freeware. It cannot be modified, but can be distributed freely.
This file is distributed as-done.
The GInfo Editorial Staff is not responsible
  for any damage caused by the use of this file!
Author: Mihai Scortaru
Please report any bugs found in this file not later than
  Tuesday, March 11th, 2003!
}
unit arrows;

interface

procedure Init;
function GetN:Integer;
function IsArrow(i,j:Integer):Boolean;
procedure Result(i:Integer);

implementation

var  a:array[1..100,1..100] of Integer;
     N,callsLeft,rez:Integer;
     initialized:boolean;

procedure error(s:string);
begin
  writeln(s);
  halt;
end;

function GetN:Integer;
begin
  if not initialized then
    error('Library not initialized!');
  GetN := N;
end;

function IsArrow(i,j:Integer):Boolean;
begin
  if not initialized then
    error('Library not initialized!');
  if (i<1) or (i>N) or (j<1) or (j>N) then
    error('Invalid element!');
  if callsleft = 0 then
    error('Too many calls!');
  Dec(callsLeft);
  IsArrow := a[i][j] <> 0;
end;

procedure Init;
var i,j:Integer;
    f:text;
begin
 if initialized then
    error('Library already initialized!');
  initialized := true;
  assign(f,'ARROWS.TXT');
  reset(f);
  readln(f,N,Rez);
  callsLeft := 2 * N;
  for i:=1 to N do
    for j:=1 to N do
      read(f,a[i][j]);
  close(f);
end;

procedure Result(i:Integer);
begin
  if not initialized then
    error('Library already initialized!');
  if (i<1) or (i>N) then
    error('Invalid element!');
  if i<>rez then
    error('Wrong answer!');
  error('Ok!');
end;

end.