/* Mugurel Ionut Andreica - Bucuresti, ROMANIA */

/* A greedy algorithm (obviously not optimal) */

/* - varianta 1 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#define maxn 101
#define filein "football.in"
#define fileout "football.out"

int wins[maxn],draws[maxn],loses[maxn],ow[maxn],ol[maxn];
int gsco[maxn],grec[maxn],score[maxn][maxn];
int win[maxn][maxn],i,j,k,m,n,p,ok;

int main()
{
freopen(filein,"r",stdin);
scanf("%d",&n);
for (i=1;i<=n;i++)
  {
  scanf("%d %d %d %d %d",&wins[i],&draws[i],&loses[i],&gsco[i],&grec[i]);
  ow[i]=ol[i]=i;
  }

/* Sort the teams in decreasing order of the number of matches won */
for (i=1;i<n;i++)
  for (j=i+1;j<=n;j++)
    if ((wins[ow[i]]<wins[ow[j]]) ||
	(wins[ow[i]]==wins[ow[j]] && loses[ow[i]]<loses[ow[j]]))
      {
      k=ow[i]; ow[i]=ow[j]; ow[j]=k;
      }

/* Sort the teams in decreasing order of the number of matches lost */
for (i=1;i<n;i++)
  for (j=i+1;j<=n;j++)
    if ((loses[ol[i]]<loses[ol[j]]) ||
	(loses[ol[i]]==loses[ol[j]] && wins[ol[i]]>wins[ol[j]]))
      {
      k=ol[i]; ol[i]=ol[j]; ol[j]=k;
      }

/* Establish the outcome of every match: victory, draw or loss */
memset(win,0,sizeof(win));
for (p=1;p<=n;p++)
  {
  i=ow[p];
  for (j=1;j<=n && wins[i]>0;j++)
    if (i!=ol[j] && win[i][ol[j]]==0 && loses[ol[j]]>0)
      {
      win[i][ol[j]]=1;
      win[ol[j]][i]=-1;
      wins[i]--;
      loses[ol[j]]--;
      }

  /* Re-sort teams in decreasing order of number of matches lost */
  for (i=1;i<n;i++)
    for (j=i+1;j<=n;j++)
      if ((loses[ol[i]]<loses[ol[j]]) ||
	  (loses[ol[i]]==loses[ol[j]] && wins[ol[i]]>wins[ol[j]]))
	{
	k=ol[i]; ol[i]=ol[j]; ol[j]=k;
	}
  }

/* Set the scores for every match */
memset(score,0,sizeof(score));

/* First, set all victories to a score of 1:0 and all draws to a score of 0:0 */
for (i=1;i<n;i++)
  for (j=i+1;j<=n;j++)
    if (win[i][j]==1)
      score[i][j]=1,gsco[i]--,grec[j]--;
    else
    if (win[i][j]==-1)
      score[j][i]=1,gsco[j]--,grec[i]--;

/*
   Next, increase the scores in every match, until every team
   has scored & received the given amount of goals
*/

for (ok=1;ok;)
  {
  ok=0;

  /* Sort the teams in decreasing order of the number of goals left to score */
  for (i=1;i<n;i++)
    for (j=i+1;j<=n;j++)
      if ((gsco[ow[i]]<gsco[ow[j]]) ||
	  (gsco[ow[i]]==gsco[ow[j]] && grec[ow[i]]<grec[ow[j]]))
	{
	k=ow[i]; ow[i]=ow[j]; ow[j]=k;
	}

  /* Sort the teams in decreasing order of the number of goals left to receive */
  for (i=1;i<n;i++)
    for (j=i+1;j<=n;j++)
      if ((grec[ol[i]]<grec[ol[j]]) ||
	  (grec[ol[i]]==grec[ol[j]] && gsco[ol[i]]>gsco[ol[j]]))
	{
	k=ol[i]; ol[i]=ol[j]; ol[j]=k;
	}

  for (p=1;p<=n;p++)
    {
    i=ow[p];
    for (k=1;k<=n && gsco[i]>0;k++)
      if (ol[k]!=i && grec[ol[k]]>0)
	{
	j=ol[k];

	if (win[i][j]==1)
	  {
	  /* i wins */
	  if (score[i][j]<10)
	    {
	    score[i][j]++;
	    gsco[i]--;
	    grec[j]--;
	    ok=1;
	    }
	  }
	else
	if (win[j][i]==1)
	  {
	  /* j wins */
	  if (score[j][i]-score[i][j]>1 && score[i][j]<10)
	    {
	    score[i][j]++;
	    gsco[i]--;
	    grec[j]--;
	    ok=1;
	    }
	  }
	else
	  {
	  /* it's a draw */
	  if (gsco[j]>0 && grec[i]>0 && score[i][j]<10)
	    {
	    score[i][j]++;
	    score[j][i]++;
	    gsco[i]--; gsco[j]--;
	    grec[i]--; grec[j]--;
	    ok=1;
	    }
	  }
	}
    }
  }

/* Output the SCORE matrix */
freopen(fileout,"w",stdout);
for (i=1;i<=n;i++)
  {
  printf("%d",score[i][1]);
  for (j=2;j<=n;j++)
    printf(" %d",score[i][j]);
  printf("\n");
  }

return 0;
}