{$A+,B-,D+,E+,F-,G-,I+,L+,N-,O-,P-,Q-,R-,S+,T-,V+,X+,Y+}
{$M 16384,0,655360}
{
This is a demo for the MIDDLE.PAS Pascal unit.
It will not be used during the evaluation process.
Please do not use in your program the variables defined in this file!
  The variables in the unit used during the evaluation process have
  different identifiers, so your source might not be compiled correctly!
The time needed for the execution of the functions and procedures in the unit
  used for evaluation will be no longer than the time needed for the
  execution of the functions and procedures in this unit!
The unit uses the file MIDDLE.TXT for initializing. You may edit your own MAX.TXT
  file in order to test your program! Your program must not try to open the
  MIDDLE.TXT file for reading because this file will not exist during the evaluation.
  The unit used for evaluation will use a different method for getting the initial data!
This file is freeware. It cannot be modified, but can be distributed freely.
This file is distributed as-done.
The GInfo Editorial Staff is not responsible
  for any damage caused by the use of this file!
Author: Mihai Scortaru
Please report any bugs found in this file as soon as possible!
}
unit middle;

interface

procedure Init;
function Get2N:Integer;
function GetNoComp:Integer;
function IsGreater(i,j:Integer):Boolean;
procedure Result(x:Integer);

implementation

type IntegerArray=array[1..2457*2] of Integer;
var  a:IntegerArray;
     N,callsLeft,noResults:Integer;
     initialized:boolean;
     results:integer;
     p1,p2:integer;

procedure error(s:string);
begin
  writeln(s);
  halt;
end;

function Get2N:Integer;
begin
  if not initialized then
    error('Library not initialized!');
  Get2N := 2 * N;
end;

function GetNoComp:Integer;
begin
  if not initialized then
    error('Library not initialized!');
  GetNoComp := callsLeft;
end;

function IsGreater(i,j:Integer):Boolean;
begin
  if not initialized then
    error('Library not initialized!');
  if (i<1) or (i>2 * N) or  (j<1) or (j>2 * N) then
    error('Invalid element!');
  if callsleft = 0 then
    error('Too many calls!');
  Dec(callsLeft);
  IsGreater := a[i] > a[j];
end;

procedure Init;
var i:Integer;
    f:text;
begin
 if initialized then
    error('Library already initialized!');
  initialized := true;
  results := 0;
  noResults := 0;
  assign(f,'MIDDLE.TXT');
  reset(f);
  readln(f,N);
  readln(f,callsLeft);
  for i:=1 to 2 * N do
    read(f,a[i]);
  readln(f,p1,p2);
  close(f);
end;

procedure Result(x:Integer);
begin
  if not initialized then
    error('Library already initialized!');
  if (x<1) or (x>2 * N) then
    error('Invalid element!');
  if (x=p1) or (x=p2) then
    error('Ok!');
  inc(results);
  if results = 2 then
    error('Wrong answer!');
end;

end.