/* Mugurel Ionut Andreica - Bucuresti, ROMANIA */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#define maxc 200
#define baza 10
#define fwd 10
#define eps 1e-9

typedef long BigNum[maxc];

long compare(BigNum, BigNum);
void add(BigNum, BigNum, BigNum);

BigNum N, naux1, naux2, nn, counter;
char s[maxc];
double p, q, pq, clast, c;

int main()
{
int i, j, k, n;

freopen("REC.IN", "r", stdin);
freopen("REC.OUT", "w", stdout);

scanf("%lf %lf %s", &p, &q, &s);

memset(N, 0, sizeof(N));
for (n = strlen(s), N[0] = n, i = n-1; i >= 0; i--)
  N[i+1] = s[n-i-1]-'0';

memset(nn, 0, sizeof(BigNum));
nn[0] = nn[1] = 1;
memset(counter, 0, sizeof(counter));
counter[0] = 1;
clast = 0;

for (i = 0; 1; i++)
  {
    c = q/p;

    if (compare(N, counter) == 0)
      break;

    add(nn, counter, naux1);
    memmove(counter, naux1, sizeof(BigNum));

    if (fabs(c-clast) < eps)
      break;
    clast = c;

    pq = p + q;
    p = q;
    q = pq;
  }

printf("%.8lf\n", floor(c*100000000.0+0.001)/100000000.0);
return 0;
}

/* 1 if n1 > n2 ; -1 if n1 < n2 ; 0 if n1 == n2 */
long compare(BigNum n1, BigNum n2)
{
long i, res;

if (n1[0] > n2[0]) return 1;
if (n1[0] < n2[0]) return -1;

for (res = 0, i = n1[0]; i >= 1; i--)
  if (n1[i] > n2[i])
    {
      res=1;
      break;
    }
  else
  if (n1[i] < n2[i])
    {
      res=-1;
      break;
    }

return res;
}

void add(BigNum n1, BigNum n2, BigNum rez)
{
long i, ndigits = n1[0];

if (n2[0] > ndigits)
  ndigits = n2[0];

memset(rez, 0, sizeof(BigNum));
for (i = 1; i <= ndigits; i++)
  rez[i] = n1[i]+n2[i];

for (i = 1 ;i <= (ndigits+fwd); i++)
  if (rez[i] >= baza)
    {
      rez[i+1] += (rez[i]/baza);
      rez[i] %= baza;
    }

for (i = (ndigits+fwd); i >= 1; i--)
  if (rez[i] > 0)
    {
      rez[0] = i;
      break;
    }
}

