#include <stdio.h>
#include <math.h>
#include <dos.h>
#define filein "WEAPON.IN"
#define fileout "WEAPON.TXT"
#define eps 1e-7

long int R, R2, i, j;
double nnum, l, Rd_, sqrt2;

double cerc(long int R2)
{
double np, Rd;
long int i, h, R, min;

R = (long int)(floor(Rd_));
Rd = Rd_/sqrt2;

if (fabs(Rd-floor(Rd)) < eps)
  Rd = floor(Rd);
if (fabs(Rd-ceil(Rd)) < eps)
  Rd = ceil(Rd);

np = 2.0*floor(Rd)+1;
np = np*np;

for (i = R, min = floor(Rd)+1, h = 0; i >= min; i--)
  {
    while (i*i + h*h <= R2)
      h++;

    h--;
    np += 4*(2*h+1);
  }

return np;
}

double cerc2(long int R2, long int lsq)
{
double np;
long int i, h;

np = 0;

for (h = 0, i = lsq; i >= 1; i--)
  {
    while (i*i + h*h <= R2 && h <= lsq)
      h++;
    h--;

    np += 4.0*h;
  }

return np + 4.0*lsq + 1.0;
}

double cerc3(long int R2, long int lsq)
{
double np;
long int i, j, k;

np = 0;
for (i = -lsq; i <= lsq; i++)
  for (j = -lsq; j <= lsq; j++)
    if (i*i + j*j <= R2)
      np++;

return np;
}


int main()
{
FILE *fout = fopen(fileout, "w");

for (R = 10000; R >= 1; R--)
{

l = R;
l = l/sqrt(3.0);
nnum = (2.0*floor(l)+1);
nnum = nnum*nnum*nnum;

sqrt2 = sqrt(2.0);
for (i = floor(l)+1; i <= R; i++)
  {
    R2 = (R*R-i*i);
    Rd_ = sqrt(R2);

    if (i*i <= R2)
      {
        nnum += 6.0*(cerc2(R2, i));

        l = sqrt(R2 - i*i);
        nnum -= 12.0*(2.0*floor(l)+1);
      }
    else
      nnum += 6.0*(cerc(R2));
  }

fprintf(fout, "%.0lf.0,\n", nnum);
fflush(fout);

printf("%ld\n", R);
}

return 0;
}