#include <stdio.h>
#include <string.h>
#define filein "MOUNTAIN.IN"
#define fileout "MOUNTAIN.OUT"
#define maxn 10010

char num[maxn], v[maxn];
int maxlr[maxn], maxrl[maxn], li, ls, i, j, k, m, n, poz;

int main()
{
/* read data */
freopen(filein, "r", stdin);
scanf(" %s", num+1);
n = strlen(num+1);

for (i = 1; i <= n; i++)
  num[i] -= '0';

/* compute maxlr */
memset(maxlr, 0, sizeof(maxlr));

v[k = maxlr[1] = 1] = num[1];

for (i = 2; i <= n; i++)
  {
    j = num[i];

    if (j >= v[k])
      {
        k++;
        v[k] = j;
        maxlr[i] = k;
      }
    else
    if (j < v[1])
      v[1] = j, maxlr[i] = 1;
    else
    if (j >= v[1] && j < v[k])
      {
        li = 1; ls = k;
        while (li <= ls)
          {
            m = (li+ls) >> 1;

            if (j<v[m])
              {
                poz = m;
                ls = m-1;
              }
            else
            if (j >= v[m])
              li = m+1;
          }

        v[poz] = j;
        maxlr[i] = poz;
      }
  }

/* Some DEBUG */

/*
printf("Left to Right: %d\n", k);

for (k = 1, i = 2; i <= n; i++)
  {
    maxlr[i] = 0;
    for (j = i-1; j; j--)
      if (num[j] <= num[i] && maxlr[j] > maxlr[i])
        maxlr[i] = maxlr[j];

    maxlr[i]++;

    if (maxlr[i] > k)
      k = maxlr[i], m = i;
  }

printf("Left to Right (*) : %d  Poz : %d\n", k, m);
*/

for (i = 1; i <= n; i++)
  if (maxlr[i] < maxlr[i-1])
    maxlr[i] = maxlr[i-1];

/* compute maxrl */
memset(maxrl, 0, sizeof(maxrl));

v[k = maxrl[n] = 1] = num[n];

for (i = n-1; i; i--)
  {
    j = num[i];

    if (j >= v[k])
      {
        k++;
        v[k] = j;
        maxrl[i] = k;
      }
    else
    if (j < v[1])
      v[1] = j, maxrl[i] = 1;
    else
    if (j >= v[1] && j < v[k])
      {
        li = 1; ls = k;
        while (li <= ls)
          {
            m = (li+ls) >> 1;

            if (j<v[m])
              {
                poz = m;
                ls = m-1;
              }
            else
            if (j >= v[m])
              li = m+1;
          }

        v[poz] = j;
        maxrl[i] = poz;
      }
  }

for (i = n; i; i--)
  if (maxrl[i] < maxrl[i+1])
    maxrl[i] = maxrl[i+1];

/* compute the answer */
for (m = i = 0; i <= n; i++)
  if (maxlr[i] + maxrl[i+1] > m)
    m = maxlr[i] + maxrl[i+1];

freopen(fileout, "w", stdout);
printf("%d\n", n-m);

return 0;
}
