/* Time Complexity: O(N) */

#include <stdio.h>
#include <string.h>
#include <math.h>
#define filein "POINTS.IN"
#define fileout "POINTS.OUT"

long int rx1, ry1, rx2, ry2, rx3, ry3, i, j, k, N, npar;
double np[4], total;

int main()
{
freopen(filein, "r", stdin);
scanf("%ld", &N);

memset(np, 0, sizeof(np));
for (i = 0; i < N; i++)
  {
    scanf("%ld %ld", &rx1, &ry1);

    np[(rx1&1)+((ry1&1)<<1)]++;
  }

total = 0;
for (i = 0; i < 4; i++)
  for (j = i; j < 4; j++)
    for (k = j; k < 4; k++)
      {
        rx1 = i & 1, ry1 = (i >> 1) & 1;
        rx2 = j & 1, ry2 = (j >> 1) & 1;
        rx3 = k & 1, ry3 = (k >> 1) & 1;

        npar = 0;

        if (!rx1 || (ry2 == ry3)) npar++;
        if (!rx2 || (ry3 == ry1)) npar++;
        if (!rx3 || (ry1 == ry2)) npar++;

        if (npar == 1 || npar == 3)
          {
            if (i == j && j == k)
              total += np[i]*(np[j]-1)*(np[k]-2)/6.0;
            else
            if (i == j)
              total += np[i]*(np[j]-1)/2.0*np[k];
            else
            if (j == k)
              total += np[i]*np[j]*(np[k]-1)/2.0;
            else
              total += np[i]*np[j]*np[k];
          }
      }


freopen(fileout, "w", stdout);
printf("%.0lf\n", total);

return 0;
}