/* Time Complexity: O(N+M) */

#include <stdio.h>
#include <string.h>
#define filein "DEVICES.IN"
#define fileout "DEVICES.OUT"
#define maxn 501
#define maxm 5001

int c1[maxm], c2[maxm], nextdir[maxm], nextinv[maxm];
int dir[maxn], inv[maxn], o[maxn], visited[maxn];
int N, M, K, nctc;

void dfdir(int);
void dfinv(int);

int main()
{
int i, j, k;

freopen(filein, "r", stdin);
scanf("%d %d", &N, &M);

memset(c1, 0, sizeof(c1));
memset(c2, 0, sizeof(c2));
memset(nextdir, 0, sizeof(nextdir));
memset(nextinv, 0, sizeof(nextinv));
memset(dir, 0, sizeof(dir));
memset(inv, 0, sizeof(inv));

for (k = 1; k <= M; k++)
  {
    scanf("%d %d", &i, &j);
    c1[k] = i; c2[k] = j;

    nextdir[k] = dir[i];
    dir[i] = k;
    nextinv[k] = inv[j];
    inv[j] = k;
  }

memset(visited, 0, sizeof(visited));
K = 0;
for (i = 1; i <= N; i++)
  if (!visited[i])
    dfdir(i);

memset(visited, 0, sizeof(visited));
for (nctc = 0, i = N; i; i--)
  if (!visited[o[i]])
    {
      nctc++;
      dfinv(o[i]);
    }

freopen(fileout, "w", stdout);
printf("%d\n", nctc);

return 0;
}

void dfdir(int nod)
{
int j, k;

visited[nod] = 1;

for (k = dir[nod]; k; k = nextdir[k])
  {
    j = c2[k];

    if (!visited[j])
      dfdir(j);
  }

K++;
o[K] = nod;
}

void dfinv(int nod)
{
int j, k;

visited[nod] = nctc;

for (k = inv[nod]; k; k = nextinv[k])
  {
    j = c1[k];
    if (!visited[j])
      dfinv(j);
  }
}
