{$A+,B-,D+,E+,F-,G-,I-,L+,N-,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
{$M 16384,0,655360}

Program _JBOMB_;

const filein = 'JBOMB.IN';
      fileout = 'JBOMB.OUT';
      MAXN = 21;
      infinit = 64000;
      dl : array [1..6] of integer = (-1, +1,  0,  0,  0,  0);
      dc : array [1..6] of integer = ( 0,  0, -1, +1,  0,  0);
      dn : array [1..6] of integer = ( 0,  0,  0,  0, -1, +1);

type pq = ^q;
     q = record
           l, c, ni : integer;
           urm : pq;
         end;

var a : array [1..MAXN, 1..MAXN, 1..MAXN] of byte;
    d, dout : array [1..MAXN, 1..MAXN, 1..MAXN] of word;
    i, j, k, m, n, p, lj, cj, nj, lb, cb, nb : integer;
    t, w : word;
    ch : char;
    cst, cfin, aux : pq;

procedure addtoq(i, j, k : integer);
begin
if (cst = nil) then
  begin
    new(cst);
    cst^.ni := i;
    cst^.l := j;
    cst^.c := k;
    cst^.urm := nil;
    cfin := cst;
  end
else
  begin
    new(aux);
    aux^.ni := i;
    aux^.l := j;
    aux^.c := k;
    aux^.urm := nil;
    cfin^.urm := aux;
    cfin := aux;
  end;
end;

procedure computedout;
var l, c, ni, i, j, k, lnext, cnext, nnext : integer;
begin
for i := 1 to m do
  for j := 1 to n do
    for k := 1 to p do
      dout[i, j, k] := infinit;

cst := nil;
for i := 1 to m do
  for j := 1 to n do
    for k := 1 to p do
      if (a[i, j, k] = 0) and
         ((i = 1) or (i = m) or (j = 1) or (j = n) or (k = 1) or (k = p)) then
        begin
          dout[i, j, k] := 1;
          addtoq(i, j, k);
        end;

while (cst <> nil) do
  begin
    l := cst^.l;
    c := cst^.c;
    ni := cst^.ni;

    for k := 1 to 6 do
      begin
        lnext := l + dl[k];
        cnext := c + dc[k];
        nnext := ni + dn[k];

        if (nnext >= 1) and (nnext <= m) and
           (lnext >= 1) and (lnext <= n) and
           (cnext >= 1) and (cnext <= p) and
           (a[nnext, lnext, cnext] = 0) and
           (dout[nnext, lnext, cnext] = infinit) then
          begin
            dout[nnext, lnext, cnext] := dout[ni, l, c] + 1;

            new(aux);
            aux^.ni := nnext;
            aux^.l := lnext;
            aux^.c := cnext;
            aux^.urm := nil;

            cfin^.urm := aux;
            cfin := aux;
          end;
      end;

    aux := cst;
    cst := cst^.urm;
    dispose(aux);
  end;
end;

procedure computed;
var l, c, ni, i, j, k, lnext, cnext, nnext : integer;
begin
for i := 1 to m do
  for j := 1 to n do
    for k := 1 to p do
      d[i, j, k] := infinit;

d[nj, lj, cj] := 0;
new(cst);
cst^.ni := nj;
cst^.l := lj;
cst^.c := cj;
cst^.urm := nil;
cfin := cst;

while (cst <> nil) do
  begin
    l := cst^.l;
    c := cst^.c;
    ni := cst^.ni;

    for k := 1 to 6 do
      begin
        lnext := l + dl[k];
        cnext := c + dc[k];
        nnext := ni + dn[k];

        if (nnext >= 1) and (nnext <= m) and
           (lnext >= 1) and (lnext <= n) and
           (cnext >= 1) and (cnext <= p) and
           (a[nnext, lnext, cnext] = 0) and
           (d[nnext, lnext, cnext] = infinit) then
          begin
            d[nnext, lnext, cnext] := d[ni, l, c] + 1;

            new(aux);
            aux^.ni := nnext;
            aux^.l := lnext;
            aux^.c := cnext;
            aux^.urm := nil;

            cfin^.urm := aux;
            cfin := aux;
          end;
      end;

    aux := cst;
    cst := cst^.urm;
    dispose(aux);
  end;
end;

begin
assign(input, filein);
reset(input);
read(m, n, p);
read(t, w);
read(nb, lb, cb);
read(nj, lj, cj);

for i := 1 to m do
  for j := 1 to n do
    for k := 1 to p do
      begin
        repeat
          read(ch);
        until (ch = '1') or (ch = '0');

        a[i,j,k] := ord(ch) - ord('0');
      end;

close(input);

computed;
computedout;

assign(output, fileout);
rewrite(output);

if (d[nb, lb, cb] + w <= t) then
  writeln('1 ', d[nb, lb, cb])
else
  writeln('0 ', dout[nj, lj, cj]);

close(output);
end.