{$A+,B-,D+,E+,F-,G-,I-,L+,N+,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
{$M 16384,0,655360}

Program _RIVALS_;

const filein='RIVALS.IN';
      fileout='RIVALS.OUT';
      MAXW = 510;
      MARE = 100000;

type plist=^list;
     list=record
            o,c:integer;
            urm:plist;
          end;

var niv : array[1..MAXW] of integer;
    edge:array[1..MAXW] of plist;
    tata:array[1..MAXW] of integer;
    cact:array[1..MAXW] of longint;
    sel:array[1..MAXW] of boolean;
    i,j,k,m,n,p,w,minv,total,mindif, ti, tj, max:longint;
    fin,fout:text;
    aux:plist;

begin
assign(fin,filein);
reset(fin);
readln(fin,w,p);

fillchar(edge,sizeof(edge),0);
for k:=1 to p do
  begin
    read(fin,i,j,m);

    new(aux);
    aux^.o:=j;
    aux^.c:=m;
    aux^.urm:=edge[i];
    edge[i]:=aux;

    new(aux);
    aux^.o:=i;
    aux^.c:=m;
    aux^.urm:=edge[j];
    edge[j]:=aux;
  end;
close(fin);

cact[1]:=0;
for i:=2 to w do
  begin
    cact[i]:=MARE;
    tata[i]:=0;
  end;

fillchar(sel,sizeof(sel),false);
sel[1] := true;
niv[1] := 1;

m:=1; p:=1; total:=0;
while (m<w) do
  begin
    aux:=edge[p];
    while (aux<>nil) do
      begin
        i:=aux^.o;
        j:=aux^.c;

        if ((cact[i]>j) and (not sel[i])) then
          begin
            cact[i]:=j;
            tata[i]:=p;
            niv[i] := niv[p] + 1;
          end;

        aux:=aux^.urm;
      end;

    minv:=MARE;
    for i:=1 to w do
      if (not sel[i]) and (cact[i]<minv) then
        begin
          minv:=cact[i];
          p:=i;
        end;

    sel[p]:=true;
    total:=total+minv;
    m:=m+1;
  end;

mindif:=MARE;
for i:=1 to w do
  begin
    aux:=edge[i];
    while (aux<>nil) do
      begin
        j:=aux^.o;

        if (j<>tata[i]) and (i<>tata[j]) then
          begin
            max := 0;
            ti := i;
            tj := j;

            while (ti <> tj) do
              begin
                if (niv[ti] >= niv[tj]) then
                  begin
                    if (cact[ti] > max) then
                      max := cact[ti];
                    ti := tata[ti];
                  end
                else
                  begin
                    if (cact[tj] > max) then
                      max := cact[tj];
                    tj := tata[tj];
                  end;
              end;

            m := aux^.c - max;
            if (m < mindif) then
              mindif := m;
          end;

        aux:=aux^.urm;
      end;
  end;

assign(fout,fileout);
rewrite(fout);
writeln(fout,mindif);
close(fout);
end.
