/*
   Time Complexity: O(N * logR)
*/

#include <stdio.h>
#include <math.h>
#include <string.h>
#include <dos.h>
#define filein "CIRCLE.IN"
#define fileout "CIRCLE.OUT"
#define maxn 100010
#define eps 1e-9
#define feps 1e-6

long int huge d[maxn];
long int i, j, K, N, nin, ninf, xx, yy;
double li, ls, R, R2;

long int *t2, t1;

int main()
{
t2 = MK_FP(0, 0x46c);
t1 = *t2;

freopen(filein, "r", stdin);
scanf("%ld %ld", &N, &K);
for (i = 1; i <= N; i++)
  {
    scanf("%ld %ld", &xx, &yy);
    d[i] = xx*xx + yy*yy;
  }

li = 0; ls = 15000.0;
while (fabs(ls-li) > eps)
  {
    R = 0.5 * (li + ls);
    R2 = R*R;

    nin = ninf = 0;
    for (i = 1; i <= N; i++)
      {
        xx = d[i];
        if (fabs(R2 - xx) < feps)
          ninf++;
        else
        if (xx < R2)
          nin++, ninf++;
      }

    if (nin > K)
      ls = R;
    else
    if (ninf < K)
      li = R;
    else
      break;
  }

printf("%ld\n", *t2-t1);

freopen(fileout, "w", stdout);
printf("0.00000000 0.00000000 %.8lf\n", R);

return 0;
}