{$A+,B-,D+,E+,F-,G-,I-,L+,N+,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
{$M 16384,0,655360}

{ Time Complexity: O(N*sqrt(N)) }

Program _ORDER_;

const filein = 'ORDER.IN';
      fileout = 'ORDER.OUT';
      MAXN = 30000;
      MAXGR = 200;

var marc : array [0..MAXN] of boolean;
    group : array [0..MAXN] of byte;
    howmany, st, fin:array[0..MAXGR] of integer;
    i, n, poz, skip, counter, left, srt, ngr:longint;
    ch:char;

procedure walktofinish;
begin
i:=poz;
while (counter>0) and (group[i]=group[poz]) do
  begin
    if (not marc[i]) then
      dec(counter);

    inc(i);
    if (i>n) then i:=1;
  end;
poz:=i;

if (counter>0) then
  begin
    i:=group[poz];
    while (poz>1) do
      begin
        if (counter>howmany[i]) then
          counter:=counter-howmany[i]
        else
          break;

        inc(i);
        if (i=ngr+1) then
          poz:=1
        else
          poz:=st[i];
      end;

    if (poz>1) then
      begin
        while (counter>0) do
          begin
            if (not marc[poz]) then
              dec(counter);

            inc(poz);
            if (poz>n) then poz:=1;
          end;
      end;
  end;
end;

procedure findnext;
begin
i := poz;
while (group[i] = group[poz]) and (marc[i]) do
  begin
    inc(i);
    if (i > n) then
      i := 1;
  end;

if (not marc[i]) then
  poz := i
else
  begin
    i := group[i];
    while (howmany[i] = 0) do
      begin
        inc(i);
        if (i > ngr) then
          i := 1;
      end;

    i := st[i];
    while (marc[i]) do
      inc(i);

    poz := i;
  end;
end;

begin
assign(input, filein);
reset(input);
read(n);
close(input);


fillchar(marc, sizeof(marc), false);
skip := 0; poz := 2;
left := n;

{ Make groups }
srt := trunc(sqrt(n)); srt:=n div srt;
ngr := 0;

fillchar(howmany,sizeof(howmany),0);

for i:=1 to n do
  if (i mod srt=1) then
    begin
      inc(ngr);
      st[ngr] := i;
      group[i] := ngr;
      fin[ngr-1] := i-1;
      howmany[ngr] := 1;
    end
  else
    begin
      group[i] := ngr;
      inc(howmany[ngr]);
    end;
fin[ngr] := n;

assign(output, fileout);
rewrite(output);

{ Cut positions }
while (left >= 1) do
  begin
    counter:=skip;

    walktofinish;

    if (counter>0) then
      begin
        counter:=counter mod left;
        walktofinish;
      end;

    findnext;

    marc[poz] := true;
    dec(howmany[group[poz]]);

    if (skip = 0) then
      write(poz)
    else
      write(' ', poz);

    dec(left);

    inc(skip);
  end;

writeln;
close(output);
end.