{$S-,I-,R-,Q-,N+}
{$M 30000,0,655360}

{
  Time Complexity : O(N^2)
}

Program _BMATRIX_;

const filein = 'BMATRIX.IN';
      fileout = 'BMATRIX.OUT';
      MAXN = 210;

var a : array [1..MAXN, 1..MAXN] of byte;
    up, uplast, stk, col:array[0..MAXN] of longint;
    maxup, maxdown, maxleft, maxright : array [0..MAXN] of longint;
    i, j, k, m, n, amax, aact, a1, a2 :longint;
    vv, rez:byte;
    ch : char;

procedure maxareaup;
var i, j, k, amax, nco, nst, p : longint;
begin
amax := 0;
nco := 0;
nst := 0;

{ proceseaza linia 1 }
for j := 1 to n do
  begin
    uplast[j] := 1 - a[1, j];

    if (uplast[j] = 0) then
      nco:=0
    else
      nco:=nco+1;

   if (nco > amax) then
     amax := nco;
  end;
maxup[1] := amax;

{ proceseaza liniile 2,..,m }
for i := 2 to m do
  begin
    nst := 0;

    for j := 1 to n do
      begin
        vv := a[i,j];

        case vv of
        1:begin
            { Empty the stack }
            while (nst>0) do
              begin
                nco:= (stk[nst]) * (j-col[nst]);
                if (nco > amax) then
                  begin
                    amax:=nco;
                  end;

                dec(nst);
              end;

            up[j]:=0;
          end;
        0:begin
            up[j] := uplast[j] + 1;

            if (up[j] > amax) then
              amax := up[j];

            k := j;

            { Empty the stack as long as its top is higher
              than the present value }

            while (nst > 0) and (stk[nst] >= up[j]) do
              begin
                k := col[nst];

                nco := (up[j])*(j-col[nst] + 1);
                if (nco > amax) then
                  begin
                    amax:=nco;
                  end;

                nco := (j-col[nst])*(stk[nst]);
                if (nco>amax) then
                  begin
                    amax:=nco;
                  end;
                dec(nst);
              end;

            { Insert value into stack }
            inc(nst);
            stk[nst]:=up[j];
            col[nst]:=k;
          end;
        end;
      end;

    { Empty the stack }
    while (nst > 0) do
      begin
        nco := (stk[nst])*(n-col[nst]+1);
        if (nco > amax) then
          begin
            amax := nco;
          end;

        dec(nst);
      end;

    move(up,uplast,sizeof(up));

    maxup[i] := amax;
  end;
end;

procedure maxareadown;
var i, j, k, amax, nco, nst, p : longint;
begin
amax := 0;
nco := 0;
nst := 0;

{ proceseaza linia m }
for j := 1 to n do
  begin
    uplast[j] := 1 - a[m, j];

    if (uplast[j] = 0) then
      nco:=0
    else
      nco:=nco+1;

   if (nco > amax) then
     amax := nco;
  end;
maxdown[m] := amax;

{ proceseaza liniile m-1,..,1 }
for i := m-1 downto 1 do
  begin
    nst := 0;

    for j := 1 to n do
      begin
        vv := a[i,j];

        case vv of
        1:begin
            { Empty the stack }
            while (nst>0) do
              begin
                nco:= (stk[nst]) * (j-col[nst]);
                if (nco > amax) then
                  begin
                    amax:=nco;
                  end;

                dec(nst);
              end;

            up[j]:=0;
          end;
        0:begin
            up[j] := uplast[j] + 1;

            if (up[j] > amax) then
              amax := up[j];

            k := j;

            { Empty the stack as long as its top is higher
              than the present value }

            while (nst > 0) and (stk[nst] >= up[j]) do
              begin
                k := col[nst];

                nco := (up[j])*(j-col[nst] + 1);
                if (nco > amax) then
                  begin
                    amax:=nco;
                  end;

                nco := (j-col[nst])*(stk[nst]);
                if (nco>amax) then
                  begin
                    amax:=nco;
                  end;
                dec(nst);
              end;

            { Insert value into stack }
            inc(nst);
            stk[nst]:=up[j];
            col[nst]:=k;
          end;
        end;
      end;

    { Empty the stack }
    while (nst > 0) do
      begin
        nco := (stk[nst])*(n-col[nst]+1);
        if (nco > amax) then
          begin
            amax := nco;
          end;

        dec(nst);
      end;

    move(up,uplast,sizeof(up));

    maxdown[i] := amax;
  end;
end;

procedure maxarealeft;
var i, j, k, amax, nco, nst, p : longint;
begin
amax := 0;
nco := 0;
nst := 0;

{ proceseaza coloana 1 }
for j := 1 to m do
  begin
    uplast[j] := 1 - a[j, 1];

    if (uplast[j] = 0) then
      nco:=0
    else
      nco:=nco+1;

   if (nco > amax) then
     amax := nco;
  end;
maxleft[1] := amax;

{ proceseaza coloanele 2,..,n }
for i := 2 to n do
  begin
    nst := 0;

    for j := 1 to m do
      begin
        vv := a[j, i];

        case vv of
        1:begin
            { Empty the stack }
            while (nst>0) do
              begin
                nco:= (stk[nst]) * (j-col[nst]);
                if (nco > amax) then
                  begin
                    amax:=nco;
                  end;

                dec(nst);
              end;

            up[j]:=0;
          end;
        0:begin
            up[j] := uplast[j] + 1;

            if (up[j] > amax) then
              amax := up[j];

            k := j;

            { Empty the stack as long as its top is higher
              than the present value }

            while (nst > 0) and (stk[nst] >= up[j]) do
              begin
                k := col[nst];

                nco := (up[j])*(j-col[nst] + 1);
                if (nco > amax) then
                  begin
                    amax:=nco;
                  end;

                nco := (j-col[nst])*(stk[nst]);
                if (nco>amax) then
                  begin
                    amax:=nco;
                  end;
                dec(nst);
              end;

            { Insert value into stack }
            inc(nst);
            stk[nst]:=up[j];
            col[nst]:=k;
          end;
        end;
      end;

    { Empty the stack }
    while (nst > 0) do
      begin
        nco := (stk[nst])*(m-col[nst]+1);
        if (nco > amax) then
          begin
            amax := nco;
          end;

        dec(nst);
      end;

    move(up,uplast,sizeof(up));

    maxleft[i] := amax;
  end;
end;

procedure maxarearight;
var i, j, k, amax, nco, nst, p : longint;
begin
amax := 0;
nco := 0;
nst := 0;

{ proceseaza coloana n }
for j := 1 to m do
  begin
    uplast[j] := 1 - a[j, n];

    if (uplast[j] = 0) then
      nco:=0
    else
      nco:=nco+1;

   if (nco > amax) then
     amax := nco;
  end;
maxright[n] := amax;

{ proceseaza coloanele n-1,..,1 }
for i := n-1 downto 1 do
  begin
    nst := 0;

    for j := 1 to m do
      begin
        vv := a[j, i];

        case vv of
        1:begin
            { Empty the stack }
            while (nst>0) do
              begin
                nco:= (stk[nst]) * (j-col[nst]);
                if (nco > amax) then
                  begin
                    amax:=nco;
                  end;

                dec(nst);
              end;

            up[j]:=0;
          end;
        0:begin
            up[j] := uplast[j] + 1;

            if (up[j] > amax) then
              amax := up[j];

            k := j;

            { Empty the stack as long as its top is higher
              than the present value }

            while (nst > 0) and (stk[nst] >= up[j]) do
              begin
                k := col[nst];

                nco := (up[j])*(j-col[nst] + 1);
                if (nco > amax) then
                  begin
                    amax:=nco;
                  end;

                nco := (j-col[nst])*(stk[nst]);
                if (nco>amax) then
                  begin
                    amax:=nco;
                  end;
                dec(nst);
              end;

            { Insert value into stack }
            inc(nst);
            stk[nst]:=up[j];
            col[nst]:=k;
          end;
        end;
      end;

    { Empty the stack }
    while (nst > 0) do
      begin
        nco := (stk[nst])*(m-col[nst]+1);
        if (nco > amax) then
          begin
            amax := nco;
          end;

        dec(nst);
      end;

    move(up,uplast,sizeof(up));

    maxright[i] := amax;
  end;
end;

begin
assign(input, filein);
reset(input);
read(m, n);

for i := 1 to m do
  for j := 1 to n do
    begin
      repeat
        read(ch);
      until (ch = '0') or (ch = '1');

      if (ch = '0') then
        a[i,j] := 0
      else
        a[i,j] := 1;
    end;

close(input);

maxup[0] := 0;
maxleft[0] := 0;

maxareaup;
maxareadown;
maxarealeft;
maxarearight;

amax := 0;
for i := 0 to m-1 do
  if (maxup[i] + maxdown[i+1] > amax) then
    amax := maxup[i] + maxdown[i+1];

for j := 0 to n-1 do
  if (maxleft[j] + maxright[j+1] > amax) then
    amax := maxleft[j] + maxright[j+1];

assign(output, fileout);
rewrite(output);
writeln(amax);
close(output);
end.