{$A+,B-,D+,E+,F-,G-,I+,L+,N+,O-,P-,Q-,R-,S+,T-,V+,X+,Y+}
{$M 65000,0,655360}

Program _ALINIERE_;

const filein = 'INPUT.TXT';
      fileout = 'OUTPUT.TXT';
      NMAX = 1100;
      eps = 1e-6;

var h : array [0..NMAX] of extended;
    maxleft, maxright, prevleft, prevright : array [1.. NMAX] of integer;
    insol : array [0..NMAX] of boolean;
    i, j, si, sj, m, n : integer;

procedure pleft(x : integer);
begin
insol[x] := true;

if (prevleft[x] > 0) then
  pleft(prevleft[x]);
end;

procedure pright(x : integer);
begin
insol[x] := true;

if (prevright[x] > 0) then
  pright(prevright[x]);
end;

begin
assign(input, filein);
reset(input);
read(n);

for i := 1 to n do
  read(h[i]);

close(input);

{ left }
for i := 1 to n do
  begin
    prevleft[i] := 0;
    maxleft[i] := 0;

    for j := i - 1 downto 1 do
      if (h[j] < h[i]) and (abs(h[i] - h[j]) > eps) and (maxleft[j] > maxleft[i]) then
        begin
          maxleft[i] := maxleft[j];
          prevleft[i] := j;
        end;

    inc(maxleft[i]);
  end;

{ right }
for i := n downto 1 do
  begin
    prevright[i] := 0;
    maxright[i] := 0;

    for j := i + 1 to n do
      if (h[j] < h[i]) and (abs(h[i] - h[j]) > eps) and (maxright[j] > maxright[i]) then
        begin
          maxright[i] := maxright[j];
          prevright[i] := j;
        end;

    inc(maxright[i]);
  end;

m := 0;
for i := 1 to n - 1 do
  for j := i + 1 to n do
    if (maxleft[i] + maxright[j] > m) then
      begin
        m := maxleft[i] + maxright[j];
        si := i;
        sj := j;
      end;

fillchar(insol, sizeof(insol), false);

pleft(si);
pright(sj);

assign(output, fileout);
rewrite(output);

writeln(n - m);
for i := 1 to n do
  if (not insol[i]) then
    writeln(i);

close(output);
end.