{ de la IOI-ul meu !!! :) }

Program MOBILES;

const MAXS=222;
      SQRTS=20;
      BUFLEN = 64000;

type linie = array [-1..MAXS] of longint;
     plinie = ^linie;
     buffer = array[1..BUFLEN] of char;
     pbuffer = ^buffer;

var colxlin:array[-1..MAXS] of plinie;
    grcolxlin:array[-1..SQRTS,-1..MAXS] of longint;
    colxgrlin:array[-1..MAXS,-1..SQRTS] of longint;
    grcolxgrlin:array[-1..SQRTS,-1..SQRTS] of longint;
    group:array[-1..MAXS] of integer;
    startgrp:array[-1..SQRTS] of integer;
    i,j,ll,cc,lf,cf,s,sqrt_s,ngr,gract,tip:integer;
    a,dmare,dsus,dst,dmic, NI:longint;
    bufin, bufout : pbuffer;

begin
new(bufin);
new(bufout);

assign(input, 'INPUT.TXT');
settextbuf(input, bufin^, BUFLEN);
reset(input);

assign(output, 'OUTPUT.TXT');
settextbuf(output, bufout^, BUFLEN);
rewrite(output);

read(i, j);
if (i > j) then
   s := i + 2
else
    s := j + 2;

{ Intialize the tables with 0 }
for i := -1 to MAXS do
  begin
    new(colxlin[i]);
    fillchar(colxlin[i]^, sizeof(colxlin[i]^),0);
  end;

fillchar(grcolxlin,sizeof(grcolxlin),0);
fillchar(colxgrlin,sizeof(colxgrlin),0);
fillchar(grcolxgrlin,sizeof(grcolxgrlin),0);
fillchar(group,sizeof(group),0);
fillchar(startgrp,sizeof(startgrp),0);

sqrt_s:=trunc(sqrt(s));
s:=s-1;
ngr:=-1;

{ Assign group identifiers to every line/column, so
  that each group has sqrt(S) elements }

for i:=0 to s do
  if (i mod sqrt_s=0) then
    begin
      inc(ngr);
      group[i]:=ngr;
      startgrp[ngr]:=i;
    end
  else
    group[i]:=ngr;

group[-1]:=-1;

{ Process the instructions }

read(NI);
while (NI > 0) do
  begin
    read(tip);

    case tip of
    1:begin
        { UPDATE }

        read(ll,cc,a);

        gract:=group[ll];

        i:=ll;
        j:=group[cc];

        while (group[i]=gract) and (i<=s) do
          begin
            colxlin[cc]^[i]:=colxlin[cc]^[i]+a;
            grcolxlin[j,i]:=grcolxlin[j,i]+a;

            inc(i);
          end;

        i:=gract+1;
        while (i<=ngr) do
          begin
            colxgrlin[cc,i]:=colxgrlin[cc,i]+a;
            grcolxgrlin[j,i]:=grcolxgrlin[j,i]+a;

            inc(i);
          end;
      end;
    2:begin
       { QUERY }

        read(ll,cc,lf,cf);
        dec(ll);

        dmare:=0; dmic:=0; dsus:=0; dst:=0;

        { Compute DMIC and DST (and part of DMARE and DSUS) }

        gract:=group[cc];

        for j:=0 to gract-1 do
          begin
            dmare:=dmare+grcolxlin[j,lf]+grcolxgrlin[j,group[lf]];
            dmic:=dmic+grcolxlin[j,ll]+grcolxgrlin[j,group[ll]];
            dst:=dst+grcolxlin[j,lf]+grcolxgrlin[j,group[lf]];
            dsus:=dsus+grcolxlin[j,ll]+grcolxgrlin[j,group[ll]];
          end;

        for j:=startgrp[gract] to cc-1 do
          begin
            dmic:=dmic+colxlin[j]^[ll]+colxgrlin[j,group[ll]];
            dst:=dst+colxlin[j]^[lf]+colxgrlin[j,group[lf]];
          end;

        { Compute DMARE and DSUS }

        gract:=group[cf];

        for j:=group[cc] to gract-1 do
          begin
            dmare:=dmare+grcolxlin[j,lf]+grcolxgrlin[j,group[lf]];
            dsus:=dsus+grcolxlin[j,ll]+grcolxgrlin[j,group[ll]];
          end;

        for j:=startgrp[gract] to cf do
          begin
            dmare:=dmare+colxlin[j]^[lf]+colxgrlin[j,group[lf]];
            dsus:=dsus+colxlin[j]^[ll]+colxgrlin[j,group[ll]];
          end;

        { Print the number of Mobile Phones }

        writeln(dmare-dsus-dst+dmic);
      end;
    end;

    dec(NI);
  end;

close(input);
close(output);
end.