#include <stdio.h>
#include <string.h>

#define NMAX 111

int A[NMAX][NMAX], viz[NMAX], t[NMAX], p[NMAX];
int i, j, k, N, M, nc;

void df(int n)
{
  int i;

  for (i = 1; i <= N; i++)
      if (!viz[i] && A[n][i])
      {
        t[i] = n;
        A[i][n] = A[n][i] = 0;
        viz[i]= viz[n] + 1;
        df(i);
      }
}

void print(int a, int b)
{
  int ti, tj, i, c;

  ti = a;
  tj = b;

  c = 1;

  while (ti != tj)
  {
    if (viz[ti] >= viz[tj])
       ti = t[ti];
    else
        tj = t[tj];

    c++;
  }

  ti = a;
  i = 0;
  while (ti != tj)
  {
    p[++i] = ti;
    ti = t[ti];
  }

  tj = b;
  i = c;
  while (tj != ti)
  {
    p[i--] = tj;
    tj = t[tj];
  }

  p[i] = tj;

  printf("%d", c);
  for (i = 1; i <= c; i++)
      printf(" %d", p[i]);

  printf("\n");
}

int main()
{
  freopen("INPUT.TXT", "r", stdin);
  freopen("OUTPUT.TXT", "w", stdout);

  scanf("%d %d", &N, &M);

  memset(A, 0, sizeof(A));
  for (k = 0; k < M; k++)
  {
    scanf("%d %d", &i, &j);
    A[i][j] = A[j][i] = 1;
  }

  memset(viz, 0, sizeof(viz));
  nc = 0;

  for (i = 1; i <= N; i++)
      if (!viz[i])
      {
        viz[i] = 1;
        df(i);
        nc++;
      }

  printf("%d\n", M - N + nc);

  for (i = 1; i < N; i++)
      for (j = i + 1; j <= N; j++)
          if (A[i][j])
             print(i, j);

  return 0;
}
