Program APM1_2;

const filein='INPUT.TXT';
      fileout='OUTPUT.TXT';
      MAXW=111;
      MARE=100000;

type plist=^list;
     list=record
            o,c:integer;
            urm:plist;
          end;

var lcost, cost:array[1..MAXW,1..MAXW] of integer;
    edge:array[1..MAXW] of plist;
    tata, niv:array[1..MAXW] of integer;
    cact:array[1..MAXW] of longint;
    sel:array[1..MAXW] of boolean;
    i,j,k,m,n,p,w,minv,total,mindif:longint;
    fin,fout:text;
    aux:plist;

    e1 : array[1..MAXW, 1..MAXW] of boolean;
    p1, p2 : integer;

procedure remove1edge(a, b : integer);
var ti, tj : integer;
begin
  ti := a;
  tj := b;

  m := lcost[a, b];

  while (ti <> tj) do
    begin
      if (niv[ti] >= niv[tj]) then
        begin
          if (cost[ti, tata[ti]] = m) then
            begin
              e1[ti, tata[ti]] := false;
              e1[tata[ti], ti] := false;
              break;
            end;

            ti := tata[ti];
        end
      else
        begin
          if (cost[tj, tata[tj]] = m) then
            begin
              e1[tj, tata[tj]] := false;
              e1[tata[tj], tj] := false;
              break;
            end;

            tj := tata[tj];
        end;
    end;
end;

begin
assign(fin,filein);
reset(fin);
read(fin,w,p);

fillchar(edge,sizeof(edge),0);
for k:=1 to p do
  begin
    read(fin,i,j,m);

    cost[i, j] := m;
    cost[j, i] := m;

    new(aux);
    aux^.o:=j;
    aux^.c:=m;
    aux^.urm:=edge[i];
    edge[i]:=aux;

    new(aux);
    aux^.o:=i;
    aux^.c:=m;
    aux^.urm:=edge[j];
    edge[j]:=aux;
  end;
close(fin);

cact[1]:=0;
for i:=2 to w do
  begin
    cact[i]:=MARE;
    tata[i]:=0;
  end;

fillchar(sel,sizeof(sel),false);
fillchar(e1, sizeof(e1), false);

sel[1]:=true;
niv[1] := 1;

m:=1; p:=1; total:=0;
while (m<w) do
  begin
    aux:=edge[p];
    while (aux<>nil) do
      begin
        i:=aux^.o;
        j:=aux^.c;

        if ((cact[i]>j) and (not sel[i])) then
          begin
            cact[i]:=j;
            tata[i]:=p;
            niv[i] := niv[p] + 1;
          end;

        aux:=aux^.urm;
      end;

    p1 := p;

    minv:=MARE;
    for i:=1 to w do
      if (not sel[i]) and (cact[i]<minv) then
        begin
          minv:=cact[i];
          p:=i;
        end;

    sel[p]:=true;
    total:=total+minv;
    m:=m+1;

    e1[p, tata[p]] := true;

    lcost[p,tata[p]]:=minv;
    lcost[tata[p],p]:=minv;
    for i:=1 to w do
      if (sel[i]) and (i<>p) and (i<>tata[p]) then
        begin
          if (minv>lcost[tata[p],i]) then
            lcost[p,i]:=minv
          else
            lcost[p,i]:=lcost[tata[p],i];

          lcost[i,p]:=lcost[p,i];
        end;
  end;


assign(fout,fileout);
rewrite(fout);

writeln(fout, w - 1);
for i := 1 to w do
  for j := 1 to w do
    if (e1[i, j]) then
      writeln(fout, i, ' ', j);

mindif:=MARE;
for i:=1 to w do
  begin
    aux:=edge[i];
    while (aux<>nil) do
      begin
        j:=aux^.o;

        if (j<>tata[i]) and (i<>tata[j]) then
          begin
            m:=aux^.c-lcost[i,j];

            if (m<mindif) then
              begin
                mindif:=m;
                p1 := i;
                p2 := j;
              end;
          end;

        aux:=aux^.urm;
      end;
  end;


writeln(fout, w - 1);

e1[p1, p2] := true;

remove1edge(p1, p2);

for i := 1 to w do
  for j := 1 to w do
    if (e1[i, j]) then
       writeln(fout, i, ' ', j);

close(fout);
end.
