{$A+,B-,D+,E+,F-,G-,I-,L+,N-,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
{$M 16384,0,655360}

Program _KEOPS_;

const filein = 'INPUT.TXT';
      fileout = 'OUTPUT.TXT';
      MAXN = 260;
      infinit = 65000;
      dl : array [1..4] of integer = (-1, 0, +1, 0);
      dc : array [1..4] of integer = (0, +1, 0, -1);

type bytelinie = array [1..MAXN] of byte;
     pbytelinie = ^bytelinie;
     wordlinie = array [1..MAXN] of word;
     pwordlinie = ^wordlinie;
     pq = ^q;
     q = record
           l, c : integer;
           urm : pq;
         end;

     solarray = array [1..65000] of char;

var a : array [1..MAXN] of pbytelinie;
    d : array [1..2, 1..MAXN] of pwordlinie;
    i, j, k, m, n, l1, c1, l2, c2 : integer;
    min : word;
    ch : char;
    sol : ^solarray;

procedure computedist(ls, cs, t : integer);
var l, c, i, j, k, lnext, cnext : integer;
    cst, cfin, aux : pq;
begin
for i := 1 to m do
  for j := 1 to n do
    d[t,i]^[j] := infinit;

d[t,ls]^[cs] := 0;

new(cst);
cst^.l := ls;
cst^.c := cs;
cst^.urm := nil;
cfin := cst;


while (cst <> nil) do
  begin
    l := cst^.l;
    c := cst^.c;

    for k := 1 to 4 do
      begin
        lnext := l + dl[k];
        cnext := c + dc[k];

        if (lnext >=1 ) and (lnext <= m) and (cnext >= 1) and (cnext <= n) and
          (d[t,lnext]^[cnext] = infinit) and (a[lnext]^[cnext] = 0) then
          begin
            d[t,lnext]^[cnext] := d[t,l]^[c] + 1;

            new(aux);
            aux^.l := lnext;
            aux^.c := cnext;
            aux^.urm := nil;

            cfin^.urm := aux;
            cfin := aux;
          end;
      end;

    aux := cst;
    cst := cst^.urm;
    dispose(aux);
  end;
end;

procedure printsol;
var lne, cne, k, ls, cs : integer;
begin
new(sol);

ls := l2;
cs := c2;

while (ls <> l1) or (cs <> c1) do
  begin
    for k := 1 to 4 do
      begin
        lne := ls + dl[k];
        cne := cs + dc[k];

        if (lne >= 1) and (lne <= m) and (cne >= 1) and (cne <= n) then
           begin
                if (d[1, lne]^[cne] = d[1, ls]^[cs] - 1) then
                   begin
                        if (k = 1) then
                           sol^[d[1, ls]^[cs]] := 'S'
                        else
                        if (k = 2) then
                           sol^[d[1, ls]^[cs]] := 'V'
                        else
                        if (k = 3) then
                           sol^[d[1, ls]^[cs]] := 'N'
                        else
                        if (k = 4) then
                           sol^[d[1, ls]^[cs]] := 'E';

                        ls := lne;
                        cs := cne;
                        break;
                   end;
           end;
      end;
  end;

for k := 1 to d[1, l2]^[c2] do
    write(sol^[k]);
writeln;
end;

begin
assign(input, filein);
reset(input);
read(m, n);

for i := 1 to m do
  begin
    new(a[i]);
    new(d[1,i]);
  end;

for i := 1 to m do
  for j := 1 to n do
    begin
      repeat
        read(ch);
      until (ch = 'L') or (ch = 'O');

      if (ch = 'L') then
         a[i]^[j] := 0
      else
          a[i]^[j] := 1;
    end;

read(l1, c1);

close(input);

computedist(l1, c1, 1);

min := infinit;
for i := 1 to m do
  begin
       if (d[1, i]^[1] < min) then
         begin
              min := d[1, i]^[1];
              l2 := i;
              c2 := 1;
         end;

       if (d[1, i]^[n] < min) then
         begin
              min := d[1, i]^[n];
              l2 := i;
              c2 := n;
         end;
  end;

for j := 1 to n do
  begin
       if (d[1, 1]^[j] < min) then
         begin
              min := d[1, 1]^[j];
              l2 := 1;
              c2 := j;
         end;

       if (d[1, m]^[j] < min) then
         begin
              min := d[1, m]^[j];
              l2 := m;
              c2 := j;
         end;
  end;

assign(output, fileout);
rewrite(output);

writeln(min);

printsol;

close(output);
end.