/* Time Complexity : O(lungimea_textului * numarul_de_cuvinte) */

#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#define NMAX 260
#define LMAX 30010
#define LLMAX 300

char *cuv[NMAX], s[LLMAX];
unsigned char *pre[NMAX];
unsigned char len[NMAX], poz[NMAX];

unsigned char txt[LMAX];
unsigned char lcuv[LMAX];
int *nmin;
int i, j, k, c, M, N, L;

int main()
{
  freopen("INPUT.TXT", "r", stdin);

  scanf("%s %d", txt + 1, &N);
  L = strlen(txt + 1);

  for (i = 1; i <= N; i++)
  {
      scanf("%s", s);
      len[i] = strlen(s);

      cuv[i] = (char*) malloc(sizeof(char) * (len[i] + 5));
      pre[i] = (unsigned char*) malloc(sizeof(unsigned char) * (len[i] + 3));

      if (cuv[i] == NULL || pre[i] == NULL)
      {
          printf("malloc error\n");
      }
      else
      {
          strcpy(cuv[i] + 1, s);

          /* calculeaza functia prefix a cuvantului i */
          pre[i][0] = pre[i][1] = k = 0;
          for (j = 2; j <= len[i]; j++)
          {
              while (k > 0 && cuv[i][j] != cuv[i][k + 1])
                    k = pre[i][k];

              if (cuv[i][j] == cuv[i][k + 1])
                 k++;

              pre[i][j] = k;
          }
      }
  }

  nmin = (int*) malloc(sizeof(int) * (L + 3));
  if (nmin == NULL)
  {
    printf("malloc error\n");
  }

  for (i = 1; i <= N; i++)
      poz[i] = 0;

  nmin[0] = 1;
  for (k = 1; k <= L; k++)
  {
    nmin[k] = 0;

    for (i = 1; i <= N; i++)
    {
        while (poz[i] > 0 && cuv[i][poz[i] + 1] != txt[k])
              poz[i] = pre[i][poz[i]];

        if (cuv[i][poz[i] + 1] == txt[k])
           poz[i]++;

        if (poz[i] == len[i])
        {
          if (nmin[k - len[i]])
          {
                c = nmin[k - len[i]] + 1;
                if (!nmin[k] || c < nmin[k])
                   nmin[k] = c, lcuv[k] = i;
          }

          poz[i] = pre[i][poz[i]];
        }
    }
  }

  M = 0;
  while (L > 0)
  {
      txt[M++] = lcuv[L];
      L -= len[lcuv[L]];
  }

  freopen("OUTPUT.TXT", "w", stdout);

  printf("%d\n", M);
  while (M--)
    printf("%s\n", cuv[txt[M]] + 1);

  return 0;
}