#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#define NMAX 2222

#define INF 666666666

int *v[NMAX], nv[NMAX], sel[NMAX];
long *d[NMAX], D[NMAX];
int i, j, k, N, M;
long c;

int main()
{
  FILE *fin = fopen("INPUT.TXT", "r");

  /* citeste fisierul prima data */
  fscanf(fin, "%d %d", &N, &M);

  memset(nv, 0, sizeof(nv));
  for (k = 0; k < M; k++)
  {
    fscanf(fin, "%d %d %ld", &i, &j, &c);

    nv[i]++;
    nv[j]++;
  }

  fclose(fin);

  for (i = 1; i <= N; i++)
  {
    v[i] = (int *) malloc(sizeof(int) * (nv[i] + 3));
    d[i] = (long *) malloc(sizeof(long) * (nv[i] + 3));
  }

  fin = fopen("INPUT.TXT", "r");

  /* citeste fisierul a doua oara */
  fscanf(fin, "%d %d", &N, &M);

  memset(nv, 0, sizeof(nv));
  for (k = 0; k < M; k++)
  {
    fscanf(fin, "%d %d %ld", &i, &j, &c);

    v[i][nv[i]] = j;
    d[i][nv[i]++] = c;

    v[j][nv[j]] = i;
    d[j][nv[j]++] = c;
  }

  fclose(fin);

  /* Dijkstra */
  for (i = 1; i <= N; i++)
  {
    sel[i] = 0;
    D[i] = INF;
  }

  sel[1] = 1;
  D[k = 1] = 0;

  while (1)
  {
    for (i = 0; i < nv[k]; i++)
    {
      j = v[k][i];

      if (D[k] + d[k][i] < D[j])
         D[j] = D[k] + d[k][i];
    }

    k = 0;
    c = INF;

    for (i = 1; i <= N; i++)
        if (!sel[i] && D[i] < c)
        {
          c = D[i];
          k = i;
        }

    if (!k)
       break;

    sel[k] = 1;
  }

  freopen("OUTPUT.TXT", "w", stdout);

  for (i = 2; i <= N; i++)
      printf("%ld\n", D[i]);

  return 0;
}